/*
 * ccountsubs.c		17/1/84		Jim Piper
 *
 * subroutines to assist with interactively counting a cell file.
 * These differ marginally from the "kyy" versions, and are for
 * the stand-alone keyboard driven count demonstration program "ccount".
 *
 * Modifications
 *
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>
#include <interact.h>
#include <chromanal.h>
#include <kcontrol.h>

#define MAX(i,j)	(i>j? i: j)
#define MIN(i,j)	(i<j? i: j)
#define WIDTH		8

extern int numchroms;

/*
 * read objects, insert in control structure,
 * compute cell column and line centre and extent,
 * set suitable scales in frame.
 */
allread(kcont)
struct kcontrol *kcont;
{
	struct chromosome *obj, *readobj();
	struct object *blobmark();
	struct chromplist *makechromplist();
	int scale,objnum,cellkol1,cellline1,celllastkl,celllastln,celldiam;
	struct pframe *f;
	
	f = kcont->f;
	while((obj = readobj(stdin)) != NULL) {
		if (obj->type == 1) {
			if (obj->plist == NULL) {
				obj->plist = makechromplist();
				obj->plist->number = kcont->maxnumber+1;
			}
			/*
			 * if not already typed, make a chromosome
			 */
			if (obj->plist->otype == 0) {
				obj->plist->otype = 1;
				obj->plist->history[2] = 1;
			}
			kcont->ool[kcont->maxnumber] = obj;
			kcont->bol[kcont->maxnumber] = blobmark(obj);
			kcont->acl[kcont->maxnumber++] = 1;
		}
	}
	numchroms = kcont->maxnumber;
	cellframe(kcont);
}
