/*
 * chromfeat.c		7/3/84		Jim Piper
 *
 * compute features of chromosome objects
 *
 * Modifications
 *	16 Nov 1987		SCG		If object has no property list generate one
 *	29 Jul 1987		CAS		Alloc debug calls names changed
 *	29 Jan 1987		CAS		Kcont->FIP symbolic
 *  15 Oct 1986		GJP		Added some debugging options
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>
#include <fileheaders.h>
#include <chromanal.h>
#define BASIC 1

extern double xscale,yscale;

main(argc,argv)
char **argv;
{
	struct object *obj, *readobj(), *robj, *chromfeatures();
	struct object *olist[100];
	struct chromplist *makechromplist();
	extern int _memmins;
	int i;
	int number = 0;
	int FIP = DIGTV;
	int debug = 0;
	
	setbuf(stderr,NULL);
	setmemalloc(16384);
	while (argc > 1 && argv[1][0] == '-') {
		switch (argv[1][1]) {
			case 'f':
				FIP = DIGFIP;
				yscale = 0.75;
				xscale = 1.0;
				break;
			case 'd':
				freeobj_debug(stderr);
				Alloc_debug(stderr);
				debug = 1;
				break;
		} 
		argv++;
		argc--;
	}

	while ((obj=readobj(stdin)) != NULL)
		olist[number++] = obj;
	starttimer();
	for (i=0; i<number; i++) {
		obj = olist[i];
		if (obj->type == 1) {
fprintf(stderr,"object %d ",i+1);
			/*
			 * Added the following two lines so that the pipe
			 * chromfeat <cellfile ! tellprops can work on a non-karyotyped
			 * cell
			 */
			if(obj->plist == NULL)
				obj->plist = (struct propertylist *) makechromplist();
			robj = chromfeatures(obj,BASIC);
			obj->plist = NULL;
			freeobj(obj);
			olist[i] = robj;
			if (debug)
				Show_alloc();
fprintf(stderr,"done\n");
		}
	}
	elapsedtime();
	if (debug) {
		fprintf(stderr,"Mem after meas before freeobjs\n");
		Show_alloc();
	}
	for (i=0; i<number; i++) {
		writeobj(stdout,olist[i]);
		freeobj(olist[i]);
	}
	if (debug) {
		fprintf(stderr,"Mem after freeobjs\n");
		Show_alloc();
	}
	exit(0);
}
