/*
 * drawfile.c		4/1/84		Jim Piper
 *
 * display all type 1 objects in a file at a suitable scale
 * or at specified scale.  Number unless contrary is specified.
 *
 ***************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	when		What
 * ---	----		----
 * JP	03-04-87	OS9 version to DDGS
 * JP	05-09-86	drawfile [-n] [-f] [-s scale] [infile]
 */

#include <stdio.h>
#include <wstruct.h>
#include <display.h>

main(argc,argv)
char **argv;
{
	int objnum,number,nonum;
	int scale,cellw,celll;
	int cellkol1,cellline1,celllastkl,celllastln;
	long daytime;
	struct object *objlist[200], *obj, *readobj();
	char s[512], *cell, *timestring;
	FILE *infile;
	struct pframe f;
	int FIP=0;

	setmemalloc(16384);
	scale = -1;
	nonum = 0;
	while (argc > 1 && argv[1][0] == '-') {
		switch (argv[1][1]) {
		case 'n':
			nonum++;
			break;
		case 'f':
			FIP++;
			break;
		case 's':
			scale = atoi(argv[2]);
			if (scale <= 0 || scale > 1024) {
				fprintf(stderr,"ridiculous scale\n");
				exit(1);
			}
			f.scale = scale;
			argc--;
			argv++;
			break;
		}
		argc--;
		argv++;
	}
	if (argc > 1) {
		cell = argv[1];
		infile = fopen(cell,"r");
		if (infile == NULL) {
			fprintf(stderr,"Can't open %s\n",cell);
			exit(1);
		}
	} else {
		cell = "<stdin";
		infile = stdin;
	}
	number = 0;
	while((obj = readobj(infile)) != NULL) {
		if (obj->type == 1) {
			objlist[number++] = obj;
			if (number == 1) {
				cellline1 = obj->idom->line1;
				cellkol1 = obj->idom->kol1;
				celllastln = obj->idom->lastln;
				celllastkl = obj->idom->lastkl;
			} else {
				cellline1 = min(cellline1,obj->idom->line1);
				cellkol1 = min(cellkol1,obj->idom->kol1);
				celllastln = max(celllastln,obj->idom->lastln);
				celllastkl = max(celllastkl,obj->idom->lastkl);
			}
		}
	}
	f.type = 60;
	f.dx = f.dy = 2048;
	f.ix = f.iy = 1;
	f.ox = (cellkol1 + celllastkl)/2;
	f.oy = (cellline1 + celllastln)/2;

	if (scale < 0) {
		celll = celllastln - cellline1 + 1;
		if (FIP)
			celll = 3*celll/4;
		cellw = celllastkl - cellkol1 + 1;
		f.scale = 3840/max(celll,cellw);
		fprintf(stderr,"scale = %d\n",f.scale);
	}
	if (FIP) {
		f.ix = f.scale;
		f.iy = (3*f.scale+2)/4;
		f.scale = 1;
	}

	if (number > 0) {
		dinit();
		clear();
		colour(GREYCOLS);
		for (objnum=1; objnum<=number; objnum++)
			picframe(objlist[objnum-1],&f);
		if (!nonum) {
			sprintf(s,"file %s",cell);
			dispstring(s,24,24);
			tsize(40,40);
			for (objnum=1; objnum<=number; objnum++)
				frameobjnum(objnum,objlist[objnum-1],&f);
		}
		finish();
	}
}


max(i,j)
{
	return ( i>j? i: j);
}


min(i,j)
{
	return ( i<j? i: j);
}
