/*
 * kardsp.c
 *
 * display a classified karogram
 *
 * Modifications
 *
 *	23 Oct 1989		dcb		Pass initslave the slave process priority
 *	30 Sep 1987		CAS		Make kcont a pointer (and global - yuk)
 *	 3 Sep 1987		CAS		New ddgs open/dev calls
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <multip.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <files.h>

#define YES = 0
#define NO = 1


struct text *textobj;
struct cellid *cellinformation;
int SHANDON = 0;
int VIDEORECORD = 0;
int aspectr = 0;
int DOWN = 0;
int thereiscellinfo = 0;

struct kcontrol *kcont;
extern DDGS *ddgsopen();
extern struct kclasscont kcc[MAXCLASS];

/*
 * display every chromosome in its current position
 */
noslave_displayall(kcont)
struct kcontrol *kcont;
{
	struct kident kid;
	register int i, j;
	register struct kclasscont *kccp;
	colour(255);
	fast();
	clear();
	slow();
	colour(254);
	tsize(50,50);
	kccp = kcc;
	for (i=0; i<MAXCLASS; i++) {
		for (j=0; j<kccp->maxn; j++) {
			kid.no = kccp->kno[j];
			if (kid.no >= 0) {
				kid.pos = kcont->mol[kid.no]->plist->disppos;
				kid.stackpos = kccp->sp[j];
				kid.kclass = i;
				kdsetup(&kid,kcont);
			}
		}
		kccp++;
	}
	disptags();
	colour(254);
	intens(1);
	for (i=0;i<kcont->maxnumber;i++)
		picframe(kcont->mol[i],kcont->ivf+i)
	;
}



char *get_to(find,s)
char find;
char *s;
{
	while(*s)
		if (*s++==find)
			return(s)
		;
	;
	return(NULL);
}




main(argc,argv)
char **argv;
{
	struct chromosome *oolist[MAXOBJS], *rolist[MAXOBJS];
	struct chromosome *molist[MAXOBJS], *mpcopyobj();
	struct object *bolist[MAXOBJS];
	SMALL activelist[MAXOBJS];
	struct pframe f, framelist[MAXOBJS];
	register int i, slave, maxsla;
	int interrupt();
	char *nptr;
	char file[25];
	FILE *fp;
	
	setmemalloc(16384);
	setpr(getpid(),MPRIOR);
	setbuf(stderr,NULL);
	kcont = (struct kcontrol *) Malloc (sizeof (struct kcontrol));

	initkcontrol(kcont);

	while (argc > 1) {
		switch (argv[1][0]) {
			case 'f':	/* get intput from these files  */
				if ((nptr=get_to('=',&argv[1][1]))!=NULL)
					if (strlen(nptr)<22)
						strcpy(file,nptr);
					else
						{
						fprintf(stderr,"File name too long\n");
						exit(1);
						}
				else
					{
					fprintf(stderr,"Invalid file specifier\n");
					exit(1);
					}
				break;
			}
		argc--;
		argv++;
	}

	kcont->ool = oolist;
	kcont->rol = rolist;
	kcont->bol = bolist;
	kcont->mol = molist;
	kcont->f = &f;
	kcont->ivf = framelist;
	kcont->acl = activelist;
	
	for (i=0; i<MAXOBJS; i++) {
		oolist[i] = NULL;
		rolist[i] = NULL;
		bolist[i] = NULL;
		molist[i] = NULL;
		activelist[i] = 0;
	}

	initslave(&kcont,0,0, SPRIOR);
	
	kcont->ddgschannel = ddgsopen(FS_VME512,1);
	dinit();
	lutfrig();
	fast();
	clear();
	slow();

	fp=fopen(file,"r");
	read_kar(fp,&kcont);
	fclose(fp);
	karyogram(&kcont);
	noslave_displayall(&kcont);
	

}

/*
 * read objects from file.
 * Give them a property list if they lack one,
 * and set them active so that feature measurement may proceed
 */
read_kar(f,k)
FILE *f;
register struct kcontrol *k;
{
	struct chromosome *obj, **mol, **rol;
	struct chromosome *readobj();
	struct chromplist *makechromplist();
	
	mol = k->mol;
	rol = k->rol;
	intens(1);
	colour(1);
	dispnum(0,3960,32);
	while ((obj=readobj(f)) != NULL)
		if (obj->type == 1) {
			mol[k->maxnumber] = obj;
			rol[k->maxnumber] = obj;
			if (obj->plist == NULL) {
				fprintf(stderr,"No property list\n");
				exit(1);
				}
			k->acl[k->maxnumber] = ACTIVE;
			intens(0);
			dispnum(k->maxnumber,3960,32);
			k->maxnumber++;
			intens(1);
			dispnum(k->maxnumber,3960,32);
		}
	intens(0);
	dispnum(k->maxnumber,3960,32);
	intens(1);
}
