/*
 *
 *		File handling routines for mkcontrol
 *
 * GJP Shandon Southern Products 15 th Jan 1986 Image Analysis Division
 *
 *
 * Modifications
 *
 *	14 Sep 1986		CAS		Includes
 */
 
#include <stdio.h>
#include <dir.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <files.h>

/*
 *	check through a structure seeing if any of the files are in the 
 *  given directory.
 */
 
check_for_files(path,fp,n)
char *path;
struct filestate *fp;
int n;
{
DIR *dfd;
struct direct *dent;
struct filestate *fpp;
int found = 0;
int i;
	if ((dfd=opendir(path))!=NULL)
		{
		while ((dent=readdir(dfd))!=NULL && found<n )
			{
			for (i=0,fpp=fp;i<n;i++,fpp++)
				if (strcmp(fpp->f_name,dent->d_name)==0)
					{
					fpp->f_state=FOUND;
					found++;
					}
				;
			;
			}
		;
		closedir(dfd);
		}
	else
		fprintf(stderr,"Failed to open directory on %s\n",path)
	;
}

/*
 *
 *	set up the file list ready for check for files to operate
 *
 */

set_up_list(fileroot,ext,fp,n)
char *fileroot;
char **ext;
int n;
struct filestate *fp;
{
int i;
	for (i=0;i<n;i++,fp++,ext++)
		{
		strcpy(fp->f_name,fileroot);
		strcat(fp->f_name,*ext);
		fprintf(stderr,"%s\n",fp->f_name);
		(fp)->f_state=NOTFOUND;
		}
	;
}

write_kar(f,kc)
FILE *f;
register struct kcontrol *kc;
{
	register int i, fsize, ac;
	char STDOUTBUF[BUFSIZ];
	char c = 0;

	/* give file (assumed stdout ?) a buffer (default grabbed by stderr) */
	setbuf(f,STDOUTBUF);

	/* compute total file size and do the seek-to-end trick */
	fsize = -1;
	for (i=0; i<kc->maxnumber; i++) {
		/* only write if active */
		ac = kc->acl[i];
		ac &= ACTIVE;
		if (ac == ACTIVE)
			fsize += seqsize(kc->mol[i]);
	}
	lseek(fileno(f),fsize,0);
	write(fileno(f),&c,1);
	lseek(fileno(f),(long)0,0);

	/* write away the data */
	for (i=0; i<kc->maxnumber; i++) {
		/* only write if active */
		ac = kc->acl[i];
		ac &= ACTIVE;
		if (ac == ACTIVE)
			writeobj(f,kc->mol[i]);
	}
}

/*
 * read objects from file.
 * Give them a property list if they lack one,
 * and set them active so that feature measurement may proceed
 */
read_raw(f,k)
FILE *f;
register struct kcontrol *k;
{
	register struct chromosome *obj, **ol;
	struct chromosome *readobj();
	struct chromplist *makechromplist();
	
	ol = k->ool;
	while ((obj=readobj(f)) != NULL)
		if (obj->type == 1) {
			ol[k->maxnumber] = obj;
			if (obj->plist == NULL) {
				obj->plist = makechromplist();
				obj->plist->number = k->maxnumber+1;
			}
			k->acl[k->maxnumber++] = ACTIVE;
		}
}
