/*
 * mpcleartest.c
 *
 * multi-processor environment screen clear test
 *
 * Modifications
 *
 *	23 Oct 1989		dcb		Pass initslave the slave process priority
 *	 3 Sep 1987		CAS		New ddgs calls
 */
#include <stdio.h>
#include <multip.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
extern DDGS *ddgsopen();

main(argc,argv)
char **argv;
{
	struct kcontrol kcont;
	register int i, j,speed=0 ,slave, maxsla;
	int interrupt();
    char iter[5];
    
	setmemalloc(16384);
	setpr(getpid(),MPRIOR);
	setbuf(stderr,NULL);
	intercept(interrupt);

	fprintf(stderr,"MULTI-PROCESSOR SCREEN CLEAR TEST\n");
	initkcontrol(&kcont);

	/* ARGUMENT SWITCHES */
	maxsla = 2;
	while (argc > 1) {
		switch (argv[1][0]) {
			case 's': /* max slave processor number */
				maxsla = atoi(&(argv[1][1]));
				if (maxsla > NSLAVES)
					maxsla = NSLAVES;
				if (maxsla < 1)
					maxsla = 1;
				maxsla--;
				break;
			case 't': /* set "seat" (terminal) for interaction */
				kcont.seat = atoi(&argv[1][1]);
				if (kcont.seat < 0 || kcont.seat > 1) {
					fprintf(stderr,"illegal terminal %d\n",kcont.seat);
					exit(1);
				}
				if (kcont.seat == 1) { /* Use higher crs display */
					kcont.terminal = "/t1";
				}
				break;
			case 'f':
				speed=1;
				break;
		}				
				
		argc--;
		argv++;
	}
	kcont.ddgschannel = ddgsopen(FS_VME512,kcont.seat);

	/*
	 * start the slaves, one per processor including in master
	 */
	for (slave=0; slave<=maxsla; slave++)
/*
		initslave(&kcont,slave,1-slave/4, SPRIOR);
		initslave(&kcont,slave,slave/4, SPRIOR);
*/
		initslave(&kcont,slave,slave%NPROCESSORS, SPRIOR);

	printf("%d slaves started\n",maxsla+1);
	printf("Kcont at 0x%x 0x%x\n",&kcont,&kcont.auxstat);
	/*
	 * start display
	 */	
	dinit();
	if(speed)
		fast();
	else
		slow();
	
	for (j=0;;j++) {
		mpclear(&kcont);
		moveto(0,0);
		lwidth(10);
		lineto(4095,4095);
		for (i=0; i<8; i++) {
			moveto(1792+64*i,512*i);
			lineby(0,504);
		}
		moveto(3500,40);
		sprintf(iter,"%d",j);
		text(iter);

		sleep(1);
	}
}
