/*
 *	M P M O N   --   Monitor slave communications
 *
 *	Written by: dcb/GJP 02/12/88
 *
 *	Image Recognition Systems
 *	720 Birchwood Blvd
 *	Birchwood
 *	Warrington
 *	WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 */
#include <stdio.h>
#include <wstruct.h>
#include <kcontrol.h>
#include <mp.h>

# include <stdio.h>

# define TRUE 1
# define FALSE 0
# define DEF_NSLAVES 5	/* Default no. slaves to look at */

extern int errno;
extern char *mpmonid;

int dbug=0;
int quit = FALSE;	/* User controlled quit */
int interrupt();
	
/*
 * Main code starts here
 */
main(argc, argv)
int argc;
char **argv;
{
	struct kcontrol *kcont;
	int		slave, processor, com, *c_addr, *c_proc;
	int opt, i, in, out, stat;
	char c, *s, *str, *buf, *malloc();
	int nslaves=DEF_NSLAVES;

	setmemalloc(12800);
	setbuf(stderr,NULL);

	intercept(interrupt); /* Set up signal catcher */
/*
 * First process for options
 */
	argv++;	/* skip program name */
	argc--; /* One less */

	while (argc>0 && (*argv)[0] == '-') {
		opt = 1;	/* where to find an option */
		stat = 1;	/* Initial option stat */
		for (s=argv[0]+1; *s!='\0'; s++)
			switch (*s) {
			case '?': options();
			case 'v':
				printf("%s\n", mpmonid);
			  	exit(0);
			case 'g': dbug++;
					break;
			case 's':
					stat = sscanf(*(argv+opt++), "%d", &nslaves);
					break;
/*			case 'n':
					stat = sscanf(*(argv+opt++), "%x", &ntrks);
					break;
*/
			default: fprintf(stderr, "Unknown switch '%c'\n", *s);
				exit(-1);
			}
		if (stat != 1) exit(_errmsg(1, "Invalid format for option '%c'", *s));
		argc -= opt;  argv += opt; opt = 1;
		if (quit) exit(1);

		stat = sscanf(*(argv), "%x", &kcont);

		display_info(kcont, nslaves);


} /* end main() */

/*
 *	D I S P L A Y _ I N F O
 */
display_info(kcont, nslaves)
struct kcontrol *kcont;
int nslaves;
{
	int i;

	/*
	 *	Print heading, lock status, maxnumber, mstatus, auxstatus
	 */
	printf("Structure %slocked\nmaxnumber\t= %d\nmstatus\t\t= %s\n\
auxstat\t\t= 0x%X (= %d)\n",
		(kcont-lock ? "" : "un"), kcont->maxnumber, sl_status(kcont->mstatus),
		kcont->auxstat, kcont->auxstat);

	for (i=0; i<nslaves; i++) {
		printf("Slave %2d command 0x%2X
}

/*
 * options() - Print options and exit
 */
options()
{
	printf("%s%s%s%s%s%s%s",
		"Syntax:\t\tmpmon [<-?vgs>] [<optinfo>] <kcontrol address>\n",
		"Function:\tMonitor slave control structures\n",
		"Use:\t\tInvestigating lockups\n",
		"Options:\n\t-?\t\tHelp info.\n",
		"\t-s\t\tSet max. no. of slaves (default 5)\n",
		"\t-g\t\tTurn on debug\n",
		"\t-v\t\tDisplay version id\n\n");
	exit(0);
} /* end options() */

/*
 *	I N T E R R U P T --  Signal catcher
 *
 */
interrupt(sig)
int		sig;
{
	quit=TRUE;
}

			
