/*
 * str.c
 *
 * Derived from testch.c.  Test bed for straightening
 *
 * Modifications
 *
 *	 3 Sep 1987		CAS		New ddgs open/dev calls
 *	31 Mar 1987		CAS		Changed display -> now axis,axis+perp lines, str
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <ddgs.h>

int wh[2] = {0,2};
struct pframe f;


main()
{
	struct object *strobj, *spobj, *mpol, *cvh, *rect;
	struct chromosome *obj, *readobj();
	struct object *convhull(), *spin(), *minwrect();
	struct object *straighten(), *chromosomeaxis();
	int i, j, number;
	double os9frig;

	ddgsopen(FS_VME512,1);
	dinit();
	number = 0;
	while ((obj = readobj(stdin)) != NULL) {
		number++;
		if (area(obj) < 60)
			fprintf(stderr,"tiny object ignored %d\n",number);
		else if (obj->plist == NULL || obj->plist->otype <= 1) {
		f.type = 60;
		f.scale = 24;
		f.ix = f.iy = 1;
		f.dx = 1024;
		f.dy = 2048;
		cvh = convhull(obj);
		rect = minwrect(cvh);

		/*
		 * rotate to vertical
		 */
		os9frig = ((struct frect *)rect->idom)->rangle;
		spobj = spin(obj,os9frig);
		mpol = chromosomeaxis(spobj);
		clear();
/*
 *	Draw object
 */
		f.ox = (spobj->idom->kol1 + spobj->idom->lastkl)/2;
		f.oy = (spobj->idom->line1 + spobj->idom->lastln)/2;
		picframe(spobj,&f);
/*
 *	Draw axis
 */
		f.ox *= 8;
		f.oy *= 8;
		f.scale /= 8;
		picframe(mpol,&f);
/*
 *	Make second copy for 'straighten' to doodle on
 */
		f.dx += 1024;
		f.ox = (spobj->idom->kol1 + spobj->idom->lastkl)/2;
		f.oy = (spobj->idom->line1 + spobj->idom->lastln)/2;
		f.scale *= 8;
		picframe(spobj,&f);
		f.ox *= 8;
		f.oy *= 8;
		f.scale /= 8;
		picframe(mpol,&f);
/*
 *	Then straighten + display (NB display done in straighten)
 */
		f.ox = (spobj->idom->kol1 + spobj->idom->lastkl)/2;
		f.oy = (spobj->idom->line1 + spobj->idom->lastln)/2;
		f.scale *= 8;
		
		strobj = straighten(spobj,mpol,1,&f);
/*		f.ox = (strobj->idom->kol1 + strobj->idom->lastkl)/2;
		f.oy = (strobj->idom->line1 + strobj->idom->lastln)/2;
		f.dx += 1024;
		picframe(strobj,&f);*/
		freeobj(spobj);
		freeobj(strobj);
		freeobj(mpol);
		freeobj(cvh);
		freeobj(rect);
		}
		freeobj(obj);
	}
}
