/*
 *		T A X . C  - Test Axis stuff (derived fron testch)
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    10th July 1987
 *
 *  Modifications
 *
 *	 5 Dec 1988		CAS		Param stuff, framestore type, facts etc
 *	 3 Sep 1987		CAS		New ddgs open/dev calls
 *	14 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <ddgs.h>
#include <wstruct.h>
#include <display.h>

#define SCALE 32

extern double xscale;
extern double yscale;

main(argc,argv)
int		argc;
char	**argv;
{
	char	*swptr, **targv;
	int		targc, doneone;
	FILE	*infile;
	int		store = FS_VME512, devno = 0;
	DDGS	*dg, *ddgsopen();
	struct object *spobj, *cvh, *rect;
	struct object *obj, *readobj();
	struct object *fipconvhull(), *spinsqueeze(), *minwrect();
	struct object *pms, *pmsaxis();
	struct object *bound, *ibound(), *skeleton(), *skobj;
	struct object *mpol, *chromosomeaxis(), *chromaxis2();
	struct pframe f;
	int i, j, number, xr, yr, tip;
	char s[100];
	double os9crud;
	int		facts = 0, spinit = 0;

	targc = argc; targv = argv;

	argc--; argv++;			/* dump process name */
	while (argc > 0) {
		if (*argv[0] == '-') {
			swptr = *argv;
			*argv = NULL;
			while (*(++swptr)) {
				switch (*swptr) {
					case '?':
						printf("Syntax:   picture <options> scale column line <options>\n");
						printf("Function: \n");
						printf("Options:  v - Show version number\n");
						printf("          1 - Use seat 1 framestore\n");
						printf("          2 - Use seat 2 framestore\n");
						printf("                  also 3 and 4\n");
						printf("          V - Virtuoso framestore (Default CRS 512)\n");
						printf("          f - show facts\n");
						printf("          s - spin object first\n");
				 		printf("          ? - Help\n");
				 		exit(0);
					case 'v':
						printf("Tax - Version 1.0\n");
						exit(0);
					case 'f':
						facts = 1;
						break;
					case 's':
						spinit = 1;
						break;
					case '1':
						devno = 0;
						break;
					case '2':
						devno = 1;
						break;
					case '3':
						devno = 2;
						break;
					case '4':
						devno = 3;
						break;
					case 'V':
						store = FS_VIRTUOSO_INVERT;
						break;
/*				  case 'x':
					param = *++argv;
					*argv = NULL; argc--;
					break;*/
				  default:
				 	printf("tax - unknown option\n");
				}
			}
		}
		argv++; argc--;
	}
	dg = ddgsopen(store,devno);
	dinit();
	llut();
	lutcol();
	lwidth(2);
	number = 0;
	xscale = 1.0;
	yscale = 0.75;
	while ((obj = readobj(stdin)) != NULL) {
		number++;
		if (area(obj)<60)
			continue;
		f.type = 60;
		f.scale = SCALE;
		f.ox = (obj->idom->kol1 + obj->idom->lastkl)/2;
		f.oy = (obj->idom->line1 + obj->idom->lastln)/2;
		f.ix = f.iy = 1;
		f.dx = 2048;
		f.dy = 2176;
		cvh = fipconvhull(obj);
		rect = minwrect(cvh);

		/*
		 * rotate to vertical
		 */
		os9crud = ((struct frect *)rect->idom)->rangle;
		if (spinit) {
			spobj = spinsqueeze(obj,&os9crud,&xscale,&yscale);
		} else
			spobj = obj;
		fast();
		clear();
		slow();

		pms = chromaxis2(spobj);
		if (facts) {
			fprintf(stderr,"Poor man skeleton (chromaxis2/pmsaxis)\n");
			details(pms);
		}
		mpol = chromosomeaxis(spobj);

		colour(OVERLAY2);
		tsize(90,100);
		dispnum(number,100,100);
		colour(GREYCOLS);
		picframe(spobj,&f);
		sprintf(s,"width %d height %d",spobj->idom->lastkl-spobj->idom->kol1,
			spobj->idom->lastln-spobj->idom->line1);
		moveto(400,100);
		text(s);

		/*
		 * display choice of axes (1) new, green, (2) old, red
		 */
		f.scale /= 8;
		f.ox *= 8;
		f.oy *= 8;
		colour(OVERLAY1);
		picframe(pms,&f);
		moveto(100,320);
		tsize(60,60);
		text("pmsaxis");
		colour(OVERLAY2);
		picframe(mpol,&f);
		moveto(100,440);
		text("chromaxis");
		freeobj(mpol);
	
		if (spinit)
			freeobj(spobj);
		freeobj(cvh);
		freeobj(rect);
		freeobj(obj);
		freeobj(pms);

		sleep(1);
	}
}

/*
 * load odd-valued look-up-table addresses
 * so that plane zero functions as overlay
 */
lutcol()
{
	register int i;
	for (i=1; i<=255; i+=4) {
		setrgb(i,0,255,0);
		setrgb(i+1,255,0,0);
		setrgb(i+2,255,255,0);
	}
}

yrange(pol)
struct object *pol;
{
	register struct polygondomain *pdom;
	register struct ivertex *vtx;
	register int i, miny, maxy;
	pdom = (struct polygondomain *)pol->idom;
	vtx = pdom->vtx;
	miny = vtx->vtY;
	maxy = miny;
	for (i=1; i<pdom->nvertices; i++) {
		if ((++vtx)->vtY < miny)
			miny = vtx->vtY;
		else if (vtx->vtY > maxy)
			maxy = vtx->vtY;
	}
	return(maxy-miny);
}

