/*
 * tch.c
 *
 * Derived from testch.c.  Test bed for centromere finding.
 *
 * Modifications
 *
 *	 3 Sep 1987		CAS		new ddgs calls (open/dev)
 *	15 Sep 1986		CAS		Casts
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <ddgs.h>

int wh[2] = {0,2};


double xscale = 1.0;
double yscale = 0.75;

main(argc,argv)
char **argv;
{
	struct object *spobj, *mpol, *cvh, *rect;
	struct chromosome *obj, *readobj();
	struct object *fipconvhull(), *spinsqueeze(), *minwrect();
	struct object *poly, *centpoly(), *chromaxis2();
	struct object *prof, *p[3], *nprofile();
	struct object *polyprof(), *polyp;
	struct histogramdomain *h;
	struct polygondomain *pdom, *uspaxis8();
	struct pframe f;
	int i, j, l, number, cpos1, cpos2, ca, cl;
	double os9frig;
	char s[100];
	int VERT = 0;

	if (argc > 1 && argv[1][0] == '-' && argv[1][1] == 'v')
		VERT = 1;
	ddgsopen(FS_VME512,1);
	dinit();
	lutcol();
	number = 0;
	while ((obj = readobj(stdin)) != NULL) {
		number++;
		if (area(obj) < 60)
			fprintf(stderr,"tiny object ignored %d\n",number);
		else if (obj->plist == NULL || obj->plist->otype <= 1) {
		f.type = 60;
		f.scale = 32;
		f.ox = obj->idom->kol1;
		f.oy = obj->idom->line1;
		f.ix = f.iy = 1;
		f.dx = 768;
		f.dy = 1024;
		if (VERT)
			spobj = (struct object *) obj;
		else {
			cvh = fipconvhull(obj);
			rect = minwrect(cvh);

			/*
			 * rotate to vertical
			 */
			os9frig = ((struct frect *)rect->idom)->rangle;
			spobj = spinsqueeze(obj,&os9frig,&xscale,&yscale);
		}
		mpol = chromaxis2(spobj);
	
		/*
		 * moment profile computation and smoothing
		 */
		multiprofiles(spobj,mpol,p,wh,2);
		shorten(mpol,p[0],p[1]);
		freeobj(p[0]);
		prof = p[1];
		h = (struct histogramdomain *) prof->idom;
		h->hv[0] = 0;
		h->hv[h->npoints - 1] = 0;
		histosmooth(p[0], 3);
		histosmooth(prof, 3);		/* As in "mfeatures.c" */
	
		/*
		 * locate centromere in mirrored profile with
		 * quantum parameter set to be 10% of peak value.
		 */
		cpos1 = cmerelocation(prof,10,1);
		/*
		 * locate centromere in un-mirrored profile with
		 * quantum parameter set to be 20% of peak value.
		 */
		cpos2 = cmerelocation(prof,5,0);
		h32normalise(prof);
		h32normalise(p[0]);
		fast();
		clear();
		slow();
		dispnum(number,100,100);

/*
		picframe(obj,&f);
		picframe(cvh,&f);
		picframe(rect,&f);
		f.dx = 2048;
*/
		f.ox = spobj->idom->kol1;
		f.oy = spobj->idom->line1;
		colour(252);
		picframe(spobj,&f);
		f.ox *= 8;
		f.oy *= 8;
		f.scale /= 8;
		picframe(mpol,&f);
		f.ox = spobj->idom->kol1;
		f.oy = spobj->idom->line1;
		f.scale *= 8;

/*
		f.dx += 768;
		picframe(spobj,&f);
		f.ox *= 8;
		f.oy *= 8;
		f.scale /= 8;
		picframe(mpol,&f);
		f.ox = spobj->idom->kol1;
		f.oy = spobj->idom->line1;
		f.scale *= 8;
*/

		f.dx += 1024;
		picframe(prof,&f);
		colour(1);
		f.dx += 16;
		picframe(p[0],&f);
/*
		profsubtr(prof,p[0]);
		colour(2);
		f.dx += 16;
		picframe(prof,&f);
*/
		colour(252);
		f.dx -= 1024;
		f.dx -= 32;

		if (cpos1 >= 0) {
			f.ox *= 8;
			f.oy *= 8;
			f.scale /= 8;
			poly = centpoly(mpol,cpos1);
			pdom = (struct polygondomain *) poly->idom;
			poly->idom = (struct intervaldomain *) uspaxis8(pdom);
			picframe(poly,&f);
			free(pdom);
			f.ox = spobj->idom->kol1;
			f.oy = spobj->idom->line1;
			f.scale *= 2;
			f.ix = 4;
			polyp = polyprof(spobj,poly);
			f.dx += 512;
			picframe(polyp,&f);
			f.dx -= 512;
			f.scale *= 4;
			f.ix = 1;
			freeobj(polyp);
			freeobj(poly);
		/*
		 * centromeric indices
		 */
			pdom = (struct polygondomain *) mpol->idom;
			l = (pdom->vtx[cpos1].vtY + 4) >> 3;
			ca = cindexa(spobj,l);
			cl = cindexl(mpol,l);
			sprintf(s,"CI area %d length %d",ca,cl);
			moveto(1000,100);
			text(s);
		}

		colour(2);
		if (cpos2 >= 0) {
			f.ox *= 8;
			f.oy *= 8;
			f.scale /= 8;
			poly = centpoly(mpol,cpos2);
			pdom = (struct polygondomain *) poly->idom;
			poly->idom = (struct intervaldomain *) uspaxis8(pdom);
			free(pdom);
			picframe(poly,&f);
			f.ox = spobj->idom->kol1;
			f.oy = spobj->idom->line1;
			f.scale *= 2;
			f.ix = 4;
			polyp = polyprof(spobj,poly);
			f.dx += 512;
			f.dy -= 128;
			picframe(polyp,&f);
			f.dx -= 512;
			f.dy += 128;
			f.scale *= 4;
			f.ix = 1;
			freeobj(polyp);
			freeobj(poly);
		/*
		 * centromeric indices
		 */
			pdom = (struct polygondomain *) mpol->idom;
			l = (pdom->vtx[cpos2].vtY + 4) >> 3;
			ca = cindexa(spobj,l);
			cl = cindexl(mpol,l);
			sprintf(s,"CI area %d length %d",ca,cl);
			moveto(1000,300);
			text(s);
		}

		if (VERT == 0) {
			freeobj(spobj);
			freeobj(cvh);
			freeobj(rect);
		}
		freeobj(mpol);
		freeobj(prof);
		
		sleep(2);
		}
		freeobj(obj);
	}
}


/*
 * Find profile along integer-scaled *8 polygon.
 * Construct empty histogram.
 * For each polygon vertex, place grey-value of point at true
 * integer-part of coordinates (x,y) into histogram structure.
 * Note no interpolation at present.
 */
 
 struct object *polyprof(obj,poly)
 struct object *obj, *poly;
 {
 	struct polygondomain *pdom;
 	struct histogramdomain *hdom, *makehistodmn();
 	struct object *ho, *makemain();
 	register struct ivertex *vtx;
 	register int i,n,*hv;
 	GREY *greyval();
 	
 	pdom = (struct polygondomain *) (poly->idom);
 	n = pdom->nvertices;
 	vtx = pdom->vtx;
 	hdom = makehistodmn(1,n);
 	hdom->l = obj->idom->line1;
	hdom->k = obj->idom->kol1;
 	ho = makemain(13,hdom,NULL,NULL,NULL);
 	hv = hdom->hv;
 	
 	for (i=0; i<n; i++,vtx++)
 		*hv++ = (int)(*greyval(obj,vtx->vtY/8,vtx->vtX/8));
 	return(ho);
 }

h32normalise(obj)
struct object *obj;
{
	register struct histogramdomain *hdom;
	register int i, maxh, *h;
	hdom = (struct histogramdomain *) obj->idom;
	h = hdom->hv;
	maxh = 0;
	for (i=0; i<hdom->npoints; i++) {
		if (*h > maxh)
			maxh = *h;
		h++;
	}
	h = hdom->hv;
	for (i=0; i<hdom->npoints; i++) {
		*h = *h * 32 / maxh;
		h++;
	}
}

/*
 * load odd-valued look-up-table addresses
 * so that plane zero functions as overlay
 */
lutcol()
{
	register int i;
	for (i=1; i<=255; i+=2)
		setrgb(i,0,255,0);
	for (i=2; i<=254; i+=4)
		setrgb(i,255,0,0);
}

profsubtr(p,q)
struct object *p, *q;
{
	struct histogramdomain *pdom, *qdom;
	int *pv, *qv, i,n;
	
	pdom = (struct histogramdomain *) p->idom;
	qdom = (struct histogramdomain *) q->idom;
	n = pdom->npoints;
	pv = pdom->hv;
	qv = qdom->hv;
	for (i=0; i<n; i++) {
		if (*qv != 0)
			*pv = *pv *32 / *qv;
		else
			*pv = 0;
		pv++;
		qv++;
	}
}
