/*
 * tcvh.c
 *
 * Derived from testch.c.  Test bed for convex hull.
 *
 * Modifications
 *
 *	 3 Sep 1987		CAS		New ddgs open/dev calls
 *	14 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>
#include <ddgs.h>

#define SCALE 32

main()
{
	struct object *cvh, *rect;
	struct object *obj, *readobj();
	struct object *convhull(), *fipconvhull(), *minwrect();
	struct pframe f;
	int i, j, number, xr, yr, tip;
	char s[100];

	ddgsopen(FS_VME512,1);
	dinit();
	lutcol();
	lwidth(2);
	number = 0;
	while ((obj = readobj(stdin)) != NULL) {
		number++;
		f.type = 60;
		f.scale = SCALE;
		f.ox = (obj->idom->kol1 + obj->idom->lastkl)/2;
		f.oy = (obj->idom->line1 + obj->idom->lastln)/2;
		f.ix = f.iy = 1;
		f.dx = 1024;
		f.dy = 2048;
		fast();
		clear();
		slow();

		colour(1);
		dispnum(number,100,150);
		colour(252);
		picframe(obj,&f);
		colour(1);
		cvh = convhull(obj);
		rect = minwrect(cvh);
		picframe(rect,&f);
		colour(2);
		picframe(cvh,&f);
		
		freeobj(cvh);
		cvh = fipconvhull(obj);
		f.dx += 2048;
		f.oy = f.oy*0.75;
		rect = minwrect(cvh);
		colour(1);
		picframe(rect,&f);
		colour(2);
		picframe(cvh,&f);



		freeobj(cvh);
		freeobj(rect);
		freeobj(obj);

		sleep(5);
	}
}

/*
 * load odd-valued look-up-table addresses
 * so that plane zero functions as overlay
 */
lutcol()
{
	register int i;
	for (i=1; i<=255; i+=2)
		setrgb(i,0,255,0);
	for (i=2; i<=254; i+=4)
		setrgb(i,255,0,0);
}

