/*
 * tellprops.c		29/2/84		Jim Piper
 *
 * print property list contents.
 *
 * Modifications
 *
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>


main(argc,argv)
char **argv;
int argc;
{
	struct object *obj, *readobj();
	struct chromplist *p;
	while((obj = readobj(stdin)) != NULL) {
		if (obj->type == 1) {
			if (obj->plist == NULL) {
				printf("\nNO PROPERTY LIST\n\n");
			} else {
				p = (struct chromplist *) obj->plist;
				printf("\nPROPERTY LIST CONTENTS\n");
				printf("----------------------\n");
				printf("object:     number %d area %d mass %d length %d",p->number,p->area,p->mass,p->length);
				if (p->pnumber > 0)
					printf(" parent %d\n",p->pnumber);
				else
					printf("\n");
				printf("hull:       area %d perimeter %d\n",p->hullarea,p->hullperim);
				printf("m w rect:   area %d width %d orientation %d\n",p->rectarea,p->rectwidth,p->rangle);
				printf("centromere: x %3d y %3d angle %3d\n",p->cx,p->cy,p->cangle);
				printf("            X %3d Y %3d ANGLE %3d\n",p->Ccx,p->Ccy,p->Ccangle);
				printf("features:   ci-a %4d ci-m %3d ci-l %3d\n",p->cindexa,p->cindexm,p->cindexl);
				printf("            cvdd %4d nssd %4d mdra %4d ddm2 %4d\n",p->cvdd,p->nssd,p->mdra,p->ddm2);
				printf("            wdd  %4d %4d %4d %4d %4d %4d\n",p->wdd[0],p->wdd[1],p->wdd[2],p->wdd[3],p->wdd[4],p->wdd[5]);
				printf("            mwdd %4d %4d %4d %4d %4d %4d\n",p->mwdd[0],p->mwdd[1],p->mwdd[2],p->mwdd[3],p->mwdd[4],p->mwdd[5]);
				printf("            gwdd %4d %4d %4d %4d %4d %4d\n",p->gwdd[0],p->gwdd[1],p->gwdd[2],p->gwdd[3],p->gwdd[4],p->gwdd[5]);
				printf("class:      obj type %d denver %2d paris %2d\n",p->otype,p->dgroup,p->pgroup);
				printf("            OBJ TYPE %d DENVER %2d PARIS %2d\n",p->Cotype,p->Cdgroup,p->Cpgroup);
			}
		}
		freeobj(obj);
	}
}
