/*
 *	T E S T C H . C
 *
 * Modifications
 *
 *	20 Jan 1988		CAS		Added cmd line stuff
 *	 3 Sep 1987		CAS		New ddgs open/dev calls
 *	14 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <ddgs.h>

#define AXISSMOOTH 2
#define PROFSMOOTH 2
#define WHICHPROF	2

struct pframe f;
int wh[2] = {0,2};


/*
 *	M A I N  --
 *
 */
main(argc,argv)
int		argc;
char	**argv;
{
	char	*swptr, **targv;
	int		targc, doneone;
	int		store = FS_VME512, devno = 0;
	DDGS	*dg, *ddgsopen();

	struct object *spobj, *mpol, *cvh, *rect;
	struct chromosome *obj, *readobj();
	struct object *convhull(), *spin(), *minwrect();
	struct object *chromaxis2();
	struct object *prof, *p[3], *profile(), *nprofile();
	struct ipoint *point, *ncentromere();
	struct ivector *vc, *centvector();
	struct histogramdomain *h;
	struct ivector v;
	struct chromplist *makechromplist();
	int i, j, number, cpos;
	int wddval[4];
	double os9frig;

	targc = argc; targv = argv;

	argc--; argv++;			/* dump process name */
	while (argc > 0) {
		if (*argv[0] == '-') {
			swptr = *argv;
			*argv = NULL;
			while (*(++swptr)) {
				switch (*swptr) {
				  case '?':
				  	printf("Syntax:   testch <options>\n");
				  	printf("Function: \n");
				  	printf("Options:  v - Show version number\n");
					printf("          1 - Use seat 1 framestore\n");
					printf("          2 - Use seat 2 framestore\n");
					printf("                  also 3 and 4\n");
					printf("          V - Virtuoso framestore (Default CRS 512)\n");
				  	printf("          ? - Help\n");
				  	exit(0);
				  case 'v':
						printf("Testch - Version 0.1\n");
						exit(0);
					case '1':
						devno = 0;
						break;
					case '2':
						devno = 1;
						break;
					case '3':
						devno = 2;
						break;
					case '4':
						devno = 3;
						break;
					case 'V':
						store = FS_VIRTUOSO_INVERT;
						break;
				  default:
				 	printf("testch - unknown option\n");
				}
			}
		}
		argv++; argc--;
	}

	argc = targc; argv = targv;

	dg = ddgsopen(store,devno);
	dinit();
	llut();
	number = 0;
	while ((obj = readobj(stdin)) != NULL) {
		number++;
		if (obj->plist == NULL)
			obj->plist = makechromplist();
		if (area(obj) < 80)
			fprintf(stderr,"tiny object %d\n",number);
		else if (obj->plist->otype <= 1) {
			f.type = 60;
			f.scale = 16;
			f.ox = obj->idom->kol1;
			f.oy = obj->idom->line1;
			f.ix = f.iy = 1;
			f.dx = 512;
			f.dy = 1536;
			clear();
			dispnum(number,100,100);
			picframe(obj,&f);
			cvh = convhull(obj);
			picframe(cvh,&f);
			rect = minwrect(cvh);
			picframe(rect,&f);

			/*
			 * rotate to vertical
			 */
			os9frig = ((struct frect *)rect->idom)->rangle;
			spobj = spin(obj,os9frig);
			f.dx = 1536;
			f.ox = spobj->idom->kol1;
			f.oy = spobj->idom->line1;
			picframe(spobj,&f);
			mpol = chromaxis2(spobj);
			f.ox *= 8;
			f.oy *= 8;
			f.scale /= 8;
			picframe(mpol,&f);
			f.ox = spobj->idom->kol1;
			f.oy = spobj->idom->line1;
			f.scale = 16;
			multiprofiles(spobj,mpol,p,wh,2);
			prof = p[0];
			histonormalise(prof);
			f.dx += 256;
			picframe(prof,&f);
			prof = p[1];
			h = (struct histogramdomain *) prof->idom;
			h->hv[0] = 0;
			h->hv[h->npoints - 1] = 0;
			histonormalise(prof);
			f.dx += 768;
			picframe(prof,&f);
			f.dx += 256;
/*
			point = ncentromere(mpol,prof);
			if (point != NULL) {
	fprintf(stderr,"centromere found %d %d\n",point->l,point->k);
				point->style = 0;
				v.type = 30;
				v.l1 = v.l2 = point->l;
				v.k1 = point->k - 10;
				v.k2 = point->k + 10;
				f.dx -= 1280;
				picframe(&v,&f);
				free(point);
			}
*/
			cpos = cmerelocation(prof);
			if (cpos >= 0) {
				vc = centvector(mpol,cpos);
				f.dx -= 1280;
				picframe(vc,&f);
				free(vc);
			}
		freeobj(spobj);
		freeobj(mpol);
		freeobj(prof);
		freeobj(cvh);
		freeobj(rect);
		}
	freeobj(obj);
	}
	finish();
}
