/*
 * threshsplit.c		Jim Piper @ AUC		04-04-86
 *
 * Attempt composite split by re-thresholding, return list
 * of resultant objects.  Their evaluation should
 * be carried out elsewhere.
 *
 * Parameters are essentially the same as for label:
 *	obj		input object
 *	*n		number of objects found (also returned by function)
 *	objl	pointer to list for output objects
 *	maxn	maximum size of the output list
 *	ignlns	objects less than this high or wide to be ignored
 *	thresh	new threshold
 *
 * Modifications
 *
 *	14 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>

#define NDILATION 2

threshsplit(obj,n,objl,maxn,ignlns,thresh)
struct object *obj, **objl;
int *n;
{
	struct object *dilation(), *threshold(), *intersect2(), *o1, *o2;
	int i, j;
	
	/*
	 * threshold
	 */
	o1 = threshold(obj,thresh);
	/*
	 * label
	 */
	o1->vdom = NULL;
	label(o1,n,objl,maxn,ignlns);
	/*
	 * return if no segmentation achieved
	 */
	if (*n <= 1)
		return(*n);
	/*
	 * dilation pass - dilate each object.
	 * This should be fall set instead !!
	 */
	for (j=0; j < *n; j++) {
		o1 = objl[j];
		for (i=0; i<NDILATION; i++) {
			o2 = dilation(o1);
			freeobj(o1);
			o1 = o2;
		}
		o1 = intersect2(o2,obj);
		freeobj(o2);
		/* give final objects a grey-table */
		o1->vdom = obj->vdom;
		objl[j] = o1;
	}
	return(*n);
}
