/*
 *      I D D G S C O M . C  --
 *
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 *
 *	Based on DDGS
 *			 Jim Piper
 *			 MRC CAPCU Edinburgh
 *			 9th April 1985
 *
 * Device dependent graphics system with approximately same 
 * functionality as DIGS.
 * Window is assumed to be 4096 square so there is scaling everywhere.
 *
 *  Modifications
 *  -------------
 *	 1 Feb 1991	jimp	Modified to write into large store buffer
 *	23 Nov 1989		CAS		Improve modularisation (lut stuff out)
 *	23 Aug 1989		CAS		new fn to allow access to colour plane mask
 *
 */
#include <stdio.h>
#include <ddgs.h>
#define EXTERN extern
#include <iddgsdefs.h>

/*
 *	M O V E T O  --
 *
 */
moveto(x,y)
{
	/* mod put in here to center the small display box on the larger
	virtuoso driven screens and hopefully anything else */
	vstatus.curx = x + CENTERXOFFSET;
	vstatus.cury = y + CENTERYOFFSET;
}

moveby(x,y)
{
	vstatus.curx += x;
	vstatus.cury += y;
}

/*
 * plane-select function
 */
colour(c)
{
	vstatus.colour = c;
	vstatus.otherplanes = 255 - vstatus.colour;
	vstatus.colourbits = vstatus.intensity>0? vstatus.colour: 0;
	vstatus.colourmask = vstatus.intensity>0? vstatus.colour: 0;
}

/*
 * intensity non-zero causes data to be written to display.
 * intensity zero causes data to be cleared (set = zero).
 */
intens(i)
{
	vstatus.intensity = i;
	vstatus.otherplanes = 255 - vstatus.colour;
	vstatus.colourbits = vstatus.intensity>0? vstatus.colour: 0;
	vstatus.colourmask = vstatus.intensity>0? vstatus.colour: 0;
}
