/*
 *      I D D G S D E F S . H  --  Internal DDGS header bits
 *
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 *
 *	Based on DDGS
 *			 Jim Piper
 *			 MRC CAPCU Edinburgh
 *			 9th April 1985
 *
 * Device dependent graphics system with approximately same 
 * functionality as DIGS.
 * Window is assumed to be 4096 square so there is scaling everywhere.
 *
 *  Modifications
 *  -------------
 *	 1 Feb 1991	jimp	Modified to write into large store buffer
 *				for setting up ideograms.  This is by way
 *				of a hack, so BEWARE........
 *
 */

typedef short PIXEL;

#define MAX_LINENO	600
#define XLIM	30
#define YLIM	600
#define XSHIFT  3
#define YSHIFT  3


/* get round OS9 compiler absurdity */
static int ZERO = 0;

EXTERN PIXEL *B;

#define ADDRESS(a,x,y)  a= B + y*XLIM + x
#define ADDRESS2(a,x,y)   a= B + y*XLIM + x

/*
 * Draw point in current colour/intensity/selected planes.
 * Different macros to give optimum efficiency in different places.
 */
#define POINT(a,g) *a=g
#define POINT3(a,ps,g)  *a=g
#define CLEARPOINT(a) *a=0
#define CLEARPOINT2(a,ps) *a=ps

struct fs_status {
	short r0;
	short wmask;
	int curx;
	int cury;
	int colour;			/* as selected by "colour()" function */
	int colourbits;		/* determined by .colour, .intensity, INVERT */
	int otherplanes;	/* complement of .colour */
	int intensity;		/* as selected by "intensity()" function */
	int colourmask;		/* 0 or .colour, depending in .intensity */
	int WINDMINX;
	int WINDMINY;
	int WINDMAXX;
	int WINDMAXY;
	short scrollorig;
	short panorig;
	PIXEL *frame;	
	PIXEL *lstart[MAX_LINENO];
};

extern struct fs_status vstatus;
extern DDGS *dgb;

#define CENTERXOFFSET 0
#define CENTERYOFFSET 0


