/*
 * makewideo.c		Jim Piper @ MRC			1 February 1991
 *
 * Make ideogram objects in Woolz type 1 object format.
 * The program makes one file for each ideogram in
 * "/dd/params/ideograms/ideo.<class>.<bands>", and a
 * single file (equivalent to a karyotyped cell) containing
 * ALL ideograms in "/dd/params/ideograms/ideo$1$1k".
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <ideogram.h>
#include <ddgs.h>
#define EXTERN
#include <iddgsdefs.h>
#define IDEO_SCALE 8

main()
{
	FILE *kout, *idout, *fbopen();
	int chr, bc;
	char s[100];
	struct chromosome *o, *make_ideogram(), *r, *makerect();

	setmemalloc(64*1024);
	kout = fbopen("/dd/params/ideograms/ideo$1$1K","w",BUFSIZ);
	if (kout == NULL) {
		fprintf(stderr,"Cannot open IDEO.W\n");
		exit(0);
	}
	B = (PIXEL *) Calloc(XLIM*YLIM,sizeof(PIXEL));
	r = makerect(1,YLIM,1,XLIM,B,0,NULL,NULL);
	vstatus.WINDMAXX = XLIM-1;
	vstatus.WINDMAXY = YLIM-1;
	colour(255);
	intens(1);
	for (chr=1; chr<=24; chr++) {
		fprintf(stderr,"Ideogram class %d\n",chr);
		for (bc=1; bc<=3; bc++) {
			o = make_ideogram(chr,bc,r);
			writeobj(kout,o);
			sprintf(s,"/dd/params/ideograms/ideo.%d.%d",chr,300*(4-bc));
			idout = fbopen(s,"w",BUFSIZ);
			if (idout == NULL) {
				fprintf(stderr,"Cannot open %s\n",s);
				exit(0);
			}
			writeobj(idout,o);
			fbclose(idout);
			freeobj(o);
		}
	}
	fbclose(kout);
}

struct chromosome *make_ideogram(chr,band_type,r)
int chr, band_type;
struct chromosome *r;
{
	FILE *fp;
	char tbuf[20];
	static int objnum = 1;
	struct chrom_data *ideo, *get_ideogram();
	struct chromosome *o, *threshold();
	struct chromplist *plist, *makechromplist();

	fp = fopen("/dd/params/human.col","r");
	if (fp == NULL) {
		fprintf(stderr,"Cannot open human.col\n");
		exit(0);
	}
	iclear();
	switch (chr) {
		default:
			sprintf(tbuf,"%d",chr);
			break;
		case 23:
			sprintf(tbuf,"X");
			break;
		case 24:
			sprintf(tbuf,"Y");
			break;
	}
	ideo = get_ideogram(fp,tbuf,band_type);
	fclose(fp);
	draw_ideogram (ideo,100,2400,IDEO_SCALE);
	o = threshold(r,1);
	o->plist = plist = makechromplist();
	plist->pgroup = plist->Cpgroup = chr;
	plist->disppos = band_type;
	plist->dispor = 1;
	plist->cindexa = 25;
	plist->number = objnum++;
	return(o);
}

iclear()
{
	int i;
	for (i=0; i<XLIM*YLIM; i++)
		B[i] = 0;
}
