/*
 * checkattention.c		Jim Piper		29-10-86
 *
 * See if object specified has properties that cause it to have
 * attention drawn to it, and if so call "drawattention()" with
 * specified intensity setting.
 *
 *****************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	When		What
 * ---	----		----
 * JP	30-07-87	Display box rather than hull round potential noise
 * JP	18-11-86	Any ACTIVE object whose type is > CHROMOSOME is in need
 *					of attention.
 *****************************************************************************
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <display.h>
#include <multip.h>

checkattention(intens,onum,kcont)
struct kcontrol *kcont;
{
	register int atype;
	register struct chromplist *plist = kcont->ool[onum]->plist;
	if (plist->otype > CHROMOSOME && (kcont->acl[onum] & ACTIVE)) {
		switch (plist->otype) {
			case COMPOSITE:
			case OVERLAP:
			case NUCLEUS:
			default:
				atype = 1;
				break;
			case NOISE:
				atype = 2;
				break;
		}
		drawattention(atype,kcont,onum,MASTER,OVERLAY2,intens);
	}
}
