#define NOKCBOUND
#define USEHULL
/*
 * drawattention.c	Jim Piper		17-10-86
 *
 * Draw attention to an object by lighting up its boundary.
 * This routine assumes that the boundary exists in the "kcontrol"
 * structure, copies into the current processor, and displays
 * it in specified colour and intensity (thus permitting removal).
 *
 * An attention type parameter "atype" has been included in case
 * we wish a different type of attention.
 *
 *****************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	When		What
 * ---	----		----
 * JP	30-07-87	Use atype parameter to draw box or hull
 * JP	14-11-86	If boundary fails because object too large, get the hull.
 *			If IRS, use the hull anyway (switch USEHULL).
 * JP	13-11-86	On compile-time switch, don't use kcontrol boundary, but
 *			make it here explicitly, and free after use.
 * JP	29-10-86	Use pre-made boundary in kcontrol structure, and make and
 *			insert boundary if not already there (unfinished).
 *****************************************************************************
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <multip.h>



drawattention(atype,kcont,onum,p,c,i)
struct kcontrol *kcont;
{
	struct object *bobj = NULL;
	int hull=0;
#ifdef NOKCBOUND
	struct object **ool, *obj, *mpcopyobj(), *ibound(), *convhull();
#else NOKCBOUND
	struct object *kcbound();
#endif NOKCBOUND
	struct pframe *f;

	colour(c);
	intens(i);
/*	lwidth(2);	*/
	f = (struct pframe *) convaddr(kcont->f,MASTER,p);
#ifdef NOKCBOUND
	if (p == MASTER)
		obj = (struct object *) kcont->ool[onum];
	else {
		ool = (struct object **) convaddr(kcont->ool,MASTER,p);
		obj = mpcopyobj(convaddr(ool[onum],MASTER,p),MASTER,p,0);
		obj->plist = NULL;
	}
#ifndef USEHULL
	bobj = ibound(obj,1);
	/*
	 * an enormouse object may not produce a boundary
	 * because of boundary stack overflow - get the hull.
	 */
	if (bobj == NULL) {
		bobj = convhull(obj);
		hull = 1;
	}
#else USEHULL
	switch (atype) {
		case 1:
			bobj = convhull(obj);
			hull = 1;
			break;
		default:
			break;
	}
#endif USEHULL
#else NOKCBOUND
#ifndef USEHULL
	bobj = kcbound(kcont,onum,p);
	/*
	 * an enormouse object may not produce a boundary
	 * because of boundary stack overflow - get the hull.
	 */
	if (bobj == NULL) {
		bobj = kchull(kcont,onum,p);
		hull = 1;
	}
#else USEHULL
	bobj = kchull(kcont,onum,p);
	hull = 1;
#endif USEHULL
#endif NOKCBOUND
	switch (atype) {
		case 1:
			picframe(bobj,f);
			break;
		case 2:
		default:
			bdisprect(obj,f);
			break;
	}
#ifdef NOKCBOUND
	if (p != MASTER)
		freeobj(obj);
#else NOKCBOUND
	if ((hull == 0 && p != kcont->oth[onum].procb) ||
		(hull == 1 && p != kcont->oth[onum].proch))
#endif NOKCBOUND
		if (bobj != NULL)
			freeobj(bobj);
/*	lwidth(1);	*/
}
