/*
 * enhance.c		Jim Piper @ I.R.S.		20-08-86
 *
 * Laplacian enhancement of chromosome in karyogram
 *
 * Modifications
 *
 *  11 Apr 1989		SEAJ	Swapped over white and black for varenhance
 *  10 Mar 1989		SEAJ	Added variable enhancement.
 *	11 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>
#include <seqpar.h>
#include <kcontrol.h>

/*
 * 5 by 5 with relative central weight +0.5
 */
int lpl5[25] = {
	-1, -1, -1, -1, -1,
	-1,  0,  1,  0, -1,
	-1,  1, 20,  1, -1,
	-1,  0,  1,  0, -1,
	-1, -1, -1, -1, -1
};

struct convolution laplac5 = {
	1,
	5,
	&lpl5[0]
};


struct object *enhance(obj)
struct object *obj;
{
	int convolve(), (*convolvept)();
	struct object *eobj, *seqpar();
	convolvept = convolve;
	eobj = seqpar(obj,1,0,0,2,0,&laplac5,convolvept);
	normalise(eobj);
	return(eobj);
}
/*
 * V A R E N H A N C E -- Variable enhancement
 *
 */
struct object *varenhance(obj, enh)
struct object *obj;
struct enhancement *enh;
{
	int convolve(), (*convolvept)();
	struct object *eobj, *seqpar();
	
	convolvept = convolve;
	eobj = seqpar(obj,1,0,0,2,0,enh->conv,convolvept);
	if (enh->white != 0 || enh->black != 0)
		htnormalise(eobj, (float)(enh->black)/10, (float)(enh->white)/10);
	else
		normalise(eobj);
	return(eobj);
}	
