/*
 * kary.c		10/6/85		Jim Piper
 *
 * interactively karyotype a file of previously rotated 
 * and classified chromosomes.
 *
 * Modifications
 *
 *	 3 dec 1986		CAS			Don't die with 'wrong type' error, just ignore
 *								the offending object and kary on..
 */

#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>

/* THESE EXTERNALS WILL BE STUCK IN A STRUCTURE SOON */
struct text *textobj;
struct cellid *cellinformation;
int SHANDON = 0;
int VIDEORECORD = 0;
int aspectr = 0;
int DOWN = 0;
int thereiscellinfo = 0;

kary(kc)
struct kcontrol *kc;
{
	struct chromosome *obj;
	struct chromplist *plist;
	struct text  *gettextinfo();
	struct cellid  *getinformation();
	int i,ac;

	/*
	 * read objects
	 */
	for (i=0; i<kc->maxnumber; i++) {
		ac = kc->acl[i];
		ac &= ACTIVE;
		if (ac != 0) {
			if (obj=kc->mol[i]) {
#ifdef DEBUG
				fprintf(stderr,"obj %d active, type %d\n",i,obj->type);
#endif DEBUG
				plist = obj->plist;
				if (obj->type != 1 || plist == NULL) {
					fprintf(stderr,"%d: wrong type or no property list\n",i);
					kc->acl[i] &= ~ACTIVE;
				} else
					initialorientation(i,kc);
			}
		}
	}

	/* check classification and display */
	classify(kc);
	karyogram(kc);
	displayall(kc);
	kinteract(kc);
}
