/*
 * manualstraight.c		Jim Piper @ I.R.S.		20-08-86
 *
 * Mkcontrol test program manual straightening
 *
 * Modifications
 *
 *	05 Mar 1990		dcb		Remove overlay definitions, and include display.h
 *	11 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>
#include <interact.h>
#include <kcontrol.h>
#include <display.h>

#define SCALE 24

/*
 * segment a composite, return the number of derived objects
 */
struct object *manualstraight(kcont,obj)
struct kcontrol *kcont;
struct object *obj;
{
	struct object *mpol, *interactpoly();
	struct polygondomain *pdom, *uspaxis8();
	struct object *strobj, *straighten();
	struct intervaldomain *idom;
	struct pframe f;
	int i,k;
	
	idom = obj->idom;
	f.type = 60;
	f.ix = f.iy = 1;
	f.scale = SCALE;
	f.dx = f.dy = 2048;
	f.ox = (idom->kol1 + idom->lastkl)/2;
	f.oy = (idom->line1 + idom->lastln)/2;
	colour(GREYCOLS);
	intens(1);
	picframe(obj,&f);
	mpol = interactpoly(KEYBOARD,&f,f.ox,idom->line1,kcont->terminal);
	if (mpol == NULL) {
		return(NULL);
	}
	/*
	 * This polygon will be a bit rough and will have arcs of widely
	 * differing lengths.  So the treatment is
	 *	(1) Multiply by 8 (rather than use floating point)
	 *	(2) Unit space
	 *	(3) Smooth.  Need to use multiple calls to "polysmooth(pdom,1)"
	 *		since e.g. "polysmooth(pdom,3)" would overflow short integers.
	 *	(4) Unit space again
	 */
	pdom = (struct polygondomain *) mpol->idom;
	polymult(pdom,8);
	f.scale /= 8;
	f.ox *= 8;
	f.oy *= 8;
	colour(OVERLAY1);
	intens(1);
	mpol->idom = (struct intervaldomain *) uspaxis8(pdom);
	free(pdom);
	pdom = (struct polygondomain *) mpol->idom;
	polysmooth(pdom,1);
	polysmooth(pdom,1);
	polysmooth(pdom,1);
	mpol->idom = (struct intervaldomain *) uspaxis8(pdom);
	picframe(mpol,&f);
	free(pdom);
	colour(GREYCOLS);
	f.scale *= 8;
	f.ox /= 8;
	f.oy /= 8;
	strobj = straighten(obj,mpol,1,&f);
	freeobj(mpol);
	return(strobj);
}
