/*
 *		M O D C O U N T . C
 *
 * Modifications
 *
 *	05 Mar 1990		dcb			Remove overlay defns, and include display.h
 *	20 Nov 1986		CAS			Extra param in countdisp
 *	19 Nov 1986		CAS			Extra param to dispotype
 */
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <display.h>

/*
 * modify the "count" of an object (the number of
 * chromosomes which it contains, essentially),
 * and change its type appropriately
 */
modcount(obj,inc,f,numchroms)
struct chromosome *obj;
struct pframe *f;
int *numchroms;
{
	struct chromplist *plist;
	
	plist = obj->plist;
	intens(0);
	countdisp(*numchroms,1);
	typedisp(obj);
	dispotype(obj,f,1);
	if (inc > 0) {
		switch(plist->otype) {
			default:
			case 1:		/* chromosome */
			case 2:		/* composite */
			case 3:		/* overlap */
				plist->otype = 2;
				break;
			case 4:		/* noise */
			case 5:		/* nucleus */
			case 6:		/* piece */
				plist->otype = 1;
				break;
		}
		plist->history[2]++;
		(*numchroms)++;
	} else {
		switch(plist->otype) {
			default:
			case 1:		/* chromosome */
				plist->otype = 4;	/* noise */
				plist->history[2] = 0;
				(*numchroms)--;
				break;
			case 2:		/* composite */
			case 3:		/* overlap */
				plist->history[2]--;
				if (plist->history[2] == 1)
					plist->otype = 1;	/* chromosome */
				(*numchroms)--;
				break;
			case 4:		/* noise */
				plist->otype = 5;	/* nucleus */
				break;
			case 5:		/* nucleus */
				plist->otype = 6;	/* piece */
				break;
			case 6:		/* piece */
				plist->otype = 4;	/* noise */
				break;
		}
	}
	intens(1);
	countdisp(*numchroms,1);
	colour(OVERLAY2);
	typedisp(obj);
	dispotype(obj,f,1);
}

