/*
 * segfuncs2.c		11/11/85		Jim Piper
 *
 *****************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	When		What
 * ---	----		----
 * JP	14-11-86	Fix segundo for object probable typing stuff.
 * JP	12-11-86	includes
 * JP	29-10-86	"segcomp()" and "segovlp()" now call "probotype()".
 * JP	29-10-86	"segjoin" modified to correspond to new "getonum()".
 * JP	28-10-86	Objects resulting from split now "UNKNOWN"
 *****************************************************************************
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <interact.h>
#include <kcontrol.h>
#include <display.h>


/*
 * segment a composite, return the number of derived objects
 */
segcomp(kcont,objnum)
struct kcontrol *kcont;
{
	struct chromosome *obj, **objlist;
	struct object **marklist;
	struct object *polyobj, *interactpoly(), *blobmark();
	struct chromplist *plist, *qlist, *makechromplist();
	SMALL *activelist;
	struct intervaldomain *idom;
	struct pframe *f;
	int i,k;
	
	objlist = kcont->ool;
	marklist = kcont->bol;
	f = kcont->f;
	activelist = kcont->acl;
	
	obj = objlist[objnum];
	idom = obj->idom;
	intens(0);
	picframe(marklist[objnum],f);
	tsize(50,50);
	frameobjnum(objnum+1,obj,f);
	intens(1);
	fprintf(stderr,"split with cursor (? for more help)\n");
	polyobj = interactpoly(KEYBOARD,f,(idom->kol1+idom->lastkl)/2,
		(idom->line1+idom->lastln)/2,kcont->terminal);
	if (polyobj == NULL) {
		picframe(marklist[objnum],f);
		frameobjnum(objnum+1,obj,f);
		return(1);
	}
	/* split original and picture results */
	polysplit(obj,polyobj,&objlist[kcont->maxnumber],&k);
	freeobj(polyobj);
	activelist[objnum] &= ~ACTIVE;
	qlist = (struct chromplist *)obj->plist;
	qlist->otype = 2;	/* composite */
	qlist->Cotype = 2;	/* composite */
	qlist->otconf = 100;
	qlist->history[1] = 1;	/* manually split */
	for (i=kcont->maxnumber; i<kcont->maxnumber+k; i++) {
		marklist[i] = blobmark(objlist[i]);
		picframe(marklist[i],f);
		frameobjnum(i+1,objlist[i],f);
		objlist[i]->plist = makechromplist();
		plist = (struct chromplist *)objlist[i]->plist;
		plist->number = i+1;
		plist->pnumber = objnum+1;
		plist->otype = UNKNOWN; 	/* not necessarily chromosome */
		plist->history[0] = 1;	/* result of manual split */
		activelist[i] = ACTIVE;
		probotype(objlist[i]);
		checkattention(1,i,kcont);
		colour(OVERLAY1);
	}
	kcont->maxnumber += k;
	return(k);
}

#define WIDTH 8

/*
 * segment an overlap, return the number of derived objects
 */
segovlp(kcont,objnum,j)
struct kcontrol *kcont;
{
	struct chromosome **objlist;
	struct object **marklist;
	struct object *polyobj, *interactpoly(), *blobmark();
	struct object *ibound(), *boundlist[20];
	struct chromplist *plist, *qlist, *makechromplist();
	SMALL *activelist;
	struct intervaldomain *idom;
	struct pframe *f;
	int i,k;
	
	objlist = kcont->ool;
	marklist = kcont->bol;
	f = kcont->f;
	activelist = kcont->acl;
	
	idom = objlist[objnum]->idom;
	intens(0);
	picframe(marklist[objnum],f);
	tsize(50,50);
	frameobjnum(objnum+1,objlist[objnum],f);
	intens(1);
	k = 0;
	for (i=kcont->maxnumber; i<kcont->maxnumber+j; i++) {
		fprintf(stderr,"Draw axis of chromosome %d using cursor (? for more help)\n",i+1);
		polyobj = interactpoly(KEYBOARD,f,
			(idom->kol1+idom->lastkl)/2,(idom->line1+idom->lastln)/2,
			kcont->terminal);
		/*
		 * If interaction killed, need to tidy up
		 */
		if (polyobj == NULL) {
			intens(0);
			for (i=0; i<k; i++) {
				picframe(boundlist[i],f);
				freeobj(boundlist[i]);
				objlist[kcont->maxnumber+i]->vdom = NULL;
				freeobj(objlist[kcont->maxnumber+i]);
			}
			intens(1);
			return(1);
		}
		/* extract object and picture results */
		objlist[i] = (struct chromosome *) extractov(objlist[objnum],polyobj,WIDTH);
		freeobj(polyobj);
		objlist[i]->plist = makechromplist();
		plist = objlist[i]->plist;
		plist->number = i+1;
		plist->pnumber = objnum+1;
		plist->otype = UNKNOWN; 	/* not necessarily chromosome */
		plist->history[0] = 2;	/* result of manual extraction from overlap */
		probotype(objlist[i]);
		checkattention(1,i,kcont);
		colour(OVERLAY1);
		boundlist[k] = ibound(objlist[i],1);
		picframe(boundlist[k],f);
		k++;
	}
	activelist[objnum] = 0;
	qlist = objlist[objnum]->plist;
	qlist->Cotype = 3;	/* overlap */
	qlist->otype = 3;	/* overlap */
	qlist->otconf = 100;
	qlist->history[1] = 2;	/* manually segmented */
	for (i=kcont->maxnumber; i<kcont->maxnumber+j; i++) {
		activelist[i] = 1;
		marklist[i] = blobmark(objlist[i]);
		picframe(marklist[i],f);
		frameobjnum(i+1,objlist[i],f);
	}
	intens(0);
	for (i=0; i<j; i++) {
		picframe(boundlist[i],f);
		freeobj(boundlist[i]);
	}
	intens(1);
	kcont->maxnumber += j;
	return(j);
}


/*
 * join two objects
 */
segjoin(kcont,j0,j1)
struct kcontrol *kcont;
{
	struct chromosome **objlist;
	struct object **marklist;
	struct object *uobjl[2], *unionn(), *blobmark();
	struct chromplist *plist, *qlist, *makechromplist();
	SMALL *activelist;
	struct pframe *f;
	int i,j,k;
	
	objlist = kcont->ool;
	marklist = kcont->bol;
	f = kcont->f;
	activelist = kcont->acl;
	
	intens(0);
	tsize(50,50);
	for (j=0; j<=1; j++) {
		i = j==0? j0: j1; 
		picframe(marklist[i],f);
		frameobjnum(i+1,objlist[i],f);
		activelist[i] = 0;
		qlist = objlist[i]->plist;
		qlist->otype = 4;	/* piece */
		qlist->Cotype = 4;	/* piece */
		qlist->otconf = 100;
		qlist->history[1] = 4;	/* manually joined */
		uobjl[j] = (struct object *) objlist[i];
	}
	intens(1);
	objlist[kcont->maxnumber] = (struct chromosome *) unionn(uobjl, 2, 1);
	marklist[kcont->maxnumber] = blobmark(objlist[kcont->maxnumber]);
	picframe(marklist[kcont->maxnumber],f);
	frameobjnum(kcont->maxnumber+1,objlist[kcont->maxnumber],f);
	objlist[kcont->maxnumber]->plist = makechromplist();
	plist = (struct chromplist *)objlist[kcont->maxnumber]->plist;
	plist->number = kcont->maxnumber+1;
	plist->pnumber = j0;		/* 1st parent */
	plist->history[3] = j1;	/* 2nd parent */
	plist->otype = 1; 	/* chromosome */
	plist->otconf = 100;
	plist->history[0] = 4;	/* result of manual join */
	activelist[kcont->maxnumber] = 1;
	kcont->maxnumber++;
}


/*
 * undo an interaction
 */
segundo(kcont,objnum)
struct kcontrol *kcont;
{
	struct chromosome **objlist;
	struct object **marklist;
	struct chromplist *plist, *qlist;
	SMALL *activelist;
	struct pframe *f;
	int i,k,parent,numchange;
	
	objlist = kcont->ool;
	marklist = kcont->bol;
	f = kcont->f;
	activelist = kcont->acl;
	
	plist = objlist[objnum]->plist;
	numchange = 0;
	tsize(50,50);
	switch (plist->otype) {
	case 0:
		/*
	 	* find if derived object, find parent
	 	*/
		parent = plist->pnumber;
		if (parent <= 0) {
			fprintf(stderr,"Object %d now assumed to be a chromosome\n",objnum+1);
			plist->otype = 1;
			activelist[objnum] |= ACTIVE;
			return(1);
		}
		/* else drop through to correct chromosome action */
	case 1:
		/*
	 	* find if derived object, find parent
	 	*/
		parent = plist->pnumber;
		if (parent <= 0) {
			fprintf(stderr,"NOT a valid derived object\n");
			return(0);
		}
		/*
	 	 * find other derived objects and permanently de-activate
	 	 */
		intens(0);
		for (i=0; i<kcont->maxnumber; i++) {
			if (activelist[i] & ACTIVE != 0 &&
					objlist[i]->plist->pnumber == parent) {
				picframe(marklist[i],f);
				frameobjnum(i+1,objlist[i],f);
				activelist[i] &= ~ACTIVE;
				if (objlist[i]->plist->otype <= 1)
					numchange--;
			}
		}
		/*
	 	 * re-activate and re-display parent
	 	 */
		intens(1);
		parent--;
		qlist = objlist[parent]->plist;
		qlist->history[1] = 0;
		qlist->otype = qlist->Cotype = 1;
		picframe(marklist[parent],f);
		frameobjnum(parent+1,objlist[parent],f);
		activelist[parent] |= ACTIVE;
		numchange++;
		/*
		 * if a join, get other parent
		 */
		if (plist->history[0] == 4) {
			parent = plist->history[3] - 1;
			qlist = objlist[parent]->plist;
			qlist->history[1] = 0;
			qlist->otype = qlist->Cotype = 1;
			picframe(marklist[parent],f);
			frameobjnum(parent+1,objlist[parent],f);
			activelist[parent] |= ACTIVE;
			numchange++;
		}
		return(numchange);

	case 2:
	case 3:
	case 4:
	case 5:
	default:
		fprintf(stderr,"Object %d now assumed to be a chromosome\n",objnum+1);
		plist->otype = 1;
		activelist[objnum] |= ACTIVE;
		return(1);
	}
}
