/*
 *     G E N E R A L . C -- General functions.
 *
 *
 *  Written: Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    20th June 1989.
 *
 *  Modifications
 *	16 Jan 1991	dcb		Freeptr moved to free_structs.c
 *	11 Jan 1991	dcb		Protect next_word from overrunning internal char buf.
 *	02 Jan 1990	dcb		Remove scrn_scroll (Now in gplib)
 *
 */
#include <stdio.h>
/*
 * Forward declarations
 */
char *skipword(), *skipwhite();
/*
 *	N E X T _ L I N E  --
 *
 */
int
next_line(fd,buffer,len)
int		fd, len;
char	*buffer;
{
	int		cnt;

	while ((cnt = readln(fd,buffer,len)) == 1)		/* loose blank lines */
		;
	if (cnt <= 0)
		return(0);
	else {
		buffer[cnt-1] = '\0';
		return(cnt);
	}
}
/*
 *	S K I P W O R D  --
 *
 */
char *
skipword(str)
char	*str;
{
	while (*str && (*str != ' ') && (*str != '\t'))
		str++;
	str = skipwhite(str);
	return(str);
}	
/*
 *	S K I P W H I T E  --
 *
 */
char *
skipwhite(str)
char	*str;
{
	while (*str && ((*str == ' ') || (*str == '\t')))
		str++;
	return(str);
}
/*
 *  N E X T _ W O R D -- Return pointer to next word
 */
char *
next_word(buf)
char *buf;
{
	char string[40], *ret;
	int i = 0;
	
	while (*buf && (*buf != ' ') && (*buf != '\t') && (i<40)) {
		string[i] = *buf;
		i++; buf++;
	}
	string[i] = '\0';
	ret = (char *) Calloc(sizeof(char), strlen(string)+1);
	strncpy(ret, string, strlen(string)+1);
	return(ret);
}
/*
 * F I N D I N D E X -- returns number of string match
 *
 */
int
findindex(string, vars, max)
char *string, *vars[];
int max;
{
	int i = 0;
	
	while ((i < max) && (matchword(string, vars[i])))
		i++;
	return(i);
}
/*
 * M A T C H W O R D
 *
 */
int
matchword(str1, str2)
char *str1, *str2;
{
	while((*str1 != '\0') && (*str2 != '\0')) {
		if (toupper(*str1 & 0x7f) != toupper(*str2 & 0x7f))
			return(1);
		str1++;
		str2++;
	}
	return(0);
}

/*
 *	I T O A -- Convert number(s) to ascii
 *	Beware: Total string length must be < 60!
 */
char *
itoa(fmt, num1, num2)
char *fmt;
int num1, num2;
{
	char *ch;
	static char buf[60]; /* Please don't overrun */
	int arg=0;

	for (ch=fmt; *ch; ch++) if (*ch == '%') arg++;
	switch (arg) {
		case 0:	sprintf(buf, fmt);
				break;
		case 1:	sprintf(buf, fmt, num1);
				break;
		case 2:	sprintf(buf, fmt, num1, num2);
				break;
	}
	return(buf);
}

/*
 *	S C R N _ C L R E O S -- Clear from cursor pos to end of screen
 */
scrn_clreos()
{
	printf("\033[0J"); fflush(stdout);
}

/*
 *	S T R S A V E --	Copy string to a safe place
 *						Return pointer to it if successful, else NULL
 */
char *
strsave(str)
char *str;
{
	char *p, *Malloc();

	if (( p= Malloc(strlen(str) + 1)) != NULL) /* get space */
		strcpy(p, str);	/* copy it there */
	return(p);
}

/*
 *	S T R N S A V E --	Copy n characters somewhere safe, and place NULL
 *						at the end of the string
 */
char *
strnsave(str, n)
char *str;
int n;
{
	char *p, *Malloc();

	if (( p = Malloc(n + 1)) != NULL) {/* get space */
		strncpy(p, str, n);	/* copy it there */
		*(p+n) = '\0';
	}
	return(p);
}

/*
 *	M O D S C O R E S -- This gets called but its functionality is
 *							not needed, make it null function
 */
/*modscores()
{
}
*/

