/*
 *	E R R O R . C -- Error handling, and error logging functions
 *
 *  Written: Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    26th January 1990
 *	These are functions collected from elsewhere (system.c)
 *
 *  Modifications
 *	09 Apr 1990	dcb		Icrease buffer size
 *
 */
#include <stdio.h>
#include <version.h>
#include <kyy.h>

#define ERRORLOG "/dd/sys/syserrors"

/*
 *	M E M E X I T F N   --  Memory alloc errors come here
 *
 */
memexitfn(err,str)
int		err;
char	*str;
{
	char	buffer[100];
	sprintf(buffer,"Memory error %d %s\n",err,str);
	errorlog(buffer);
	fprintf(stderr,"Memory corruption error\n");
	kill(getpid(),WOOLZSIG);
}

/*
 *	E R R O R L O G  --  Write messsage to error log file
 *
 */
errorlog(message)
char	*message;
{
	char	buffer[256];
	int		fd, time, date, day, tick;

	if ((fd = open(ERRORLOG,2)) == -1)
		if ((fd = create(ERRORLOG,2,0x1b)) == -1) 
			return(0);
	lseek(fd,0,2);		/* get to eof */
	_sysdate(0,&time,&date,&day,&tick);
	sprintf(buffer,"%02d/%02d/%02d %02d:%02d  %s (seat %d) (V%s) ",
		date&255, (date>>8)&255, (date>>16)&65535,
		(time>>16)&255, (time>>8)&255, _prgname(), alc->seat, VERSION);
	writeln(fd,buffer,strlen(buffer));
	writeln(fd,message,strlen(message));
	close(fd);
}

