/*
 *		K Y Y . H  --   definitions for metaphase finder control system
 *
 * Modifications
 *
 *	11 Feb 1992		jimp			Altered MASKs for MRC
 *	15 Jan 1991		CAS			Right mask for HCS camera
 *	16 Jul 1990		CAS			Remove clashing ourop def
 *	06 Nov 1989		dcb			Mask left 50% wider, mask top 40% narrower
 *	23 Feb 1989		CAS			Increase left mask to 10 from 8 for pulnix camera
 *	30 Jan 1989		CAS			Added shading-edgs and mask defines
 *	 1 Dec 1988		CAS			WOOLZSIG belongs in application not library 
 *								so moved back
 *	18 Nov 1988		dcb			WOOLZSIG moved to wtcheck.h
 *	19 Aug 1988		SCG			Classifier structs moved to class.h;
 *	03 May 1988		SCG			Modified rankcf and introduced two new
 *								structures for classifier training 
 *	13 Aug 1987		SCG			Normal/Abnormal defines removed
 *	06 Aug 1987		SCG			Removed rcdline, not used anymore
 *	 2 Jun 1987		CAS			Move cyto_file structure to fileheaders.h
 *	22 May 1987		SCG			Removed box struct (slides.h) and list ptrs
 *	 5 Feb 1987		CAS			Kmr/mf signals
 *								Move slide stuff into slides.h
 *	 9 Jan 1987		SCG			Introduced rsub string for subset.
 *								removed ranking.
 *	 8 Jan 1987		CAS			Symbolic sizes in struct cyto_file
 *	17 Dec 1986		CAS			Removed hhh struct
 *	10 Dec 1986		CAS			Added cyto_file struct
 *	14 Nov 1986		jimp		Symbolic name of chromosome types is already
 *								in chromanal.h, so deleted here.
 *	13 Nov 1986		jimp		OVERLAY defs picked up from <display.h>
 *	17 Oct 1986		CAS			Removed MAXOBJ (Use MAXOBJS in chromanal)
 *	 6 Oct 1986		CAS			Moved OVERLAY defs to here, and added
 *								kmr - mf signal defs
 *	18 Aug 1986		CAS			Moved cfippparams to cfipp.h
 *	16 Jul 1986		CAS			Added cfipparams structure
 *	10 Jun 1986		GJP			Added diginfo structure
 *	17 May 86    	Denis       notsecondary        
 * 								fipops mnemonics
 *	11 Oct 1985		Mark Mckie	stain and tissue type added
 *	27 Aug 1985		D.Rutovitz	HOMEDIR and datadir
 *	   Aug 1985		Denis		metaphase record redefinition
 *								inclusion of woolz struct.h and obj refrences
 *	   Jul 1985		Denis R		cmdsys form
 *	   Jun 1985		Margaret S	cytel  form
 *		   1984		G Shippey	revel  form
 */

#ifndef KYY_H
#define KYY_H
#ifndef EXTERN
#ifdef INIFILE
#define EXTERN
#endif
#ifndef INIFILE
#define EXTERN extern
#endif
#endif

#include <wstruct.h>
#include <allcontr.h>

/*
 *	System global data structures
 */
EXTERN struct allkontr *alc;

/*
 *	System global files
 */
EXTERN FILE *fp;

/*
 *  global data used by review program
 */
#define MAXSTRING 64
#define MAXCOMS 512
#define COMSTART '!' /* start of comment records */
#define NULLSTRING ""

#define ANY       1
#define REVIEWED  2
/* bit codes for 'fclass' in records structure */
#define JUNK	  2
#define USABLE    4
#define UNUMET	  8			/* unusable, but metaphase */

#ifdef INIFILE
	unsigned int bit[] = {1,2,4,8,16,32,64,128} ;
	int lastact = 0;
#else
	extern unsigned int bit[8];
	extern int lastact ;		/* 0 - none, 1- search, 2-digitise 
						           for microscope objective warnings */
#endif

/*
 *	Edge masking - how much to hit
 */
#define MASKTOP		2		/* */
#define MASKBOT		0
#define MASKLEFT	15
#define MASKRIGHT	15		/* for Sony camera */
#define EDGE		4		/* Shading correction Number of edge pixels to ignore */


struct diginfo {
	char  validcoord ;		/* signal non zero if x and y valid */
	short xcoord ,
		  ycoord ,			/* x and y coordinates of metphase spread */
		  chromcount ;		/* count of number of chromosoms */
	char karyotyped ;		/* indication of the karyotype stage */
	
};

	

/* list format control */
EXTERN int outstyle;	/* if explicitly set non-zero,overides defaults*/
EXTERN int ourstyle;	/* actual format */
EXTERN int (*cv_fn_ptr) ();	/* Pointer to function which converts list
						coordinates to microscope coordinates. */



EXTERN int sumout;


EXTERN int listnr;		/* digitised object number */
EXTERN int showmets;	/* signal for metfind time display */
EXTERN int doshade;		/* control shading in capture and findmet 
						   values: -1  shading done in capture
						            0  no shading done
						            1  shading done in findmet */
EXTERN int talk,italk;
EXTERN char esub[160];	/* caption showing current selection */
EXTERN char isub[160];	/* caption showing current selection */
EXTERN char rsub[160];	/* caption showing current selection */
/*EXTERN char ourop[11];	/* current operator name */
EXTERN int xs,ys,zs;	/* stage coordinates */

/*EXTERN struct object *objlist[MAXOBJS];*/

/* EXTERN struct hstruct *hhh;  header record structure
		( this is equivalenced to the clustdat pointer */

/*
 *	Miproc communication routine flags
 */
#define PROMPT ':'
#define FOR_CTRLD  -1	 /* detect CTRL+D after CTRL+Q and return 0 */
#define FOR_WSIG   -2	 /* expect control sequence CTRL+Q BW : */
#define FOR_WORD   -5	/* look for 'word_wanted' */
#define FOR_QUIET  -6	/* wait for Miproc to go quiet */
#define FOR_DSIG   -7	 /* look for digitise signal (BD after CTRL+Q) */
EXTERN int notsecondary;

/*
 *	KMR - MF  Interprocess signals
 *	Note: WOOLZSIG is now defined in wtcheck.h
 */
#define MF_DIES		10		/* Sent by MF before it dies (hopefully never) */
#define KMR_INT		23		/* Int signal from kmr */
#define MF_INT		33
#define WOOLZSIG	50		/* Send to self if fatal woolz error */

/*
 *	Colour overlays for Monitor screen
 */
#include <display.h>

#endif KYY_H

