/*
 * 	Copyright (c) and intellectual property right Image Recognition Systems (1988)
 *
 *	File:	metscan.h
 *
 *		Header file containing all the default values for metaphase
 *		scan parameters.
 *
 *	Written by: S C Georgiou
 *				720 Birchwood Boulevard
 *				Birchwood Science Park
 *				Warrington
 *				Cheshire
 *
 *	Date: 30th January 1987
 *
 *
 *	Modifications:
 *
 *	11 Dec 1989		dcb			Increase upper threshold limit to 80
 *	16 May 1989		dcb			DEFDRANGE back to 2, increasing range OK now
 *	09 Feb 1989		dcb			DEFDRANGE -> 6 for new afe board (old boards
 *								are unaffected by this change).
 *	19 Aug 1988		SCG			Removed many defines to class.h
 *	18 Jul 1988		SCG			Defines for filing
 *	20 Jun 1988		SCG			octareamax at 4000
 *	06 May 1988		SCG			Modified and extended classifier defines
 *	13 Jan 1988		SCG			threshold defaults now in sysinit
 *	23 Jul 1987		CAS			ON/OFF -> stdio, removed FOCS
 *	21 Jul 1987		CAS			Remove all focus setup -> now done in sysinit
 *	16 Jul 1987		SCG			shap1, shap2 changed from 350,350 to 250,0
 *								candidates 1000 and defined default box
 *	14 Jul 1987		CAS			MINTHR reduced to 8 (from 9)
 *								Added FMAXEX - focus max excursion
 */

/*
 * defines to aid list filing
 */
#define SELECT 1
#define SCORE 2
#define RSCORE 3

/*
 * Default scan box size 
 */
#define BYLLIM -10000
#define BYHLIM 23000
#define BXLLIM -9500
#define BXHLIM 9500

#define MCELLS 1000						/* Number of candidates */
#define MSWATHE 200						/* Number of swathes */
#define DEFDRANGE 2						/* Default density range */
#define DOSHADE 0						/* For shading correction 
										   0 no shading in met finding
										   or capture */
#define SHADSW 3000	
#define YGATE 2							/* CCD array width (1024) */
#define MAXTHR 80						/* Max upper thold */
#define MINTHR 8						/* Min upper thold */

 
