/*
 *	P R E P S . H  --  Prep relevant stuff
 *
 *
 *  Written: Clive A Stubbings
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    23rd July 1987
 *
 * Modifications
 *
 */

#ifndef PREPS_H
#define PREPS_H
#include <fileheaders.h>


/*
 *	Structure kept in alc and mult_slide structs for met/kary classification
 */
struct cyto_types {
		int	ktistype,
			kfstype;
	};
	
/*
 *	Preparation data
 *
 *	This is global data read from file.  All installations must have numerically
 *	compatible data to allow information exchange.  Further work is required 
 *	where this impinges on met finding coefficients
 */
#define DEF_NUM_CHR 24

struct tisdata {
	int	index,
		numchr;
	char	descr[40];
};

struct stndata {
	int		index;
	char	descr[40];
};

#endif PREPS_H
