/*
 * flex.c		Jim Piper and Bill Hill @MRC		23-10-90
 *
 * Overall menu control of the flexible screen.....
 *
 * MODIFICATIONS
 * -------------
 * 24-06-91 ih		Check for null flex screen in fles filing
 * 29-01-91 jimp	Modified main menu messages back again after cheeky
 *			fax from Jonathan Tunstall....
 * 19-01-91 jimp	Modified main menu messages to conform to IRS spec
 *			(although I don't actually agree with the spec).
 * 21-12-90 jimp	Renamed Flex_ImpFile() to Flex_Filing(), called
 *			the write/read/replace menu.
 * 20-12-90 BH		Put flex globals into the flex_status structure
 * 06-12-90 jimp	Reversed meaning of (L) and (R) for compatibility
 *			with moving in karyogram display.
 *
 */
#include <stdio.h>
#include <cmdsys.h>
#include <kyy.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <display.h>
/*#include <dispform.h>*/
#include <fileheaders.h>
#include <flex.h>
#include <allcontr.h>

extern FILE *debug_channel;
extern struct allkontr *alc;
extern int	flex_CopyObj(),
		flex_Initialise(),
		flex_menu(),
		flex_PickUp(),
		flex_PutDown();
extern void	flex_Terminate();
extern FILE *debug_channel;

int		flex_Main();
static int	flex_Filing();

extern struct kcontrol *kcont;
extern struct ipoint cursor;

/************************************************************************
* Function:	flex_Main						*
* Returns:	int:			always 0			*
* Purpose:	Flexible screen main function, initialise flex screen	*
*		and process main menu.					*
* Parameters:	int Phase:		phase of interaction where 0 is	*
*					segmentation and 1 karyotyping.	*
************************************************************************/
int		flex_Main(Phase)
int		Phase;
{
  int		ExitCmd,
		Option;

  setextradisp(NULL);
  flex_Initialise(Phase);
  newmenu("Copy to Flexible Screen");
  cmmd("select/deselect chromosome ;%f", flex_PickUp);
  mouse(MIDBT);
  cmmd("transfer chromosome ;%f", flex_CopyObj);
  mouse(LEFTBT);
  cmmd("position chromosome ;%f", flex_PutDown);
  mouse(RIGHTBT);
  cmmd("format flexible screen ;%+i%f", alc->flex_screen, flex_menu);
  mouse(LONGMB);
  cmmd("filing;%f", flex_Filing); mouse(LONGRB);
  ExitCmd = cmmd("exit");
  mouse(LONGLB);
  while(((Option = thismu()) != 0) && (Option != ExitCmd))
    ;
  flex_Terminate();
  return(0);
}

/************************************************************************
* Function:	flex_Filing						*
* Returns:	int:			always 0			*
* Purpose:	call the filing menu
* Parameters:	-							*
************************************************************************/
static int	flex_Filing()
{
	if (alc->flex_screen)
		flex_file_menu(&(alc->flex_screen));
	else {
		if (alc->debug)
			fprintf(debug_channel,"flex_Filing passed NULL alc->flex_screen pointer\n");
		fprintf(stderr,"flex_Filing passed NULL alc->flex_screen pointer\n");
	}
	return(0);
}
