/*
  A PROBLEM WITH FINDING THE ROOT OF THE TREE BY CHASING ->assoc --
  WHAT IF THE TOP LEVEL IS EXTENDED... IT'S ATTACHED TO "FS".
  FOR NOW, JUST PRINT A WARNING AND GIVE UP ......
*/ 
/*
 * flextest.c		Jim Piper and Bill Hill @MRC		07-11-90
 *
 * Test of the routines in flexsubs.c
 *
 * MODIFICATIONS
 * -------------
 * 18-12-90 jimp	Forced to include "allcontrol" things, regretfully.
 *			This requires "../common/common.l", which permits
 *			us to remove "memexitfn()", "mousecurs()" from here.
 * 29-11-90 jimp	Option "-I" for running on "IRS" system -
 *			frame-store #2 at 0x400000, mouse on /t5
 * 27-11-90 jimp	Added mousecurs() TEMPORARILY (from ident.c)
 * 26-11-90 jimp	Added menu control and mouse tracking tests...
 *
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <display.h>
#include <fileheaders.h>
#include <flex.h>

#define INIFILE 1
#include <cmdsys.h>
#include <allcontr.h>
/*
 * Globals (have to go somewhere)
 */
struct allkontr *alc;
struct kcontrol *kcont;
FILE *debug_channel = NULL;

main(argc,argv)
char **argv;
{
	struct flexible_screen *fs, *flex_make();
	int memexitfn(), frig();
	FILE *in, *out, *fbopen();
	int IRS = 0;

	setbuf(stderr,NULL);
	setmemalloc(48*1024);
	Alloc_exit(memexitfn);
	while (argc > 2 && argv[1][0] == '-') {
		switch (argv[1][1]) {
			case 'I' :
				IRS++;
				break;
			default:
				fprintf(stderr,"Try -I\n");
				break;
		}
		argc--;
		argv++;
	}

	if (IRS) {
		mouseport("/t5");		/* Where we want the mouse to be */
		ddgsopen(4,1);
	}
	else {
		mouseport("/t2");		/* Where we want the mouse to be */
		ddgsopen(4,0);
	}

	muini(stdout);				/* Init cmdsys + mouse */

	dinit();
	llut();
	lutoverlays();
	clear();
	in = fbopen(argv[1],"r",2048);

	alc = (struct allkontr *)Calloc(1,sizeof(struct allkontr));
	alc->flex_screen = fs = flex_make(500);
	flex_test_fill(fs,in,25);
	flex_draw_sc(fs,1);

	flex_test_facilities(fs);

	flex_menu(fs);
/*
	flex_frames_small(fs);
	flex_draw_sc(fs,1);
	flex_menu(fs);

	out = fbopen("flextest.out","w",2048);
	writeobj(out,fs->cao);
	flex_del_sc(fs);
*/
	alldone(0);

	finish();
}


/*
 * Test the merge/join/check/display facilities
 */
flex_test_facilities(fs)
struct flexible_screen *fs;
{
	flex_frames_big(fs);
	flex_group_nd(fs->cao->o[2],fs->cao->o[3]);
	flex_group_nd(fs->cao->o[4],fs->cao->o[5]);
	flex_group_nd(fs->cao->o[2],fs->cao->o[4]);
	flex_group_nd(fs->cao->o[12],fs->cao->o[13]);
	flex_group_nd(fs->cao->o[14],fs->cao->o[15]);
	flex_merge_nd(fs->cao->o[12],fs->cao->o[14]);
	
/*
	flex_ungroup_nd(((struct compounda *)fs->cao->o[2])->o[1]);
	flex_check_sc(fs);
*/
	clear();
	flex_draw_sc(fs,1);
}



/*
 * Fill a compound object with n leaf nodes based
 * on image objects read from a disc file.
 */
flex_test_fill(fs,in,n)
struct flexible_screen *fs;
FILE *in;
int n;
{
	int i,j=1;
	struct object *o, *readobj();
	struct compounda *ca, *flex_fill_next_slot();

	colour(GREYCOLS);
	for (i=0; i<n; i++) {
		o = readobj(in);
		if (o == NULL)
			return(0);
		if (o->type != 1)
			i--;
		else {
			ca = flex_fill_next_slot(fs,o,4,j);
			flex_draw_objs_nd(ca);
			j *= -1;
		}
	}
}


int quit_fn()
{
}



lutoverlays()
{
	int i;
	for (i=1; i<255; i+=2)
		setrgb(i,0,0,255);
	for (i=2; i<255; i+=4) {
		setrgb(i,255,0,0);
		setrgb(i+1,255,0,0);
	}
}	

