/*
 *		C H R O M B I S . C
 *
 *  Written: Denis Rutovitz.
 *           MRC CAPCU Edinburgh.
 *
 *	MRC Propietary Software.
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 *
 *	Date:	14th Dec 1985
 *
 *
 * Modifications
 *
 *	14 Feb 1989		CAS			trivial cosmetics
 *	23 May 1988		CAs			remove superfluous llut in dispgo
 */
#include <stdio.h>
#include <wstruct.h>
#include <multip.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <allcontr.h>
#include <display.h>

static struct object *bound = NULL;
extern struct object *ibound();
extern struct allkontr *alc;
extern struct kcontrol *kcont;
static slave, maxsla;
static iwas;


/*
 *	S H O W B O U N D  --
 *
 */
showbound(iselect,onoff)
int		iselect, onoff;
{
	if (bound) {	
		intens(0);
		picframe(bound,kcont->f);
		intens(1);
		freeobj(bound);
		bound = NULL;
		if (iwas == iselect) return;
	}
	if (onoff) {
		bound = ibound(kcont->ool[iselect-1],1); 
		colour(OVERLAY1);
	    picframe( bound ,kcont->f);
	    iwas = iselect;
	}
}

/*
 *	D I S P G O
 *
 */
dispgo() {
	myfrig();
	fast();
	mpclear(kcont) ;
	slow();
	intens(1);
}

/*
 *	S T A R T F M E A S 
 *
 */
startfmeas() {
		fmeasstart(kcont);
		if (bound) showbound(0,0);
}

/*
 *	M Y F R I G  --  load look-up-table addresses
 *					 so that planes zero and 1 function as overlays
 */
myfrig() {
	register int i;
	for (i=1; i<127; i+=4) {
		setrgb(i,255,0,0);
		setrgb(i+2,0,255,0);
		setrgb(i+1,0,0,255);
	}
	for (; i<=255; i+=4) {
		setrgb(i,255,255,0);
		setrgb(i+2,255,0,255);
		setrgb(i+1,255,255,0);
	}
}

/*
 *	D I S P A L L  --  display the objects
 */
dispall()
{
	int i;
	cellframe(kcont);
	makemarks(kcont);
	colour(GREYCOLS); 
	mastdisplay(kcont);
	/* do a quick fix on probable object types before displaying */
	for (i=0; i<kcont->maxnumber; i++)
		probotype(kcont->ool[i]);
	colour(OVERLAY1);
	tsize(50,50);
	dispblobs(kcont);
	kcont->mstatus |= SEGBEGIN;
}

waitfeats(k) {
		waitfmeas( k); 
/* GJP		elapsedtime();   */
}

