/*
 *		F L E X _ S C R E E N . C -- Flexible screen tests
 *
 *           Written:	David Burgess
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1990)
 *
 *  Modifications
 *
 */
#include <cmdsys.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <multip.h>
#include <allcontr.h>
#include <display.h>
/*#include <interact.h>*/
#include <seg_control.h>
#include <dispform.h>

#define KSCALE 8		/* Default kary display scale */
#define NORMAL 1
#define CHANGE 2
#define ABNORMAL	25
#define RADIANS 	.01745
#define BORDER 20
#define MAX(i,j)	(((i)>(j))? (i): (j))
#define MIN(i,j)	(((i)<(j))? (i): (j))

/*
 * external variables
 */
extern struct allkontr *alc;
extern struct kcontrol *kcont;
static struct chromosome **objlist;
/*struct kident kid1, kid2;*/
static *gotcell;

/*
 *	F L E X _ S C R E E N -- Display kary in 1/4 screen
 */
flex_screen(phase)
{
	struct chromosome **mol;
	struct pframe *ivf, f;
	int i;

	initflex();
	displayall(phase);

/*	mol = kcont->mol;
	ivf = kcont->ivf;
	ivf->scale = 4;
	for (i=1; i<kcont->maxnumber; i++) {
		modframe(&f, ivf);
		picframe(mol, f);
		mol++;
		ivf++;
	}
*/
}

/*
 *	M O D F R A M E -- Modify frame for 1/4 screen display
 */
modframe(f, ivf)
struct pframe *f, *ivf;
{
	f->type = ivf->type;
	f->scale = ivf->scale/2;
	f->dx = ivf->dx/2;
	f->dy = ivf->dy/2;
	f->ox = ivf->ox/2;
	f->oy = ivf->oy/2;
	f->ix = ivf->ix/2;
	f->iy = ivf->iy/2;
	f->func = NULL;
}

/*
 *	I N I T F L E X -- Initialise screen for flexible screen transfer display
 */
initflex()
{
	int i, xmax, ymax, xmin, ymin;
	int xsplit, ysplit;
/*	setframe(kcont->f,8);	*/	/* Cursor frame */
	xmax = alc->ddgschannel->lineln << alc->ddgschannel->xshift;
	ymax = alc->ddgschannel->lineno << alc->ddgschannel->yshift;
	xsplit = xmax/2;
	ysplit = ymax/2;
/*
	cursor.l = xsplit;
	cursor.k = ysplit;
*/
	qclear();
	lwidth(3);
	colour(255 & ~(OVERLAY1|OVERLAY2));
	moveto(0,ysplit); lineto(xmax,ysplit);
	moveto(xsplit,0); lineto(xsplit,ymax);
	lin_colour_lut();					/* Set linear LUT + overlay colours */
	lwidth(1);
	colour(GREYCOLS);
}
