/*
 * kary.c		10/6/85		Jim Piper
 *
 * interactively karyotype a file of previously rotated 
 * and classified chromosomes.
 *
 *   2 May 1991		ih			Avoid null objs - woolz exit signal if bad woolz object instead of exit(2)
 *	 2 Dec 1988		CAS/SEAJ	Moved call to reorderchr to kary() from karyogram()
 *	29 Sep 1986		cas			Removed ref to 'gettextinfo'
 *	16 Sep 1986		CAS/GJP		km/kr -> kmr
 *	15 May 1985		GJP			Add extra parameter of dispcellinfo to displayall
 *	15 May 1986		GJP			Set SHANDON up 
 *	 7 May 1986		GJP			Debugs removed  
 */

#include <stdio.h>
#include <kyy.h>
#include <chromanal.h>
#include <signal.h>
#include <kcontrol.h>

/* THESE EXTERNALS WILL BE STUCK IN A STRUCTURE SOON */
extern struct text *textobj;
struct cellid *cellinformation;
int SHANDON = 1;
extern int VIDEORECORD;
extern int aspectr;
extern int DOWN;

kary(kc)
struct kcontrol *kc;
{
	struct chromosome *obj;
	struct chromplist *plist;
/*	struct text  *gettextinfo(); */
	struct cellid  *getinformation();
	int i,ac;

	/*
	 * read objects
	 */
	for (i=0; i<kc->maxnumber; i++) {
		ac = kc->acl[i];
		ac &= ACTIVE;
		if (ac != 0) {
			if (obj = kc->mol[i]) {
				plist = obj->plist;
				if (obj->type != 1 || plist == NULL) {
					fprintf(stderr,"%d: wrong type or no property list\n",i);
					kill(getpid(),WOOLZSIG); /* signal a woolz type error to shutdown*/
				}
				initialorientation(i,kc);
			}
		}
	}

	/* check classification and display */
	classify(kc);
	karyogram(kc);
	reorderchr(kc);			/* reorder chromosomes according to confidence level
								if first attempt a karyogram */
	displayall(kc,0);
}
