/*
 *		V A R E N H A N C E M E N T . C -- Variable enhancement.
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 *
 *
 *  Modifications
 *
 *  11 Jun 1991		ih		Check for null objlist before notgood
 *   1 Feb 1991 	ih		Added a #include <flex.h> for new field in alc
 *							This also implies the need for file_headers.h since
 *							struct cyto_file is defined in there and used in flex.h
 *							I think any .h file that depends on defs in other .h
 *							files should automatically #include them but you
 *							have to be aware of multiple #defines then.
 *	29 Jan 1991	JimP@MRC	Added switch for flexible screen to
 *					singleenhance().
 *					SPOTTED A NASTY IN setup_varenh(), DID
 *					NOT FIX IT, BUT LEFT A COMMENT.
 *	19 Jul 1990		dcb		enhanceopt: take extra phase param. & pass to adjustlut
 *  16 Jul 1990		dcb		Put back look up table adjust into enhancement options
 *	21 Mar 1990		ih		Set default enhance to all
 *	22 Sep 1989		dcb		setup_varenh: Only grab enhancement structure once
 *							enhanceopt: enclose menu line & mouse opt in braces
 *  18 Apr 1989		SEAJ	Added mouse button to varenhance setup.
 */
#include <cmdsys.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <multip.h>
#include <fileheaders.h>
#include <flex.h>
#include <allcontr.h>
#include <display.h>

#define MAXNORM 200
#define MAXLEVEL 15
#define MATRIXFILE "/dd/params/matrixfile"
/*
 * external variables
 */
extern struct allkontr *alc;
extern struct kcontrol *kcont;
extern struct ipoint cursor;
extern struct kident kid1;
extern FILE *debug_channel;
extern int kycurs();
extern int adjustlut();
extern struct object *varenhance();
extern char *skipwhite(), *skipword();
/*
 * statics used only in this module
 */
static struct mat_list {
	int number;
	int matrix[25];
	struct mat_list *next;
};
static int enh_level = 0, norm_black = 0, norm_white = 0, default_level = 0, 
		   beensetup = 0;
static struct chromosome **objlist;

int varenh_menu(), inc_dec();
/*
 * E N H A N C E M E N T -- call either dohance or allhance
 *
 */
enhancement(from, single, type)
int from, *single, type;
{
	if (from == SEGMENT) {
		switch(type) {
			case 2 :
				metenhance();
				break;
			case 4 :
				metrestore();
				break;
			case 5 :
				methtnormalise();
				break;
		}
	} else {
		if (*single)
			dohance(type);
		else
			allhance(type);
	}
}
/*
 * D O S T R I N G -- copy whether single or all into given string
 *
 */
static
dostring(single, string)
int *single;
char *string;
{
	if (*single)
		strcpy(string, "single");
	else
		strcpy(string, "all");
}
/*
 *	E N H A N C E N O P T  --
 *
 */
enhanceopt(from, phase)
int from, phase;
{
	int single = 0;
	int d1=1, d2=1;
	char string[8];

	objlist = (struct chromosome **) kcont->mol;
	dostring(&single, string);
	newmenu("Enhancement Options");
	if (from == KARYOTYPE) {
		cmmd("single/all;%+t:k40%-s%f", &single, string, dostring);
	}
	cmmd("normalise;:k40%+i%-+d%+i%f", from, &single, 5, enhancement);mouse(RIGHTBT);
	cmmd("enhance;:k40%+i%-+d%+i%f", from, &single, 2, enhancement); mouse(LEFTBT);
	cmmd("recover;:k40%+i%-+d%+i%f", from, &single, 4, enhancement); mouse(LONGMB);
	cmmd("variable enhancement setup;%+i%f", from, varenh_menu); mouse(LONGRB);
	cmmd("look-up-tables;%-+d%-+d%+i%f", &d1, &d2, phase, adjustlut); mouse(MIDBT);
	while (thismu());
}
/*
 * S I N G L E E N H A N C E -- enhance single chromosome in master
 *				(though in flexible screen, enhance
 *				whatever is currently selected).
 *
 */
singleenhance(from)
int from;
{
	switch (from) {
 		case KARYOTYPE:
			sing_kar_enh();
			break;
		case SEGMENT:
			sing_met_enh();
			break;
		case FLEXIBLE_SCREEN:
			if (alc->flex_screen != NULL)
				flex_enhance_ms(alc->flex_screen);
			break;
		default:
			printf("Singleenhance - invalid FROM %d\n",from);
			break;
	}
}
/*
 * S I N G _ K A R _ E N H -- single karyotype enhance
 *
 */
sing_kar_enh()
{
	struct chromosome *nobj, *eobj;

	if (!objlist||!objlist[kid1.no]) return(0);
	if (notgood(0)) return(0);
	erasecursor();
	unkdisplay(&kid1, kcont);
	if (objlist[kid1.no] != kcont->kol[kid1.no]) {
		eobj = objlist[kid1.no];
		eobj->plist = NULL;
		freeobj(eobj);
		objlist[kid1.no] = kcont->kol[kid1.no];
	}
	nobj = (struct chromosome *) varenhance(objlist[kid1.no], kcont->enh);
	objlist[kid1.no] = nobj;
	kdisplay(&kid1, kcont);
	setmsv(kycurs);
}
/*
 * S I N G _ M E T _ E N H -- single metaphase enhance
 *
 */
sing_met_enh()
{
	struct object *nobj;
	
	colour(GREYCOLS);
	intens(1);
	if (kcont->acl[kcont->current_obj-1] & ACTIVE) {
		nobj = varenhance(kcont->ool[kcont->current_obj-1], kcont->enh);
		picframe(nobj, kcont->f);
		if (nobj != NULL) {
			nobj->plist = NULL;
			freeobj(nobj);
		}
	}
	colour(OVERLAY1);
}
		
/*
 * D I S P M A T R I X -- display full matrix on screen
 *
 */
dispmatrix(on)
int on;
{
	char string[20];
	int i;
	
	if (kcont->enh != NULL) {
		colour(OVERLAY2);
		intens(on);
		tsize(40, 40);
		for (i=0; i<5; i++) {
			sprintf(string, "%3d %3d %3d %3d %3d", kcont->enh->matrix[i*5], 
				kcont->enh->matrix[(i*5)+1], kcont->enh->matrix[(i*5)+2], 
				kcont->enh->matrix[(i*5)+3], kcont->enh->matrix[(i*5)+4]);
			dispstring(string, 1200, 200+(i*80));
		}
	}
}	
/*
 * S E T U P _ V A R E N H --
 *
 */
setup_varenh(from, top)
int from;
struct mat_list *top;
{
	struct mat_list *ptr;
	int i;

	if (kcont->enh != NULL && alc->debug)
		dispmatrix(0);	
	if (kcont->enh == NULL)
		kcont->enh = (struct enhancement *)Calloc (1, sizeof(struct enhancement));
	kcont->enh->white = norm_white;
	kcont->enh->black = norm_black;
	ptr = top;
	while (ptr != NULL && ptr->number != enh_level)
		ptr = ptr->next;
	if (ptr != NULL) {
		for (i = 0; i < 25; i++)
			kcont->enh->matrix[i] = ptr->matrix[i];
	} else {
		fprintf(stderr, "There is no matrix with this number\n");
		return(0);
	}
/* SURELY, THIS SHOULD BE DONE ONLY IF kcont->enh WAS "NULL" ?? */
	kcont->enh->conv = (struct convolution *) Calloc(1, sizeof(struct convolution));
/****************************************************************/
	kcont->enh->conv->size = 5;
	kcont->enh->conv->type = 50;
	kcont->enh->conv->cv = kcont->enh->matrix;
	if (alc->debug)
		dispmatrix(1);	
	singleenhance(from);
}
/*
 * E N H A N C E _ S T R I N G -- Display the current state of the variable enhancement
 *
 */
enhance_string()
{
	char str[10];
	
	if (enh_level == 0)
		sprintf(str, "Off");
	else if (enh_level == default_level)
		sprintf(str, "Default");
	else
		sprintf(str, "%d", enh_level);
	screengo(OUTLINE - 2, 0);
	printf("Enhance level %9s normalisation black %3d white %3d\n",
											str, norm_black, norm_white);
	putprompt();
}
/*
 * F R E E L I S T
 *
 */
freelist(ptr)
struct mat_list *ptr;
{
	struct mat_list *prev;

	prev = ptr;
	while (ptr != NULL) {
		ptr = ptr->next;
		Free(prev);
		prev = ptr;
	}
}
/*
 * R E A D _ M A T R I X _ F I L E -- read matrices from file and setup list
 *
 */
struct mat_list *
read_matrix_file(def, white, black, only)
int *def, *white, *black, only;
{
	int fd, line, i;
	char buffer[200], *buf, filename[80];
	struct mat_list *p = NULL, *ptr = NULL;

	if (alc->matrixfile != NULL)
		strcpy(filename, alc->matrixfile);
	else
		strcpy(filename, MATRIXFILE);
	if ((fd = open(filename, 1)) == -1) {
		fprintf(stderr, "Unable to open matrix file.\007\n");
		return(ptr);
	}
	while (nextbufline(fd, buffer, sizeof(buffer))) {
		buf = buffer;
		buf = skipwhite(buf);
		if (strncmp(buf, "default", 7) == 0) {
			buf = skipword(buf);
			buf = skipwhite(buf);
			*def = atoi(buf);
			buf = skipword(buf);
			buf = skipwhite(buf);
			*white = atoi(buf);
			buf = skipword(buf);
			buf = skipwhite(buf);
			*black = atoi(buf);
			if (only) {				/* only defaults required */
				enh_level = *def;
				break;
			}
		} else if (isdigit(*buf)) {
			if (ptr == NULL) {
				ptr = (struct mat_list *) Calloc(1, sizeof(struct mat_list));
				p = ptr;
				p->next = NULL;
			} else {
				p->next = (struct mat_list *) Calloc(1, sizeof(struct mat_list));
				p = p->next;
				p->next = NULL;
			}
			p->number = atoi(buf);
			for (line = 0; line < 3; line++) {
				for (i= 0; i < 3; i++) {
					buf = skipword(buf);
					buf = skipwhite(buf);
					p->matrix[(line*5) +i] = atoi(buf);
				}
				/* reflect about middle column */
				p->matrix[(line*5) + 3] = p->matrix[(line*5) + 1];
				p->matrix[(line*5) + 4] = p->matrix[line*5];
				/* reflect about middle row */
				if (line < 2) {
					for (i = 0; i < 5; i++)
						p->matrix[20 + i - (line*5)] = p->matrix[(line*5) + i];
				}
			}
		}
	}
	close(fd);
	return(ptr);
}
/*
 * V A R E N H _ M E N U -- menu to change the type of enhancement performed
 *
 */
varenh_menu(from)
int from;
{
	static int def_white = 0, def_black = 0;
	int black = 1, inc = 2, one = 1, cmd, i;
	struct mat_list *top;
	
	if ((top = read_matrix_file(&default_level, &def_white, &def_black, 0)) == NULL)
		return (0);
	if (!beensetup) {
		enh_level = default_level;
		norm_white = def_white;
		norm_black = def_black;
		beensetup = 1;
	}
	while (1) {
		downmenu();
		newmenu("variable enhancement setup");
		cmmd("increase enhancement level;:k40%-+d%+i%+i%-+d%f%-f", &one, 1, MAXLEVEL, 
							&enh_level, inc_dec, enhance_string);mouse(LONGRB);
		cmmd("decrease enhancement level;:k40%-+d%+i%+i%-+d%f", &one, 0, MAXLEVEL,
							&enh_level, inc_dec);mouse(LONGLB);
		if (black) {
			cmmd("normalise increase/decrease black;:k40%+t", &black);mouse(LONGMB);
			cmmd("increase black;:k40%-+d%+i%+i%-+d%f", &inc, 1, MAXNORM, &norm_black, 
							inc_dec);mouse(RIGHTBT);
			cmmd("decrease black;:k40%-+d%+i%+i%-+d%f", &inc, 0, MAXNORM, &norm_black, 
							inc_dec);mouse(LEFTBT);
		} else {
			cmmd("normalise increase/decrease white;:k40%-t", &black);mouse(LONGMB);
			cmmd("increase white;:k40%-+d%+i%+i%-+d%f", &inc, 1, MAXNORM, &norm_white, 
							inc_dec);mouse(RIGHTBT);
			cmmd("decrease white;:k40%-+d%+i%+i%-+d%f", &inc, 0, MAXNORM, &norm_white, 
							inc_dec);mouse(LEFTBT);
		}
		cmmd("accept and enhance;:k40%+i%-+d%f", from, top, setup_varenh);mouse(MIDBT);
		cmmd("normalise increment/decrement;:k40%d", &inc);
		cmmd("restore default values;:k40%-+d%-+d%-+d%+i%f", &default_level, 
								&norm_white, &norm_black, 1, read_matrix_file);
		
		while (cmd = thismu()) {
			enhance_string();
			if (cmd == 3) {
				upmenu();
				break;
			}
		}
		if (cmd == 0) {
			freelist(top);
			if (alc->debug)
				dispmatrix(0);
			break;	/* normal exit */
		}
	}
	upmenu();
}
/*
 * I N C _ D E C -- increment or decrement value supplied by amount supplied
 *
 */
inc_dec(inc, increase, maximum, number)
int *inc, increase, maximum, *number;
{
	if (increase)
		*number += *inc;
	else
		*number -= *inc;
	if (*number < 0)
		*number = 0;
	if (*number > maximum)
		*number = maximum;
}

