/*
 *			B O X C O R N S  --  Set up scan box using co-ords
 *								 from microscope
 *
 * Modifications
 *
 *	 2 Mar 1989		CAS			Remove old MIZAR/VAX defines
 *	 1 Apr 1987		CAS			Trap fail of 'getpos'
 *	 3 feb 1987		CAS			Redraw screen box after each co-ord entered.
 *								Assume that top-left entered first (although
 *								it makes no odds either way)
 *	 7 Aug 1986		GJP			Remove the cmdspace includes
*/
#include <cmdsys.h>
#include <kyy.h>

static int setflag=0;			/* Count how many corners we have */
static int x,y;					/* Prev corner */
static int *xl,*xh,*yl,*yh;		/* local pointers to save having to pass
									them in cmdsys */
static xyset();
/*
 */
cornerset(x1,x2,y1,y2,mbox) 
int *x1,*x2,*y1,*y2;
struct box *mbox;
{
	setflag=x=y=0;
	xl=x1;
	xh=x2;
	yl=y1;
	yh=y2;
	newmenu("set box");
	cmmd ("set corners;%g%-+d",xyset,mbox);mouse(RIGHTBT);
	cmmd ("return");mouse(MIDBT);
	while (thismu() && (nncmd != 2));
}

/*
 *	X Y S E T
 */
static
xyset(mbox)
struct box *mbox;
{
	if (getpos(-1) == -1) return;
	if(!setflag) {
		dwb(0);				/* erase old box */
		*yl = ys;
		*xl = xs;
		slidelimits(xl,xh,yl,yh);
		slide_to_box(mbox,*xl,*xh,*yl,*yh);
/*
 *		mbox->btop =  YMID - ((ys-800)  / CONV );
 *		mbox->bleft =  XMID + (xs / CONV );
 */
		dwb(2,mbox,1,1); /* show scanned area */
		fprintf(stderr,"Please select other corner\n");
	} else {
		if(y>ys){ *yl=ys;*yh=y;}
		else {*yl=y;*yh=ys;}
		if(x>xs){ *xl=xs;*xh=x;}
		else {*xl=x;*xh=xs;}
		if (alc->devel || alc->debug)
			fprintf(stderr,"xl %d xh %d yl %d yh %d\n",*xl,*xh,*yl,*yh);
		dwb(0);				/* erase old box */
		slidelimits(xl,xh,yl,yh);
		slide_to_box(mbox,*xl,*xh,*yl,*yh);
/*
 *		mbox->bbot =  YMID - ((*yh+800)  / CONV );
 *		mbox->btop =  YMID - ((*yl-800)  / CONV );
 *		mbox->bleft =  XMID + (*xl / CONV );
 *		mbox->bright =  XMID + (*xh / CONV );
 */
		dwb(2,mbox,1,1); /* show scanned area */
	}
	x=xs; y=ys;
	setflag = setflag==0 ? 1 : 0;	 
}

