/*
 *      C C O N V _ M E N U . C  --  Coordinate conversion menus
 *
 *	Extracted from mic_conv.c which is a tangled mess.....
 *
 *
 *  Written: Clive A Stubbings
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1991)
 *
 *  Date:    31st July 1991
 *
 *  Modifications
 *
 */
#include	<cmdsys.h>
#include	<cconv.h>

#define SCREENFUL	15
#define	DIRSTART	5
/*
 * S H O W N A M E S -- Show the names of all the microscopes known
 *
 */
shownames()
{
	FILE	*fp;
	struct	microscope mic;
	int		count, flag=0;
	char	buf1[10], buf2[10], buf3[10], buf4[10];
	
	if ((fp = fopen(MSCOPEFILE, "r")) == (FILE *) -1 ) {
		printf("Unable to read microscope file.\007\n");
		return(0);
	}

	vclear(ENDLINE);
	screengo(1, 20);
	printf("Directory of Microscopes\n\n");
	printf("     Number    Name              Z50                A10\n     ------    ----              ---                ---\n");
	count = 0;

	while(read_mic_line(fp,&mic) != -1) {
		printf("     %4d     %-8s  %8s  %8s  %8s  %8s  %2s  %3s\n",
			mic.number, mic.id,
			float_str(buf1,mic.Z50.x), float_str(buf2,mic.Z50.y),
			float_str(buf3,mic.A10.x), float_str(buf4,mic.A10.y),
			mic.left_handed ? "LH" : "RH", mic.inverted ? "INV" : "NON");
		if (++count >= SCREENFUL) {
			count = 0;
	   		if (!go_on()) {
				flag = 1;
				break;
			}
			clearlns(DIRSTART, ENDLINE);
			screengo(DIRSTART, 0);
		}
	}
	fclose(fp);
	if (!flag)
		if (go_on());
	vclear(ENDLINE);
	scrollpart(OUTLINE, ENDLINE);
	setdisplay(BUST);
}


