/*
 *	F I P C O M M . H   --  Mizar/Miproc communications includes
 *
 *
 *	Written: Clive A Stubbings
 *			 Image Recognition Systems
 *			 720 Birchwood Boulevard
 *			 Birchwood Science Park
 *			 Warrington
 *			 Cheshire
 *
 *	Date:	 5th June 1986
 *
 *	Modifications
 *
 *	 2 Dec 1986		CAS		Moved CF_ defines to here
 *	 1 Aug 1986		CAS		Added FS_NFILE
 *
 */
/*
 * 'Good' returns
 */
#define FS_OK	  0				/* General OK return */
#define FS_CFIP   1				/* Talking to Combifip */
#define FS_MIPEX  2				/* Talking to Mipex */
#define FS_MIPMON 3				/* Talking to Mipmon */
/*
 * 'Bad' returns
 */
#define FS_FAIL  -1				/* General fail */
#define FS_NOPEN -2				/* Can't open miproc channel */
#define FS_NECHO -3				/* Miproc failed to echo command */
#define FS_UNKN  -4				/* Unknown prompt */
#define FS_QUIET -5				/* All has gone quiet - no reply */
#define FS_UNEXC -6				/* Unexpected char */
#define FS_NLOAD -7				/* Load failed */
#define FS_NSMPX -8				/* Can't start mipex */
#define FS_NSCFP -9				/* Can't start combifip */
#define FS_NFILE -10			/* Can't open a file */

#define CF_SYNT		1		/* syntax error (prompt !) */
#define CF_ENDST	2		/* Stage has hit endstop */
#define CF_FNFND	3		/* Focus not found */
#define CF_FOCEX	4		/* Focus excessive (either swathe to swathe or
								along swathe */
#define CF_DIGOF	5		/* Digitisation overflow */
#define CF_UNKN		6

