/*	L I S T O P S . C
 *
 *   author: Denis R.			June 1985
 *
 *
 * Modifications
 *
 *	18 Jun 1991		CAS		move_s bolted in to stagepos properly
 *	16 Jul 1991		CAS		Extract menus -> mf_menu
 *	24 Jun 1991		CAS		Support seat 2 prior stage
 */
#include <cmdsys.h>
#include <kyy.h>
#include <slides.h>
/*#include <metscan.h> */
#include <disp_defs.h>


#define TABLENGTH 1920
#define TABWIDTH 240
#define TLY_BOX 2300
#define TLX_BOX 700

/*
 * initilisation of score display structure
 */
static struct item items[3] = {{"Positive", 0, -1}, {"Negative", 0, -1}, 
								{"Unsure", 0, -1}};

static struct boxdisplay fxscores = {
	"Scores", 3, 0, 0, 0, 0, 1, items
};

int		setfx();

char *Malloc();
extern int nowfork();
extern int listend;
extern int aggregate;
/*
 *	Things we export for menu maintenance
 */
char comstring[2][40], scecom[40], chromcom[40];
char *listclasstags[] = { 0, " ", " ", " ", " "};

/* static char *ctags[] = { 0, " ", " ", " ", " "}; */
static char string[20];
static setcom(), notclass();
/*
 *
 *  P U T C O M  --
 *
 */
putcom () 
{
int nc, nc1, nc2, nc3, nc4;
struct	mult_slide	*bp;

	bp = alc->curbay;
	if (bp->startptr == NULL) return(0);

	nc1 = strlen(comstring[0]) + 1;
	nc2 = strlen(comstring[1]) + 1;
	nc3 = strlen(scecom) + 1;
	nc4 = strlen(chromcom) + 1;
	nc = nc1 + nc2 + nc3 + nc4;			/* note four null bytes */
	if(nc == 4) {						/* No comment! */
		bp->currptr->mlrec->com = 0; 
		return(0);
	}
										/* not enough room left for comment*/
	if (nc > bp->comtop - bp->compos) { 
		register char *cpp,*cqq;
		char *newcom;
		int cbig;
										/* enough, and more to grow into */
		cbig = (bp->comtop - bp->combot) * 12 / 10 + COMLONG + nc;
		newcom = Malloc(cbig);
		if (bp->compos) {
			cqq = newcom;
			for (cpp = bp->combot; cpp <= bp->compos; ++cpp) 
												*cqq++ = *cpp;
			Free (bp->combot);
			bp->compos = cqq;
										/* note that comments begin at 
										   alc->combot + 1 (to avoid zero 
										   offset ) */
		} else bp->compos = newcom + 1; 
		bp->combot = newcom;
		bp->comtop = bp->combot+ cbig;
	}
										/* set the pointer into the record */
	bp->currptr->mlrec->com = bp->compos - bp->combot; 
	strcpy(bp->compos,comstring[0]);
	strcpy(bp->compos+nc1,comstring[1]);
	strcpy(bp->compos+nc1+nc2,scecom);
	strcpy(bp->compos+nc1+nc2+nc3,chromcom);
	bp->compos += nc + 1;
	
}
/*
 *
 *  F X T O G  --
 *
 */
fxtog(str)
char	*str;
{

	switch (*str) {
	case 'N':
		strcpy(str, "Positive");
		break;
	case 'P':
		strcpy(str, "Unsure");
		break;
	case 'U':
		strcpy(str, "\0");
		break;
	default:
		strcpy(str, "Negative");
		break;
	}
	modscores(alc->curbay->currptr->mlrec->ufrag, *str, alc->curbay->scp);
	alc->curbay->currptr->mlrec->ufrag = *str;
		
}
/*
 *
 *  C H R O M T O G  -- Three way string toggle
 *
 */
chromtog(str)
char	*str;
{
										/* NULL now and before; put 46,XX */
	if((*str == '\0') && (*chromcom == '\0')) {	
		strcpy(str, "46,XX");
		strcpy(chromcom, "46,XX");
										/* NULL now 46,XY before; put 46,XY */
	} else if(!strcmp(str, "46,XX") && !strcmp(chromcom, "46,XX")) {
		strcpy(str, "46,XY");
		strcpy(chromcom, "46,XY");
										/* NULL now 46,XY before; leave NULL*/
	} else if(!strcmp(str, "46,XY") && !strcmp(chromcom, "46,XY")) {
		*chromcom = '\0';
		*str = '\0';
	} else								/* If not NULL copy whatever typed */
		strcpy(chromcom, str);
}

/*
 *
 *  S E T F X  --
 *
 */
setfx(mpt, str)
struct	mlclust *mpt;
char	*str;
{

	if(mpt->ufrag == 'N')
		strcpy(str, "Negative");
	else if(mpt->ufrag == 'P') 
		strcpy(str, "Positive");
	else if(mpt->ufrag == 'U')
		strcpy(str, "Unsure");
	else 
		*str = 0;
}
/*
 *	C H E K U D I C
 */
chekudic(cs)
char	*cs;
{
int	num;
struct	mlclust *mpt;

	mpt = alc->curbay->currptr->mlrec;
	if(cs)
		num = atoi(cs);	
	else
		num = -1;
	if(num < 0 || num > 255) 
		fprintf(output, "Bad dicentrics count\n");
	else
		mpt->udic = (char) num;
		
	if(mpt->udic == -1)
		*cs = '\0';
	else
		sprintf(cs, "%3d", (int)mpt->udic);
}
/*
 *	C H E K U R I N G
 */
chekuring(cs)
char	*cs;
{
int	num;
struct	mlclust *mpt;

	mpt = alc->curbay->currptr->mlrec;
	if(cs)
		num = atoi(cs);	
	else
		num = -1;
	if(num < 0 || num > 255)
		fprintf(output, "Bad ascentrics count\n");
	else
		mpt->uring = (char) num;
		
	if(mpt->uring == -1)
		*cs = '\0';
	else
		sprintf(cs, "%3d", (int)mpt->uring);
}
/*
 *
 *  S E T S C R C D  --
 *					Set tags for new record in score menu
 *
 */
setscrcd(ii, ir, otype, dn, an, fxs, mstage) 
int	*ii, *ir, *otype, mstage;
char	*dn, *an, *fxs;
{
struct	mlclust	*mpt;
struct	mult_slide	*bp;

	bp = alc->curbay;
	mpt = bp->currptr->mlrec;
											/* Display tags */
	*listclasstags[Junk] = bit[Junk] & mpt->fclass ? '*' : 0 ;
	*listclasstags[Othermet] = bit[Othermet] & mpt->fclass ? '*' : 0 ;
	*ii = bp->nameids.cellno = mpt->recnr;	/* Record number */
	*ir = mpt->qrank;						/* Rank */
	if(mpt->uring != -1)					/* Ascentrics */
		sprintf(an, "%3d", (int)mpt->uring);	
	else
		*an = '\0';
	if(mpt->udic != -1)						/* Dicentrics */
		sprintf(dn, "%3d", (int)mpt->udic);	
	else
		*dn = '\0';
	*otype = chekattr(bp, mpt, bp->minrank,	/* In/out of current subset */
			bp->maxrank);
	setfx(mpt, fxs);						/* Fragiles */
	setcom();
											/* move stage to cell */
	if (alc->config & CONF_FIP) {
/*		if (alc->devel)
 *			move_s(mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff,
 *					 mpt->zval+bp->focslc+bp->zcpoff);
 *		else
 */
			stagepos(mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff,
					 mpt->zval+bp->focslc+bp->zcpoff);
	} else if ((mstage >= 0) && (alc->config & CONF_MSTAGE)) {
		mstagepos(mstage,mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff);
	}
}

/*
 *
 *  S E T S L R C D  --
 *					Set tags for new record in select menu
 *
 */
setslrcd(ii, ir, otype, mstage) 
int	*ii, *ir, *otype;
{
int i, nc1, nc2;
struct	mlclust	*mpt;
struct	mult_slide	*bp;

	bp = alc->curbay;
	mpt = bp->currptr->mlrec;

	*listclasstags[Junk] = bit[Junk] & mpt->fclass ? '*' : 0 ;
	*listclasstags[Usable] = bit[Usable] & mpt->fclass ? '*' : 0 ;
	*listclasstags[Othermet] = bit[Othermet] & mpt->fclass ? '*' : 0 ;
	*otype = chekattr(bp, mpt, bp->minrank,		/* In/out of current subset */
			bp->maxrank);
	*ii = bp->nameids.cellno = mpt->recnr;
	*ir = mpt->qrank;

	if (alc->config & CONF_FIP) {
/*
 *		if (alc->devel)
 *			move_s(mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff,
 *					 mpt->zval+bp->focslc+bp->zcpoff);
 *		else
 */
			stagepos(mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff,
					 mpt->zval+bp->focslc+bp->zcpoff);
	} else if ((mstage >= 0) && (alc->config & CONF_MSTAGE)) {
		mstagepos(mstage,mpt->xval+bp->xcpoff,mpt->yval+bp->ycpoff);
	}

}
/*
 *
 *  S E T C O M  --
 *
 */
static setcom()
{
int i, nc1, nc2, nc3;
struct	mlclust	*mpt;
struct	mult_slide	*bp;

	bp = alc->curbay;
	mpt = bp->currptr->mlrec;

	if (mpt->com)  {
		strcpy(comstring[0], bp->combot+mpt->com); 
		nc1 = strlen(comstring[0]);
		strcpy(comstring[1], bp->combot+mpt->com + nc1 + 1); 
		nc2 = strlen(comstring[1]);
		strcpy(scecom, bp->combot+mpt->com + nc1 + nc2 + 2); 
		nc3 = strlen(scecom);
		strcpy(chromcom, bp->combot+mpt->com + nc1 + nc2 + nc3 + 3); 
	} else {
		*comstring[0] = '\0'; 
		*comstring[1] = '\0'; 
		*scecom = '\0';
		*chromcom = '\0';
	}
}
/*
 *
 *	C L A S S L I N E
 *
 */
classline(type)
int	type;
{
int j, temp; 
char ctemp, done;
struct	mlclust	*mpt;
struct	mult_slide *bp;

	bp = alc->curbay;
	if(bp->startptr == NULL) 
		return(0);
	mpt = bp->currptr->mlrec;
	done = mpt->fclass & (USABLE | JUNK | UNUMET);
	switch(type) {

		case Unclass:
			notclass(Othermet);
			notclass(Usable);
			notclass(Junk);
			break;
		case Othermet:
			notclass(Junk);				/* cant be junk */
			notclass(Usable);			/* cant be usable */
			break;
		case Junk: 
			notclass(Othermet);
			notclass(Usable);
			break;
		case Usable: 		
			notclass(Junk);
			notclass(Othermet);
			if(!(mpt->fclass&USABLE))	/* If usable dont recount */
				bp->usbltot++;
		}
	if(!done)							/* Was not done before, done now */
		bp->revtot++;					/* Has been classified; hence reviewed */
	mpt->fclass |= bit[type];			/* Set appropriate class code */
	*listclasstags[type] = '*';					/* Set star on display */
	return(0);
}
/*
 *
 *	N O T C L A S S
 *
 */
static 
notclass(j) 
{
struct	mlclust	*mpt;
struct	mult_slide *bp;

	bp = alc->curbay;
	if(bp->startptr == NULL)
		return(0);
	mpt = bp->currptr->mlrec;
	
	if (mpt->fclass & bit[j]) {	
		if(mpt->fclass & bit[j] & USABLE)	/* Keep track of usables */
			bp->usbltot--;
		mpt->fclass &= ~bit[j];
	}
	*listclasstags[j] = '\0';
}

/*
 *	C L A S S N U M --
 */
classnum(mpt)
struct	mlclust *mpt;
{

	if(mpt == NULL)
		return(0);
	if(mpt->fclass&USABLE)
		return(Usable);
	else if(mpt->fclass&JUNK)
		return(Junk);
	else if(mpt->fclass&UNUMET)
		return(Othermet);
	else
		return(0);
}	

/*
 * C L A S S _ S C O R E -- Associate class numbers with metaphase scoring
 * No parameterisation yet !!!
 */
class_score(metscore)
{
	switch(metscore) {
		case 0:
			/* make unclass */
			classline(Unclass);
			break;
		case 1:
		case 2:
		case 3:
			/* make junk */
			classline(Junk);
			break;
		case 4:
		case 5:
			/* make othermet */
			classline(Othermet);
			break;
		case 6:
		case 7:
			/* make usable */
			classline(Usable);
			break;
		default:
			break;
	}
					
} /* end class_score */

/*
 *		C E N T R I T
 *
 *	Returns:
 *		0 - sucess
 *		-1 - fail
 */
centrit(mstage)
int		mstage;
{
	struct	mlclust *mpt;
	struct	mult_slide *bp;
	int		mx, my;

	bp = alc->curbay;
	
	screengo(ENDLINE,1);
	fprintf(output,"Please check cell centred and in focus\n"); 
	if (! go_on()) { 
		setdisplay(BUST);
		return(-1);
	}
	if (bp->startptr != NULL) {
		if (alc->config & CONF_MSTAGE) {
			if (mstage < 0) return(-1);
			mstagegetpos(mstage,&mx,&my);
			setoffsets(bp->currptr->mlrec,mx,my,0);
			printf("Offsets %d %d\n",bp->xcpoff,bp->ycpoff);
		} else {
			if (getpos(2)) return(-1);
			setoffsets(bp->currptr->mlrec,xs,ys,zs);
		}
	}
	return(0) ;
}

/*
 * D I S P T A B L ---
 *
 */
disptabl(sx, sy, ints)
int sx, sy, ints;
{
int spos, sspos, i, xpp;
char sbuf[10];

	/*
	 * draw box outline
	 */	
	moveto(sx, sy);
	intens(ints);
	lwidth(2);
	lineby(TABLENGTH, 0);
	lineby(0, TABWIDTH);
	moveto(sx, sy);
	lineby(0, TABWIDTH);
	lineby(TABLENGTH, 0);

	/*
	 * draw divisions
	 */
	lwidth(1);
	spos = (TABWIDTH * 2) / 3;
	moveto(sx, sy + spos);
	lineby(TABLENGTH, 0);
	
	sspos = (TABLENGTH - 320) / (MAXSCORE + 1);
	moveto(sx + 320, sy);
	lineby(0, TABWIDTH);
	for(i = 0, xpp = sx + 320; i <= MAXSCORE; i++, xpp += sspos) {
		moveto(xpp, sy);
		lineby(0, TABWIDTH);
		sprintf(sbuf, "%d", i);
		moveto(xpp + 32, sy + spos + 32);
		text(sbuf);
	}
	
	/*
	 * draw text
	 */
	tsize(48, 48);
	moveto(sx + 32, sy + 56);
	sprintf(sbuf, "Total");
	text(sbuf);
	moveto(sx + 32, sy + spos + 16);
	sprintf(sbuf, "Score");
	text(sbuf);
}

/*
 * D I S P S C O R E ---
 *
 */
dispscore(sx, sy, scarr, ints)
int sx, sy, *scarr, ints;
{
int sspos, i, xpp; 
char sbuf[10];

	intens(ints);
	tsize(40, 40);
	sspos = (TABLENGTH - 320) / (MAXSCORE + 1);
	moveto(sx + 320, sy);
	lineby(0, TABWIDTH);
	for(i = 0, xpp = sx + 320; i <= MAXSCORE; i++, xpp += sspos) {
		moveto(xpp + 32, sy + 16);
		sprintf(sbuf, "%d", scarr[i]);
		text(sbuf);
	}
}

/*
 * D I S P S C R ---
 *
 */
dispscr(scarr)
int scarr[];
{
int xstart = 10, ystart = 13, i, xp, xinc = 6;

	screengo(ystart, xstart);
	fprintf(output, "Score:");
	screengo(ystart + 2, xstart);
	fprintf(output, "Totals:");
	for(i = 0, xp = xstart + 10; i <= MAXSCORE; i++, xp += xinc) {
		screengo(ystart, xp);
		fprintf(output, "%d", i);
		screengo(ystart + 2, xp);
		fprintf(output, "%d   ", scarr[i]);
	}
}
/*
 * M O D S C O R E S --- modify scores structure
 *
 */
modscores(a, b, scp)
register a, b;
register struct scores *scp;
{
	switch(a) {
	case '\0': 
		break;
	case 'P': scp->fxyes--;
		break;
	case 'N': scp->fxno--;
		break;
	case 'U': scp->fxmaybe--;
		break;
	default:
		break;
	}
	switch(b) {
	case '\0':
		break;
	case 'P': scp->fxyes++;
		break;
	case 'N': scp->fxno++;
		break;
	case 'U': scp->fxmaybe++;
		break;
	default:
		break;
	}
	updatebox(&fxscores, scp->fxyes, scp->fxno, scp->fxmaybe);
	refreshbox(&fxscores);
}

/*
 *	D R A W _ S C O R E S _ B O X
 */
draw_scores_box()
{
	drawbox(TLX_BOX, TLY_BOX, &fxscores);
}

