/*
 *      T O G G L E . C  --  Library modules to allow toggling between live and
 *							clear backgrounds for the Satellite Switching System
 *
 *  Written: Andy Longshaw
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1989)
 *
 *  Date:   21st Aug 1989
 *
 *  Modifications
 *	23 Oct 1989	dcb		Use cval 0 as first value (to give black text)
 *
 */
#include	<cmdsys.h>

static int	cval = 0;

/*
 *	B A C K T O G G L E  --  Toggle text colour
 *
 */
int
back_toggle()
{
	switch(cval) {
		case 0:
			osetrgb(0,0,0,0);
			break;
		case 1:
			osetrgb(0,255,255,255);
			break;
		case 2:
			osetrgb(0,135,135,135);
			break;
	}
	cval = (++cval) % 3;
	return(0);
}


/*
 *	B A C K _ R E S T O R E  -- Reset overlay colour
 *
 */
back_restore()
{
	switch ((cval+2) % 3) {
		case 0:
			osetrgb(0,0,0,0);
			break;
		case 1:
			osetrgb(0,255,255,255);
			break;
		case 2:
			osetrgb(0,135,135,135);
			break;
	}
}		
