/*
 * kcbound.c	Jim Piper		29-10-86
 *
 * Return a boundary address in this processor.  Access and if necessary
 * make and insert the boundary in the kcontrol structure.  The final
 * freeing of the returned object will only function correctly with
 * Clive Stubbings' link count modification to object structures.
 *
 *****************************************************************************
 * This routine will require additional capability in "mpcopyobj()".
 *****************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	When		What
 * ---	----		----
 * JP	31-10-86	Mods to correspond to "kcontrol.h"
 *****************************************************************************
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <multip.h>

struct object *kcbound(kcont,onum,p)
struct kcontrol *kcont;
{
	struct object *obj, *bobj, *mpcopyobj(), **convaddr(), *ibound();
	struct object **ool;
	struct othings *mbol;
	int q;
	mbol = (struct othings *) convaddr(kcont->oth,MASTER,p);
	bobj = mbol[onum].bound;
	q = mbol[onum].procb;
	if (bobj == NULL) {
		if (p == MASTER) {
			mbol[onum].bound = bobj = ibound(kcont->ool[onum],1);
		}
		else {
			ool = convaddr(kcont->ool,MASTER,p);
			obj = mpcopyobj(convaddr(ool[onum],MASTER,p),MASTER,p,0);
			mbol[onum].bound = bobj = ibound(obj,1);
			obj->plist = NULL;
			freeobj(obj);
		}
		mbol[onum].procb = q = p;
	}
	if (p != q)
		bobj = mpcopyobj(convaddr(bobj,q,p),q,p,0);
	return(bobj);
}
