/*
 * kchull.c	Jim Piper		03-11-86
 *
 * Return a convex hull address in this processor.  Access and if necessary
 * make and insert the hull in the kcontrol structure.  The final
 * freeing of the returned object will only function correctly with
 * Clive Stubbings' link count modification to object structures.
 *
 *****************************************************************************
 * This routine will require additional capability in "mpcopyobj()".
 *****************************************************************************
 * MODIFICATION HISTORY
 * --------------------
 * Who	When		What
 * ---	----		----
 *****************************************************************************
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>
#include <multip.h>

struct object *kchull(kcont,onum,p)
struct kcontrol *kcont;
{
	struct object *obj, *bobj, *mpcopyobj(), **convaddr(), *convhull();
	struct object **ool;
	struct othings *mbol;
	int q;
	mbol = (struct othings *) convaddr(kcont->oth,MASTER,p);
	bobj = mbol[onum].hull;
	q = mbol[onum].proch;
	if (bobj == NULL) {
		if (p == MASTER) {
			mbol[onum].hull = bobj = convhull(kcont->ool[onum]);
		}
		else {
			ool = convaddr(kcont->ool,MASTER,p);
			obj = mpcopyobj(convaddr(ool[onum],MASTER,p),MASTER,p,0);
			mbol[onum].hull = bobj = convhull(obj);
			obj->plist = NULL;
			freeobj(obj);
		}
		mbol[onum].proch = q = p;
	}
	if (p != q)
		bobj = mpcopyobj(convaddr(bobj,q,p),q,p,0);
	return(bobj);
}
