/*
 * sl_clear.c		7/11/85		Jim Piper
 *
 ************************************************
 * slave service function to					*
 * clear screen                                 *
 ************************************************
 */


#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>

/*
 * Multi-process clear of screen - split screen into 8 sections,
 * use kcont->auxstat to share these out among the slave
 * processes, use kcont->lock to ensure indivisible access.
 *
 * Bits 0-7 indicate the start of section clears,
 * bits 8-15 indicate corresponding finish of section clears.
 */
sl_clear (slave, kcont)
register struct kcontrol *kcont;
{
	register int i,istart,ifinish,started;

	lock7(&(kcont->lock));
	for (i=0; i<8; i++) {
		istart = 1 << i;
		started = kcont->auxstat & istart;
		if (started == 0) {
			kcont->auxstat |= istart;
			ifinish = istart << 8;
			unlock7(&(kcont->lock));
			partclear(i);
			lock7(&(kcont->lock));
			kcont->auxstat |= ifinish;
		}
	}
	unlock7(&(kcont->lock));
}
