/*
 *			S L _ D E B U G . C	--	Turn on debug for slaves to stderr
 *
 *			Written by: dcb
 *			Image Recognition Systems
 *			720 Birchwood Boulevard
 *			Birchwood Science Park
 *			Warrington
 *			Cheshire
 *			WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems (1988)
 *	Notes:	Based on sl_clear.c
 *
 *  Modifications
 *
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <kcontrol.h>

/*
 *	S L _ D E B U G   -- Set up debugging in the slaves
 */
sl_debug(slave, kcont)
int slave;
register struct kcontrol *kcont;
{
	static int on_off=OFF;

	if (on_off == OFF) {
		Alloc_debug(stderr);
		freeobj_debug(stderr);
		Makestruct_debug(stderr);
		woolz_check_debug(stderr);
		/*
		 * Max level, since there is no access to wclevel. Maybe we can pass
		 * this across later
		 */
		woolz_check_level(3);
		fprintf(stderr, "Slave %d here, debugging on\n", slave);
		on_off = ON;
	}
	else {
		fprintf(stderr, "Slave %d here, debugging off\n", slave);
		on_off = OFF;
	}		
} /* end sl_debug */
