/*
 *      C O N V S C R F O R M A R -- Converts old style screen format 
 *									 structure to new.
 *
 *
 *  Written: Sarah E. A. Jones.
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    8th May 1989
 *
 *  Modifications
 *
 */
#include <stdio.h>
#include <wstruct.h>
#include <chromanal.h>
#include <dispform.h>
/* 
 * Local structures
 */
static struct oldkdisppos {
	int col;		/* DIGS column number of center of area */
	int lin;		/* DIGS line number of base of area */
	int defaultpos;	/* default number of positions for class members */
	int npos;		/* current number of positions for class members */
	int space;		/* DIGS width available */
	char tag[6];	/* character string which names this class */
};
static struct oldscreenform {
		short	size;				/* Structure size */
		short	version;
		struct	databox	idbox;
		struct	oldkdisppos disppos[MAXCLASS];
		int		stacklin;
		int		stackcol[NSTACKPOS+2];
		struct	pos	chromclass;
};
int classhgt[] = {
	800, 800, 800, 700, 700, 500, 500, 500, 500, 500, 500, 500,
	400, 400, 400, 350, 350, 350, 300, 300, 250, 250, 550, 250,
	500
};
/*
 * C O N V S C R F O R M A T
 *
 */
struct screenform *
convscrformat(scrheader)
struct screenform * scrheader;
{
	struct screenform *new;
	struct oldscreenform *old;
	int i;
	
	switch (scrheader->version) {
		case 1 :
			old = (struct oldscreenform *) scrheader;
			new = (struct screenform *) Calloc(sizeof(struct screenform), 1);
			new->version = VERSION;
			new->size = sizeof(struct screenform);
			_strass(&new->idbox, &old->idbox, sizeof(struct databox));
			new->stacklin = old->stacklin;
			new->viewed_stack = VIEWED_STACK;
			for (i = 0; i < NSTACKPOS + 2; i++)
				new->stackcol[i] = old->stackcol[i];
			new->chromclass.x = old->chromclass.x;
			new->chromclass.y = old->chromclass.y;
			for (i = 0; i < MAXCLASS; i++) {
				new->disppos[i].col = old->disppos[i].col;
				new->disppos[i].lin = old->disppos[i].lin;
				new->disppos[i].defaultpos = old->disppos[i].defaultpos;
				new->disppos[i].npos = old->disppos[i].npos;
				new->disppos[i].space = old->disppos[i].space;
				new->disppos[i].height = classhgt[i];
				strcpy(new->disppos[i].tag, old->disppos[i].tag);
			}
			new->linebuf.count=0;
			new->linebuf.lineint=0;
			Free(scrheader);
			return(new);
		case 2 :
			scrheader->linebuf.count=0;
			scrheader->linebuf.lineint=0;
		case 3 :
			return(scrheader);
	}
}

