/*
 *     S C R F O R M A T . H -- Header file for : scrformat.c
 *						 						  cursprocs.c.
 *
 *
 *  Written: Sarah E. A. Jones.
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    30th March 1989.
 *
 *  Modifications
 *  17 July 1991	ih	added linebuf struct to scrform
 */
#define WHITE 0
#define RED 1
#define BLUE 2
#define GREEN 4
#define YELLOW 8
#define VIOLET 16
#define AZURE 32
#define BLACK 64

#define XOFFSET 684
#define YOFFSET 112

#define CHROM 1
#define STACK 2
#define IDBOX 3
#define CHROMCLASS 4
#define IDTEXT 5
#define IDLINE 6

#define ABNORMAL 24

#define LEFT 1
#define RIGHT 2

/*
 * local structures
 */
struct datab {
	struct box b;
	struct idtext cont[MAXTEXT];
};
struct classpos {
	struct box b;
	int defaultpos;
	int npos;
	char tag[6];
};
struct scrform {
	struct datab idbox;
	struct classpos classes[MAXCLASS];
	struct box stk[NSTACKPOS+2];
	struct box chromclass;
	int viewed_stack;
	struct linebuf linebuf;
};
