/*
 * 	S L I D E S . H --
 *
 * Modifications
 *
 *	 5 Feb 1987		CAS		Moved slide stuff here from kyy
 *	30 Jan 1987		SCG		Defines for multiple slide scans
 *	16 Jan 1987		SCG		Max metaphase number increased to 2000.
 *	28/4/86     Denis       re-arrangement of xval,yval; intro xwide,
 *							ywide
 */
#ifndef P2
#define W2(a,b,c)	printf("a b %d c %d\n",b,c);sleep(3)
#define P2(a,b,c)	printf("a b %d c %d\n",b,c)
#define P2N(a,b,c)	/* null version ! */
#endif

/*
 *	Stage/slide stuff
 *
 *	X - Y position (screen coords)
 */
#define SLMYTOP 4000
#define SLMYBOT 490
#define SLMXBOT 1750
#define SLMXTOP 2950
/*
 *	Size of slide on screen (screen coords)
 */
#define SLMWIDE (SLMXTOP-SLMXBOT)	/* Width */
#define SLMHIGH (SLMYTOP-SLMYBOT)	/* */
#define FROSTH  880					/* Height of frosted/label bit */
/*
 *	Scan limits (screen coords)
 */
#define BOTLIM 1100
#define TOPLIM 3185 /* slide simulation limits */
/*
 *	slide -> box translation params
 */
#define XMID 2350
#define YMID 2245 /* midpoint of tv slide equal to New England finder zero */
#define CONV 21.4 /* conversion factor from tv ddgs units to microns */

/*
 *	data structures for Miproc met record
 */
#define COMLONG 241	/* max length of cluster record */
#define RECLONG 32	/* length of cluster record */
#define MAXREC 2000	/* max number of permitted cluster records */
#define HDLONG 64	/* length of header record */
#define IDLONG 9	/* space for specimen id in header record */
#define SLONG 6 	/* space for slide id in header record */
#define SCLONG 4	/* space for scorer's name in header record */
#define TSLONG 12	/* space for tissue-comment in header record */
#define STLONG 10	/* space for fstain-comment in header record */
#define AILONG 10	/* space for aim-comment in header record */
#define SMAX 8		/* space for aim-comment in header record */
#define AV_XOFFSET 45018	/* space for aim-comment in header record */
#define AV_YOFFSET 0	/* space for aim-comment in header record */

struct hstruct { 
/*  0 */ short nrecs;	/* no. of records, excluding header */
/*  2 */ short comments; /* amount of storage requd for comments
			    (on files, appended) */
/*  4 */ short scored;
/*  6 */ char abnormals;
/*  7 */ char dics;
/*  8 */ char frags;
/*  9 */ char rings;
/* 10 */ char patient[IDLONG];
/* 19 */ char slide[SLONG];
/* 23 */ char scorer[SCLONG];
/* 29 */ char date[3];
/* 32 */ char tissue[TSLONG];
/* 44 */ char fstain[STLONG];
/* 54 */ char aim[AILONG];
};
struct clustdat {
	
/*  0 */	short xval;  /* x pos on slide, after Mz reset */
/*  2 */	short yval;  /* y pos on slide after Mz reset */
/*  4 */	short xwide; /* cluster x extent after Mz reset */
/*  6 */	short ywide; /* cluster y extent after Mz reset */
/*  8 */	short zval;
/* 10 */	short nobj;
/* 12 */	short sf;
/* 14 */	short aobj;
/* 16 */	short octa;
/* 18 */	char skt;
/* 19 */	char dv;	/* cluster density variation */
/* 20 */	char inbox;	/* copied here by Mz from Miproc qscore */
/* 21 */	char meanod;
/* 22 */	short qrank;	/* Miproc: char mfscore/qscore  */
/* 24 */	short com; /* pointer to comment relative address (or zero) */
/* 26 */	char fclass;	/* see bit-codes , above [ Miproc xwide ] */
/* 27 */	char quality;   /* user set */
/* 28 */	char udic,ufrag,uring ; /* [Miproc ywide ] */
/* 31 */	char chrom;
};
