/*
 * boundilation.c
 * -----------
 * Ji Liang Apr 5, 1987
 *
 * dilate boundary 
 *
 * 24-08-87	jimp	Return an entire boundary, so that it can be freed.
 * 05-08-87	jl/jp	Malloc, Free, etc..
 */
#include <math.h>
#include <stdio.h>
#include <wstruct.h>
#include <split.h>

struct object *boundilation(plgd, num)
struct polygondomain *plgd;
{
	struct object *obj, *makemain(), *dobj, *fastdilate();
	struct object *ibound(), *bobj;
	struct intervaldomain *idmn, *makedomain();
	struct interval *jp, *jpw;
	struct ivertex *itv = plgd->vtx, *wtx, *pre;
	int line, l1, ll, k1, kl;
	register int i, j, k, tmp, incr;
	int gap, n, sign;

	/*
	 * find the minimum square which can contain the boundary
	 */
	l1 = k1 = BIGVALUE;
	ll = kl = 0;
	n = plgd->nvertices;
	for(i = 0; i < n; i++){
		l1 = MIN(itv->vtY, l1);
		ll = MAX(itv->vtY, ll);
		k1 = MIN(itv->vtX, k1);
		kl = MAX(itv->vtX, kl);
		itv++;
	}
	i = ll - l1 + 1;
	i <<= 1;
	j = 0;
	jp = jpw = (struct interval *) Malloc(sizeof(struct interval) * i);
	wtx = (struct ivertex *) Malloc(sizeof(struct ivertex) * (i + n));
	wtx[j].vtY = itv->vtY;
	wtx[j].vtX = itv->vtX;
	itv = plgd->vtx;
	line = itv->vtY;
	pre = itv;
	itv++;
	for(i = 0; i < n - 1; i++){
		tmp = abs(itv->vtY - line);	
		if(tmp > 1){
			if(itv->vtY > line)
				incr = 1;
			else incr = -1;
			sign = (itv->vtX - pre->vtX) / (itv->vtY - line);
			for(k = 1; k < tmp; k++){
				line += incr;
				wtx[j].vtY = line;
				wtx[j++].vtX = sign*incr + pre->vtX;
			}
		}
		wtx[j].vtY = itv->vtY;
		wtx[j++].vtX = itv->vtX;
		line = itv->vtY;
		pre++;
		itv++;
	}
	/*
	 * double sort 
	 */
	n = j;
	for(gap = n/2; gap > 0; gap /= 2)
		for(i = gap; i < n; i++)
			for(j = i - gap; j >= 0; j -= gap){
				if(wtx[j].vtY > wtx[j + gap].vtY || wtx[j].vtY == wtx[j + gap].vtY && wtx[j].vtX > wtx[j + gap].vtX){
					tmp = wtx[j].vtY;
					wtx[j].vtY = wtx[j + gap].vtY;
					wtx[j + gap].vtY = tmp;
					tmp = wtx[j].vtX;
					wtx[j].vtX = wtx[j + gap].vtX;
					wtx[j + gap].vtX = tmp;
				}
			}
	/*
	 * change polygon to object
	 */
	j = 0;
	for(line = l1; line <= ll; line++){
		jp->ileft = wtx[j].vtX;
		while(wtx[j].vtY == line)
			jp->iright = wtx[j++].vtX;
		jp++;
	}
	Free(wtx);
	idmn = makedomain(1, l1, ll, k1, kl);
	idmn->freeptr = (char *) jpw;
	obj = makemain(1, idmn, 0, 0, 0);
	jp = jpw;
	k = 0;
	for(i = l1; i <= ll; i++){
		jpw = jp;
		jp->ileft -= k1;
		jp->iright -= k1;
		jp++;
		makeinterval(i, idmn, 1, jpw);
		k++;
	}
	for(i = 0; i < num; i++){
		dobj = fastdilate(obj);
		freeobj(obj);
		obj = dobj;
	}
	bobj = ibound(obj, 1);
	freeobj(obj);
	return(bobj);
}
