/*
 * coefmatrix.c
 * -----------
 * Ji Liang Aug 19, 1986
 *
 * solve polynorminal of dgree 3 
 * using mathod of least squars
 * this subroutine only can get 
 * coefficient matrix use algeqe()
 * to get coefficients
 *
 * Modifications
 *
 *	22 Jan 1991		CAS		Localise debug
 *	26 Oct 1987		CAS		Debugging, made power local + return double - was
 *							causing error 107's
 *	13 Apr 1987		jp		LSIZE,KSIZE copied from sosolae.c
 */
#include <math.h>
#include <stdio.h>
#define LSIZE 4
#define KSIZE 5

#ifdef DEBUG
static FILE *debug_channel = NULL;
#endif

static double power();

/*
 *	C O E F M A T R I X
 *
 */
double *coefmatrix(coord, num, S)
int *coord;
int num;
double *S;
{
	double tmp1, tmp2, *s[LSIZE];
	int *x, *y, *xstart, *ystart;
	register i, j, k, l;

#ifdef DEBUG
	if (debug_channel) fprintf(debug_channel,"coefmatrix - num %d\n",num);
#endif DEBUG
	/*
	 * get data
	 */
	xstart = x = (int *) Malloc (sizeof(int) * num);
	ystart = y = (int *) Malloc (sizeof(int) * num);
	for(i = 0; i < num; i++){
		x[i] = *coord++;
		y[i] = *coord++;
	}
	/*
	 * initialize
	 */
	k = 0;
	s[0] = S;
	for(i = 0; i < LSIZE; i++){
		s[i] = s[0] + k;
		k += KSIZE;
		for(j = 0; j < KSIZE; j++)
			s[i][j] = 0;
	}
	/*
	 * get constant terms
	 */
	k = KSIZE - 1;
	for(j = 0; j < num; j++)
		s[0][k] = s[0][k] + y[j];
	/*
	 * get first and last column and last line
	 */
	s[0][0] = num;
	l = LSIZE - 1;
	for(i = 1; i < LSIZE; i ++){
		for(j = 0; j < num; j++){
			tmp1 = power(x[j], i);
			if(i < l)
				tmp2 = tmp1 * power(x[j], (l - i));
			else tmp2 = tmp1;
			s[i][0] = s[i][0] + tmp1;
			s[l][i] = s[l][i] + tmp1 * tmp2;
			s[i][k] = s[i][k] + tmp1 * y[j];
		}
	}
	/*
	 * get the rest of the elements in left butomn triagle
	 */
	for(j = 1; j < l; j++)
		for(i = j; i < l; i++)
			s[i][j] = s[i + 1][j - 1];
	/*
	 * get the rest of the elements in top right triagle
	 */
	for(i = 0; i < l; i++)
		for(j = i + 1; j < k; j++)
			s[i][j] = s[j][i];
	Free(xstart);
	Free(ystart);
#ifdef DEBUG
	if (debug_channel) fprintf(debug_channel,"coefmatrix - end\n");
#endif DEBUG
 	return;
}	



/*
 *	P O W E R S  --
 *
 *	Calculate x to power y
 */
static double power(x, y)
int x, y;
{
	register int i;
	register double z;

	if(y == 0)
		return(1);
	else{
		z = x;
		for(i = 1; i < y; i++)
			z *= x;
		return(z);
	}
}

