/*
 * conhullax.c 
 * ________________
 *
 * Ji Liang Sept 4, 1986
 * 
 * small function for extracting feature of curves
 *
 * MODIFICATIONS
 * -------------
 *  ji	25-08-87	Rewrote subarea.
 *  jl	12-08-87	Free more space.
 *	jl	11-08-87	Use qsort in subarea().
 *	jp	13-04-87	Inserts, structure assignments replaced
 */

#include <stdio.h>
#include <wstruct.h>
#include <split.h>
#define WIND 5


/*
 * deeppoint()
 * ---------------
 * find deepest concave point opposete to a chord 
 * i.e calulate the distance from the points, which
 * are pointed by ptr, and find the maxmum one
 */
struct address *deeppoint(l1, k1, l2, k2, plg)
int l1, k1, l2, k2;
struct polygondomain *plg;
 {
	register int a, b, x, y;
	int l, k, m;
	int i, j, n, h;
	struct address *deep, *dstart;
	struct ivertex *ivt = plg->vtx, *tmptr;
	int htmp[2], sameh = 1;

	deep = dstart = (struct address *) Malloc (sizeof(struct address) * 2);
	/*
	 * initionlise in case only one deep point to be found
	 */
	deep[0].order = 0;
	deep[1].order = 0;
	n = plg->nvertices;
	/* ji
	deep[1].ycood = ivt->vtY;
	deep[1].xcood = ivt->vtX;
	ivt += n - 1;
	deep[0].ycood = ivt->vtY;
	deep[0].xcood = ivt->vtX;
	ivt = plg->vtx;
	*/
	deep[1].ycood = l2;
	deep[1].xcood = k2;
	deep[0].ycood = l1;
	deep[0].xcood = k1;
	/*
	 * check one by one
	 */
	a = l1 - l2;
	b = k1 - k2;
	htmp[1] = htmp[0] = 0;
	for(i = 0; i < n; i++){
		l = ivt->vtY;
		k = ivt->vtX;
		y = l - l1;
		x = k - k1;
		h = y * b - x * a;
		h = ( h > 0) ? h : (-h);
		if(h == htmp[1])
			sameh++;
		else {
			if(htmp[1] > h && htmp[1] > htmp[0]){
				j = smalldeep(deep);
				/*
				 * if two points have nearly the same
				 * depth compare the angle
				 */
				/*
				 * more deep
				 */
				 m = getangle(ivt - 1);
				if(((htmp[1]-deep[j].order) > WIND) || ((abs(htmp[1]-deep[j].order) <= WIND) && (m > getangle(tmptr)))){
					if(j == 0){
						deep[0].order = deep[1].order;
						deep[0].xcood = deep[1].xcood;
						deep[0].ycood = deep[1].ycood;
					}
					deep[1].order = htmp[1];
					sameh = (sameh + 1) >> 1;
					deep[1].xcood = (ivt-sameh)->vtX;
					deep[1].ycood = (ivt-sameh)->vtY;
				}
			}
			htmp[0] = htmp[1];
			htmp[1] = h;
			sameh = 1;
		}
		tmptr = ivt - 1;
		ivt++;
	}
	for(i = 0; i < 2; i++){
		h = deep[i].order * 8 / hypot8(a, b);
		if(h < THRES)
			h = 0;
		deep[i].order = h;
	}
	return(dstart);
}

/*
 * smalldeep()
 *--------
 * find the order of the smaller deepest points
 */
smalldeep(deep)
struct address *deep;
{
	if(deep[0].order > deep[1].order)
		return(1);
	else return(0);
}


/*
 * the angle has not been normolized the more the value is
 * the smaller the angle is
 */
getangle(ivt)
struct ivertex *ivt;
{
	register i;

	i = (ivt->vtY - (ivt-3)->vtY) * ((ivt+3)->vtX - ivt->vtX) - (ivt->vtX - (ivt-3)->vtX) * ((ivt+3)->vtY - ivt->vtY);
	return(i);
}

/* 
 * get the area covered by the line(l1,k1, l2,k2)
 * and the curve from (l1,k1) to (l2,k2)
 */
subarea(obj, l1, k1, l2, k2)
struct object *obj;
int l1, k1, l2, k2;
{
	struct polygondomain *plgd, *trace();
	struct polygondomain *algd, *makepolydmn();
	struct ivertex *ivt;
	int area, n;

	plgd = trace(obj, l1, k1, l2, k2);
	ivt = plgd->vtx;
	n = plgd->nvertices;
	algd = makepolydmn(1, ivt, n, n + 1, 1);
	ivt = algd->vtx;
	ivt += n;
	algd->nvertices = n + 1;
	ivt->vtY = l1;
	ivt->vtX = k1;
	area = contourarea(algd);
	Free(plgd);
	Free(algd);
	return(area);
}

