/*
 * get4grey.c
 * ----------
 * Ji Liang Dec 22, 1986
 * Extract 4 grey values from object
 * the 3 points are as follows:
 *
 * flag = 0:            1:          	2:    		3:   
 *            x x x         x x     	     x		     
 *		o   	    o x	     	   o x		    o x
 *			       		     x		    x x
 *
 * flag = 4:            5:        	6:    		7:   
 *                           		     x  	   x x  
 *	       	o   	    x o 	     x o 	   x o
 *            x x x         x x     	     x		     
 * This should save time compared with 3 calls to greyval().
 */

#include <stdio.h>
#include <wstruct.h>
#include <split.h>

get3grey(obj, l, k, flag, g3)
struct object *obj;
int l, k, flag;
GREY *g3;
{
	int ki, i, n, j, m;
	int line, loop, incr;
	struct intervaldomain *idmn = obj->idom;
	struct interval *intl;
	struct valuetable *vdmn = obj->vdom;
	struct intervalline *itvl;
	struct valueline *vlln;
	GREY *g, bcg, *greyval();

	bcg = vdmn->bckgrnd;
	for(i = 0; i < 3; i++)
		g3[i] = bcg;
	line = l - 1;
	j = 0;
	ki = k - idmn->kol1;
	for(loop = 0; loop < 3; loop++){
		if (line < idmn->line1 || line > idmn->lastln) {
			return(-1);
		}
		incr = 0;
		if(loop == 0){
			if(flag > 3 && flag < 7)
				incr--;
			else if(flag < 2 || flag == 7)
				goto END;
			else if(flag == 2)
				incr++;
		} else if(loop == 1){
			if(flag == 0 || flag == 4)
				goto END;
			else if(flag < 4)
				incr++;
			else incr--;
		} else {
			if(flag > 5 || flag == 0)
				incr--;
			else if(flag > 2 && flag < 6)
				goto END;
			else if(flag == 2)
				incr++;
		}
		itvl = &idmn->intvlines[line - idmn->line1];
		n = itvl->nintvs;
		intl = itvl->intvs;
		while (n-- > 0) {
			if(ki + incr + 1 < intl->ileft){
				goto END;
				break;
			}
			if(ki + incr  <= intl->iright){
				vlln = vdmn->vtblines[line - vdmn->line1];
				g = vlln->values + k + incr - vlln->vkol1;
				break;
			}
			intl++;
		}
		if(loop == 0){
			if(flag < 4)
				m = flag - 1;
			else m = 7 - flag;
			for(i = 0; i < m; i++){
				g3[j++] = *(g + i);
			}
		} else if(loop == 1){
				g3[j++] = *g;
		} else {
			if(flag < 4)
				m = 3 - flag;
			else m = flag - 5;
			for(i = 0; i < m; i++){
				g3[j++] = *(g + i);
			}
		}
END:
		line++;
	}
	return(1);
}
