
/*
 * segmentrate.c 
 * ________________
 *
 * Ji Liang June 8, 1987
 *
 * the boundary divided by two points on the boundary
 * get the rate of long piece / short piece
 * note: point p0 and p1 were treated different because
 * p0 is a vertex on the boundary but p1 may be on one side
 * (if the distance between them is big
 * ====================================
 * Modification history
 * --------------------
 *  04-08-87	Ji Liang 	
 *				From two directions to reach the two cut points and get rate.
 *  29-06-87	Ji Liang
 * 				Unified the method. Deleted the function pixel_connec_rate().
 */

#include <stdio.h>
#include <wstruct.h>
#include <split.h>

segmentrate(obj, plgd, p0, p1)
struct object *obj;
struct polygondomain *plgd;
struct ivertex *p0, *p1;
{
	struct ivertex *wtx = plgd->vtx, tmp;
	int i, j, k;
	register d, rest, piece;
	int start = 0, end = 0;
	int flag0 = 0, flag1 = 0;
	int thresh = 10;

	i = squardisi(p0, p1);
	if( i < 37)
		thresh = 0;	
	rest = 0;
	piece = 0;
	for(i = 0; i < plgd->nvertices - 1; i++){
		d = idistance(wtx+1, wtx);
		piece += d;
		if(absdis(p0, wtx) == 0){ 
			break;
		} else if(absdis(p1, wtx) <= thresh){
			break;
		}
		wtx++;
	}
	end = i + 1;
	wtx = plgd->vtx;
	wtx += plgd->nvertices - 1;
	for(i = plgd->nvertices - 1; i > end; i--){
		d = idistance(wtx, wtx-1);
		piece += d;
		if(absdis(p0, wtx) == 0){ 
			break; 
		} else if(absdis(p1, wtx) <= thresh){
			break; 
		}
		wtx--;
	}
	for(j = i; j > end; j--){
		d = idistance(wtx, wtx-1);
		rest += d;
		wtx--;
	}
	if(rest == 0 || piece == 0)
		return(100);
	if(rest > piece)
		return(rest / piece);
	else return( piece / rest);
}

/*
 * return 8 * distance
 */
idistance(X, Y)
struct ivertex *X, *Y;
{
	register int l, k;

	l = X->vtY - Y->vtY;
	k = X->vtX - Y->vtX;
	return(hypot8(l, k));
}
