/* showtouch.c
 *
 * find touching points in a composite
 *
 * ji Nov 20, 1986
 * -------------
 * usage: testtp [-fnum]  
 * -fnum: 	disply scale = num
 */

#include <stdio.h>
#include <ctype.h>
#include <wstruct.h>
#include <label.h>
#include <interact.h>
#include <sgtty.h>

struct ipoint point = {40, 0, 0, 0};
char c;

main(argc, argv)
int argc;
char *argv[];
{
	struct pframe fr;
	struct object *obj, *objlist[3];
	struct object *readobj();
	struct polygondomain *plgd0, *plgd1, *boundary();
	int num, i;
	char *arg, str;

	fr.scale = 15;		/* default scale value */
	setout("stocol", 'p');
	dinit();
	clear();
	while (argc > 1 && argv[1][0] == '-') {
		argc--;
		arg = *++argv;
		switch (arg[1]) {
		case 'f':		
			if (isdigit(arg[2])) {
				i = atoi(&arg[2]);
				if (i > 0)
					fr.scale = i;
				else{
					fprintf(stderr,"can't see picture using this scale\n");
					exit(1);
				}
			}
			break;
		default:
			fprintf(stderr, "usage: testtp [-fnum] \n");
			exit(1);
		}
	}
	colour(255);
	i = 0;
	while((obj = readobj(stdin)) != NULL){
		clear();
		i++;
		fprintf(stderr,"\n\n*****  the %d-th object *****\n\n\n", i);
		fr.ox =  (obj->idom->kol1+ obj->idom->lastkl)/2 ;
		fr.oy =  (obj->idom->line1+ obj->idom->lastln)/2 ;
		fr.dx = 2048;
		fr.dy = 2048;
		fr.ix = 2;
		fr.iy = 2;
		fr.scale = fr.scale;
		fr.func = 0;
		picframe(obj, &fr);
		objlist[0] = obj;
		num = 1;
		if(simon(obj, &fr) == 0)
			fprintf(stderr,"!!!  simon test fail !!!\n");
		sleep(2);
	}
	update();
	finish();
	endout();
}
