/*
 *      S P L I T . H  --  General bits + things for splitlib modules
 *
 *
 *  Written: Clive A Stubbings
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    5th November 1987
 *
 *  Modifications
 *
 */
#define POLYSPLITMAXOBJ	10		/* Max objects generated by poly_split */
#define MAX_ANGS	150	/* maximum number of angles in list */
#define MAX_HOLES	50	/* maximum number of holes permitted */
#define OBJNUM      100	/* the maximum number of objs in a picture */
#define SUBNUM 		45
#define SIZE        140	/* the maximum number of special points in a 
				picture i.e. junction points, terminal
				points, etc. */
#define HALFSIZE         70	
#define MAXLNITV    20 	/* the maximum number of intvals in a line */
#define MAXLINE    1024	/* the maximum number of lines in a picture */
#define MAXCOL    512	/* the maximum number of columns in a picture */
#define MAXITV    1000  /* the maximum intvals in a picture */
#define BIGVALUE  640000
#define	ANGPIXEL    5	/* the distance when an angle is calculated */
#define	ANGTHRES    -146 /* The maximum tan(angle) * 256 in the angle list */
#define FTOI	256		/* scale for change double or float to int */
#define THRES	  2     
#define MAX(i, j)	(i>j? i: j)
#define MIN(i, j)	(i<j? i: j)
/*
 * #define P0(a) 	fprintf(stderr,"a\n")
 * #define P1(a,b) fprintf(stderr,"a, b = %d\n", b)
 * #define P2(a,b,c) 	fprintf(stderr,"a, b %d  c %d\n", b,c)
 * #define P3(a,b,c,d) 	fprintf(stderr,"a, b %d  c %d  d %d\n", b,c,d)
 * #define P4(a,b,c,d,e) 	fprintf(stderr,"a, b %d  c %d  d %d  e %d\n",b,c,d,e)
 */
#define ACOPY(a,b) {a.order=b.order;a.xcood=b.xcood;a.ycood=b.ycood;}

struct address {
	int order;
	int xcood;
	int ycood;
};

struct faddress {
	double order;
	int xcood;
	int ycood;
};

struct lblcontrol{
	int act[4];
	int end[4];
	int finish[4];
	int first[4];
	struct address **tms;
	struct object *inobj;
	struct object *outobj[4];
};

struct angladd {
	int num;
	struct ivertex small[2];
	struct ivertex *angl[100];

};

struct angle {
	GREY g;		/* grey level at the point indicate by the angle */
			/* the distance between it and the vertex is 2 */
	int grad;		/* gradient of grey level around the angle */
	GREY gp;	/* the average grey level of the path which start */
			/* at this angle */
	int rate;	/* the segment ration by above path */
	int prop;	/* record if the angle has been analysed */
	int alph;	/* tan(angle) */
	struct ivertex *st;	/* the following three points form the angle */
	struct ivertex *vtx;
	struct ivertex *end;
	struct ivertex assoc; 	/* relavent point */
};

struct anglist {
	GREY bgd;	/* the grey level of the backgroud */
	GREY brt;	/* the grey level of the brightest point */
	GREY aveg;	/* the average grey level of whole object */
	int num;	/* how many angles in the real list */
	int small;	/* which angle is the smallest */
	int fsmall;
	int tanang;
	struct angle ang[MAX_ANGS]; /* detail for every angle in the list */
};


