/*
 * striptouch.c
 * ------------
 * July 22, 1987	Ji Liang
 *
 * if an object is touching with the main object
 * return the touching part and put the rest
 * in remobj
 *
 *	30 Sep 1987		CAs		Another itteration
 * 25-09-87	jimp@IRS	Get 11-09-87 closer to correctness !!
 * 11-09-87	jimp	Make interval tables bigger (prevents rare crash)
 * 05-08-87	jl/jp	Free, Malloc, etc.
 */
#include <stdio.h>
#include <wstruct.h>
#include <split.h>


struct object *striptouch(obj, tobj, remobj)
struct object *obj, *tobj, **remobj;
{
	struct intervaldomain *idmn = obj->idom;
	struct intervaldomain *tdmn = tobj->idom;
	struct intervaldomain *makedomain(), *mdomain, *rdomain;
	struct object *makemain(), *mobj;
	struct intervalline *itvl;
	struct interval *intl, *mintl, *rintl;
	struct interval *mstart, *rstart;
	int ml1, mll, mk1, mlk;
	int rl1, rll, rk1, rlk;
	int totintl, *mn, *rn;
	int i, j, k, n, line, tobjlines, space;
	
	if(idmn->line1 > tdmn->lastln+1 || idmn->lastln+1 < tdmn->line1 || idmn->kol1 > tdmn->lastkl + 1 || idmn->lastkl + 1 < tdmn->kol1){
		*remobj = tobj;
		return(NULL);
	}
	 
	totintl = intcount(tdmn) + 2;
	tobjlines = tdmn->lastln - tdmn->line1 + 1;
	itvl = &tdmn->intvlines[0];
	space = MAX(totintl,tobjlines) + 1;
	/*
	 * "tobj" can bend back on itself and have several intervals per line
	 * therefore allocate space for intcount(tobj) things.   jimp
	 *
	 *	Further hackery - I don't understand but I'll guess and see if it helps
	 *	MAX(totintl,tobjlines) appears to determine how big the array's need to
	 *	be -  so here's hoping   .... CAS
	 */
	mintl = (struct interval *) Malloc(space * sizeof(struct interval));
	rintl = (struct interval *) Malloc(space * sizeof(struct interval));
	mstart = mintl;
	rstart = rintl;
	mn = (int *) Calloc(space, sizeof(int));
	rn = (int *) Calloc(space, sizeof(int));
	k = tdmn->kol1;
	mk1 = tdmn->lastkl;
	mlk = 0;
	rk1 = mk1;
	rlk = 0;
	i = 0;
	for(line = tdmn->line1; line <= tdmn->lastln; line++){
		intl = itvl->intvs;
		n = itvl->nintvs;
		while (n-- > 0) {
			if(connect4(obj, line, intl->ileft+k, intl->iright+k)){
				mintl->ileft = intl->ileft;
				mintl->iright = intl->iright;
				mk1 = MIN(intl->ileft, mk1);
				mlk = MAX(intl->iright, mlk);
				mintl++;
				mn[i]++;
			} else {
				rintl->ileft = intl->ileft;
				rintl->iright = intl->iright;
				rk1 = MIN(intl->ileft, rk1);
				rlk = MAX(intl->iright, rlk);
				rintl++;
				rn[i]++;
			}
			intl++;
		}
		itvl++;
		i++;
	}
	/*
	 * if no intersect interval touching part is NULL
	 */
	for(i = 0; i < tobjlines; i++)
		if(mn[i] > 0){
			ml1 = i + tdmn->line1;
			break;
		}
	if(i == tobjlines){
		*remobj = tobj;
		Free(mstart);
		Free(rstart);
		Free(mn);
		Free(rn);
		return(NULL);
	}
	/*
	 * if all of intervals of tobj are touching
	 * with obj, remaining is NULL
	 */
	for(i = 0; i < tobjlines; i++)
		if(rn[i] > 0){
			rl1 = i + tdmn->line1;
			break;
		}
	if(i == tobjlines){
		*remobj = NULL;
		Free(mstart);
		Free(rstart);
		Free(mn);
		Free(rn);
		return(tobj);
	}
	/*
	 * some are touching the rest are remaining
	 */
	for(i = tobjlines - 1; i >= 0; i--)
		if(mn[i] > 0){
			mll = i + tdmn->line1;
			break;
		}
	for(i = tobjlines - 1; i >= 0; i--)
		if(rn[i] > 0){
			rll = i + tdmn->line1;
			break;
		}
	mdomain = makedomain(1, ml1, mll, mk1 + k, mlk + k);
	rdomain = makedomain(1, rl1, rll, rk1 + k, rlk + k);
	mobj = makemain(1, mdomain, NULL, NULL, NULL);
	*remobj = makemain(1, rdomain, NULL, NULL, NULL);
	mdomain->freeptr = (char *) mstart;
	rdomain->freeptr = (char *) rstart;
	j = ml1 - tdmn->line1;
	mintl = mstart;
	for(line = ml1; line <= mll; line++){
 		intl = mintl;
		for(i = 0; i < mn[j]; i++){
			mintl->ileft -= mk1;
			mintl->iright -= mk1;
			mintl++;
		}
		makeinterval(line, mdomain, mn[j], intl);
		j++;
	}
	rintl = rstart;
	j = rl1 - tdmn->line1;
	for(line = rl1; line <= rll; line++){
 		intl = rintl;
		for(i = 0; i < rn[j]; i++){
			rintl->ileft -= rk1;
			rintl->iright -= rk1;
			rintl++;
		}
		makeinterval(line, rdomain, rn[j], intl);
		j++;
	}
	Free(mn);
	Free(rn);
	return(mobj);
}


/*
 * if interval (left, right)
 * 4 connect any interval in lile 
 * l - 1, l, l + 1 of
 * object obj return 1, otherwise return 0
 */
connect4(obj, l, left, right)
struct object *obj;
int l, left, right;
{
	struct intervaldomain *idmn = obj->idom;
	struct intervalline *itvl;
	struct interval *intl;
	int kl, kr, n, loop = 3; 
	register i;

	if (l + 1 < idmn->line1 || l > idmn->lastln + 1)
		return(0);
	kl = left - idmn->kol1;
	kr = right - idmn->kol1;
	if(l == idmn->line1 - 1){
		itvl = &idmn->intvlines[0];
		loop = 1;
	} else if(l == idmn->lastln + 1){
		itvl = &idmn->intvlines[idmn->lastln - idmn->line1];
		loop = 1;
	} else {
		itvl = &idmn->intvlines[l - idmn->line1];
		if(l == idmn->lastln){
			loop = 2;
			itvl--;
		} else if(l == idmn->line1)
			loop = 2;
		else itvl--;
	}
	for(i = 0; i < loop; i++){
		intl = itvl->intvs;
		n = itvl->nintvs;
		while (n-- > 0) {
			if (!((kr+1 < intl->ileft) || (kl > intl->iright+1)))
				return(1);
			intl++;
		}
		itvl++;
	}
	return(0);
}
