/* framedigs.c 		7/3/86		Denis Rutovitz
   subroutines for transforming frame to digs coordinates
   and inversely, digs to frame coordinates
   
 * Modifications
 *
 *
 *	16 Aug 1987		CAS		Hacked a temp fix limit checking..
 *	 2 aug	1987	BDP		Changed limit checks for larger virtuoso board
 */
 
#include <stdio.h>
#include <wstruct.h>
#include <ddgs.h>
/*#include <ddgsdefs.h>*/

/**********************************
 *
 *	Note: To get at the framestore info we need we have to access a ddgs
 *			internal data structure.  This module needs moving/changing..
 *			CAS 16th Sept 1987
 */

extern DDGS *dgb;		/* Picked up from ddgs... Sorry */

#define WINDMINX (dgb->minx<<dgb->xshift)
#define WINDMINY (dgb->miny<<dgb->yshift)
#define WINDMAXX (((dgb->maxx+1)<<dgb->xshift)-1)
#define WINDMAXY (((dgb->maxy+1)<<dgb->yshift)-1)

#define BIGNUM 60000


/* calculate frame distance in col-direction */
frkdis(x,f) 
register x;
register struct pframe *f;
{
	register int xs;
	xs = f->ix*f->scale;
	return ( x*xs );	
}
/* calculate inverse frame distance in line-direction */
frldis(y,f) 
register y;
register struct pframe *f;
{
	register int ys;
	ys = f->iy*f->scale;
	return ( y*ys) ;	
}
/* calculate inverse frame distance in col-direction */
frkvdis(x,f) 
register x;
register struct pframe *f;
{
	register int xs;
	xs = f->ix*f->scale;
	if (!xs) xs = 1;
	return ( (int) ( x/xs) );	
}
/* calculate inverse frame distance in line-direction */
frlvdis(y,f) 
register y;
register struct pframe *f;
{
	register int ys;
	if (!ys) ys = 1;
	ys = f->iy*f->scale;
	return ( (int) ( y/ys) );	
}
showframe(fr) struct pframe *fr; {
	printf( "Frame %d \n",fr);
	printf(
"fr->dx %d fr->dy %d fr->ox %d fr->oy %d fr->ix %d fr->iy %d fr->scale %d\n",
fr->dx , fr->dy , fr->ox , fr->oy , fr->ix , fr->iy , fr->scale );
}
/* calculate digs coordinates, given frame and position */
frdigsxpos(x,f)
register int x;
register struct pframe *f;
{
	register int xs,xo;
	
	xs = f->ix * f->scale;
	xo = f->dx - xs * f->ox;
	return (xo + xs*x);
}
frdigsypos(y,f)
register int y;
register struct pframe *f;
{
	register int ys,yo;
	
	ys = f->iy * f->scale;
	yo = f->dy - ys * f->oy;
	return (yo + ys*y);
}
/* calculate frame coordinates, given digs coordinates */
short frinvxdig(xv,f)
register int xv;
struct pframe *f;
{
	register int xs,xo;
	register x;
	xs = f->ix* f->scale;
	xo = f->dx - xs* f->ox;
	if ( !xs ) {
		if (xv > xo ) x = - BIGNUM;
		else x = BIGNUM;
	} else x = (xv - xo ) / xs ;
	return(x);
}
short frinvydig(yv,f)
register int yv;
struct pframe *f;
{
	register int ys,yo;
	register y;
	ys = f->iy* f->scale;
	yo = f->dy - ys* f->oy;
	if ( !ys ) {
		if (yv > yo ) y = - BIGNUM;
		else y = BIGNUM;
	} else y = (yv - yo ) / ys ;
	return(y);
}
/* enforce digs limits on frame coordinates */
limxdigfrm(x,f) register x;register struct pframe *f;  {
	register int xtemp;
	xtemp = frdigsxpos(x,f);
	if ( xtemp > WINDMAXX )  x = frinvxdig(WINDMAXX , f);
	else if ( xtemp < WINDMINX )  x = frinvxdig(WINDMINX , f);
	return(x);
}
limydigfrm(y,f) register struct pframe *f;  register y; {
	register int ytemp;
	ytemp = frdigsypos(y,f);
	if ( ytemp > WINDMAXY )  y = frinvydig(WINDMAXX , f);
	else if ( ytemp < WINDMINY )  y = frinvydig(WINDMINY , f);
	return(y);
}

