/*
 * mouse.c
 *
 * Routine specific to Mouse Systems M-2 optical mouse
 *
 * Modifications
 *
 *	24 Aug 1987		CAS		wmachdef -> machdef
 */

#include <stdio.h>
#include <machdef.h>
#include <interact.h>

/*
 * read next location and button status from mouse
 */
n_mouse(m,f)
register struct m2mouse *m;
register FILE *f;
{
	register int i;
	register char c;
	/* test for synch pattern, ensure 4 more bytes available */
	while (((i = wgetc(f,5)) & 0xF8) != 0x80)
		;
	/* set L M R buttons */
	m->L = (i&4)? 1: 0;
	m->M = (i&2)? 1: 0;
	m->R = i&1;
	/* increment register paying attention to sign of delta X, delta Y */
	c = getc(f); m->XINC = c;
	c = getc(f); m->YINC = c;
	c = getc(f); m->XINC += c;
	c = getc(f); m->YINC += c;
	m->X += m->XINC;
	m->Y += m->YINC;
}

static
wgetc(f,q)
register FILE *f;
register int q;
{
	while (getstat(1,fileno(f)) < q)
		tsleep(2);	
	return(getc(f));
}
