/*
 * histocell.c
 *
 *
 ***********************************************************************
 * This programs uses special modified versions of some Woolz routines
 * that access the frame store and explicitly mask out the top 8 bits,
 * which are apparently invariably read as "FF".
 ***********************************************************************
 *
 *	Modifications
 *
 *	 4 Dec 1988		CAS		Convert to long woolz names + make compile
 *
 */

#include <stdio.h>
#include <wstruct.h>

#define FRAME 0x400000
#define true 1


main(argc,argv)
char **argv;
int argc;
{
	struct object *obj, *histo, *fshisto(), *tobj, *fsthreshold(),
					*histonormalise();
	struct object *makerect(), *objl[100];
	struct intervaldomain *idom;
	register int i,j;
	int xs,ys,type,num,thres,numobj,*h;
	extern int packcheck;
	extern SMALL highlow;
	struct pframe f;
	GREY min , max;
	int mv,val;
	int k1,kl,l1,ll;
	char c;

	
		
	packcheck = 0;
	dinit();
	nlut();
	fast();
	fgsetup();
	setfglut(0);
	setfgsync(0);
	clear();
	
	f.ix = 1;
	f.iy = 1;
	f.ox=f.oy=f.dx=f.dy=0;
	f.scale=16;

	packcheck = 0;
	grab();
	obj = makerect(0,511,0,511,FRAME,0,NULL,obj);
	
	do {
		fprintf(stdout,"type l1 ll k1 kl\n");
		scanf("%d %d %d %d",&l1,&ll,&k1,&kl);
		obj->idom->line1 = l1;
		obj->idom->lastln = ll;
		obj->idom->kol1 = k1;
		obj->idom->lastkl = kl;
		invert(obj);
		fprintf(stderr,"This area OK ?\n");
		while (scanf("%c",&c), c != 'n' && c != 'y')
			;
		invert(obj);
	} while (c != 'y');

		vduclear();
		vdugo(0,0);
		fprintf(stdout,"    Min value =\n");
		fprintf(stdout,"    Max value =\n");
		fprintf(stdout,"Largest value =\n");
		fprintf(stdout," largest at   =");

	while(true){	
		fgdigitise();
	/*	tsleep(5);
		fgfreeze();
	*/
		fsgreyrange(obj,&min,&max);
		histo = fshisto(obj,255);
		histomax(histo,&mv,&val);
		freeobj(histo);
		vdunumat(min,1,16);
		vdunumat(max,2,16);
		vdunumat(mv,3,16);
		vdunumat(val,4,16);
/*
		setrgb(mv,255,0,0);
		setrgb(min,0,255,0);
		setrgb(max,0,0,255);
*/
/*
		histodup(histo);
		histonormalise(histo);
		picframe(histo,&f);
		fprintf(stdout,"Hit CR to continue :");
		while(getc(stdin)!='\n');
*/
	}
}



/*
 * fshisto.c	Jim Piper
 * Mods since grey-table in CRS frame store
 */



/*
 * make a histogram from an object given the maximum grey value
 */
struct object *fshisto(obj,maxg)
struct object *obj;
{
	struct object *hist, *makemain();
	struct histogramdomain *hdom, *makehistodmn();
	struct iwspace iwsp;
	struct gwspace gwsp;
	register GREY *g;
	register int k, *h;
	/* make empty histogram */
	hdom = makehistodmn(1,maxg+1);
	hist = makemain(13,hdom,NULL,NULL,obj);
	/* fill histogram */
	h = hdom->hv;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (k=iwsp.lftpos; k<=iwsp.rgtpos; k++) {
			if ((*g&255) >= 0)
				h[(*g&255)] ++;
			g++;
		}
	}
	return(hist);
}

/*
 * invert grey-table of object.
 */
fsinvert(obj)
struct object *obj;
{
	GREY min,max,range;
	register GREY *g;
	register int i;
	struct iwspace iwsp;
	struct gwspace gwsp;

	fsgreyrange(obj,&min,&max);
	range = max + min;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (i=0; i<iwsp.colrmn; i++) {
			*g = range - (*g & 255);
			g++;
		}
	}
}

/*
 * compute greyrange of pixel object
 */
fsgreyrange(obj,min,max)
struct object *obj;
GREY *min, *max;
{
	register GREY v,*g;
	register int i;
	GREY lmin, lmax;
	struct iwspace iwsp;
	struct gwspace gwsp;
	lmin = 1;
	lmax = 0;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (i=0; i<iwsp.colrmn; i++) {
			v = (*g & 255);
			g++;
			if (lmin > lmax){
				lmin = v;
				lmax = v;
			}
			else if (v > lmax)
				lmax = v;
			else if (v < lmin)
				lmin = v;
		}
	}
	*min = lmin;
	*max = lmax;
}

histodup(obj)
struct object *obj;
{
	register struct histogramdomain *hdom;
	register int i, *h;
	hdom = (struct histogramdomain *) obj->idom;
	h = hdom->hv;
	for (i=0; i<hdom->npoints; i++) {
		h[1] = h[0];
		h++;h++;
	}
}
/*
 *   find maximum points in histogram
 *
 */
 
 
histomax(obj,max,val)
struct object *obj;
int *max,*val;
{
	register struct histogramdomain *hdom;
	register int i, *h;
	hdom = (struct histogramdomain *) obj->idom;
	h = hdom->hv;
	*max=0;
	*val=0;
	for (i=0; i<hdom->npoints; i++) {
		if(*h>*max){
			*max=*h;
			*val=i;
		}
		h++;
	}
}
/*
 * invert grey-table of object.
 */
invert(obj)
struct object *obj;
{
	GREY min,max,range;
	register GREY *g;
	register int i;
	struct iwspace iwsp;
	struct gwspace gwsp;

	greyrange(obj,&min,&max);
	range = max + min;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (i=0; i<iwsp.colrmn; i++) {
			*g = range - (*g & 255);
			g++;
		}
	}
}

/*
 * compute greyrange of pixel object
 */
greyrange(obj,min,max)
struct object *obj;
GREY *min, *max;
{
	register GREY v,*g;
	register int i;
	GREY lmin, lmax;
	struct iwspace iwsp;
	struct gwspace gwsp;

	lmin = 1;
	lmax = 0;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (i=0; i<iwsp.colrmn; i++) {
			v = (*g & 255);
			g++;
			if (lmin > lmax){
				lmin = v;
				lmax = v;
			}
			else if (v > lmax)
				lmax = v;
			else if (v < lmin)
				lmin = v;
		}
	}
	*min = lmin;
	*max = lmax;
}

nlut()
{
	int c;
	for (c=0;c<255;c++)
		setrgb(c,c,c,c);
}


grab() 
{
		fgdigitise();
		fprintf(stdout,"Hit CR to freeze :");
		while(getc(stdin)!='\n');
		fgfreeze();
}

vduclear()
{
	fprintf(stdout,"\033[2J");
}

vducrl()
{
	fprintf(stdout,"\033[0K");
}

vdugo(r,c)
int r,c;
{
	fprintf(stdout,"\033[%d;%dH",r,c);
}

vduech(n)
int n;
{
	fprintf(stdout,"\033[%dX",n);
}

vdunumat(val,r,c)
int val,r,c;
{
	vdugo(r,c);
	vduech(5);
	fprintf(stdout,"%d",val);
}

