/*
 *	F S F R A M E H I S T O . C
 * 		Create a histogram from byte orientated frame store
 *
 *		Graham John Page Image recognition Systems
 *			Copyright IPR etc
 *									18 Jun 1987
 *
 */

#include <stdio.h>
#include <wstruct.h>


/*
 *
 *		F S F R A M E H I S T O
 *
 *	Inputs addres of frame store, lines, cols and max grey
 *
 *	Outputs pointer to object of type histogram
 *
 */
 
struct object *fsframehisto(frame,ppl,lpf,maxg)
register unsigned char *frame;	/* Pointer to begining of frame store  */
int ppl;						/* Number of pixels in a line */
int lpf;						/* Number of lines in a frame */
int maxg;						/* Max grey value required to determin size */
{
	struct object *hist, *makemain();
	struct histogramdomain *hdom, *makehistodmn();
	register int k, *h , size=ppl*lpf;
	/* make empty histogram */
	hdom = makehistodmn(1,maxg+1);
	hist = makemain(13,hdom,NULL,NULL,NULL);
	/* fill histogram */
	h = hdom->hv;
	do {
			h[*frame]++;
			frame++;
	}while (--size);
	return(hist);
}

