/*
 * fshisto.c	Jim Piper
 * Mods since grey-table in CRS frame store
 *
 *
 * make a histogram from an object given the maximum grey value
 *
 ***********************************************************************
 * This programs uses special modified versions of some Woolz routines
 * that access the frame store and explicitly mask out the top 8 bits,
 * which are apparently invariably read as "FF".
 ***********************************************************************
 */

#include <stdio.h>
#include <wstruct.h>


struct object *fshisto(obj,maxg)
struct object *obj;
{
	struct object *hist, *makemain();
	struct histogramdomain *hdom, *makehistodmn();
	struct iwspace iwsp;
	struct gwspace gwsp;
	register GREY *g;
	register int k, *h;
	/* make empty histogram */
	hdom = makehistodmn(1,maxg+1);
	hist = makemain(13,hdom,NULL,NULL,obj);
	/* fill histogram */
	h = hdom->hv;
	initgreyscan(obj,&iwsp,&gwsp);
	while (nextgreyinterval(&iwsp) == 0) {
		g = gwsp.grintptr;
		for (k=iwsp.lftpos; k<=iwsp.rgtpos; k++) {
			if ((*g&255) >= 0)
				h[(*g&255)] ++;
			g++;
		}
	}
	return(hist);
}

