/************************************************************************/
/*																		*/
/*							convhull.c									*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Written by:		B. Pinnington										*/
/*																		*/
/*	Purpose:		Test program for convhull functions					*/
/*																		*/
/*	Description:	Reads type one objects from stdin, and writes type  */
/*					12 objects to stdout. A call to hullarea is also	*/
/*					included to test that routine, the output though 	*/
/*					can be optionally disabled.							*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Modifications:														*/
/*																		*/
/************************************************************************/

#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *cvobj, *convhull(), *readobj();
	int tell,ha,perim;
	int st;
	
	tell = 1;					/* default is to output hullarea message */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     convhull [<opts>]\n");
				fprintf(stderr,"Function:   Convert type one object to type 12 convex hull\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -d      Disable writing of hullarea and perimeter message to stderr\n");
				exit(0);
			case 'd':
				tell = 0;
				break;
			default:
				fprintf(stderr,"CONVHULL: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"CONVHULL: Illegal arguement %s\n",*argv);
	}
			
	setmemalloc(65536);
	Alloc_limits( 0, 1024 * 512 * sizeof(GREY) );

	while((obj = readobj(stdin)) != NULL) {
		if (obj->type != 1) {
			writeobj(stdout,obj);
		} else {
			cvobj = convhull(obj);
			ha = hullarea(cvobj,&perim);
			if (tell)
				fprintf(stderr,"CONVHULL: Hull area = %d, Perimeter = %d\n",ha,perim);
			writeobj(stdout,cvobj);
			freeobj(cvobj);
		}
		freeobj(obj);
	}
}
