/*
 *
 *	D I L A T I O N . C --
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Written: J. Piper
 *           Medical Research Council
 *           Clinical and Population Cytogenetics Unit
 *           Edinburgh.
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	   16th August 1983.
 *
 *	Purpose:	   
 *
 *	Description:
 *
 *  Modifications
 *
 *	23 Nov 1987		BDP		Added help
 *	20 Nov 1987		BDP		Changed arguement format to -c=n from -c n
 *	05 Nov 1987		BDP		Writeobj for non type 1 objs had bad parameter order
 *	02 Nov 1987		BDP		Added a dilation count option -c
 *	12 Dec 1986		CAS/GJP	Don't null the vdom - see what happens..
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>

prstdout()
{
	fprintf(stderr,
"DILATION: File block curr ptr = 0x%x\n\
                      base ptr = 0x%x\n\
 					  end  ptr = 0x%x\n\
 					  flag     = 0x%x\n\
 					  file no  = 0x%x\n\
 					  char     = 0x%x\n\
 					  buff size= 0x%x\n",
			stdout->_ptr,stdout->_base,stdout->_end, stdout->_flag,
			stdout->_fd, stdout->_save,stdout->_bufsiz);

}

main(argc,argv)
int argc;
char **argv;
{
	int count,i;
	struct object *obj, *dobj, *readobj(), *dilation();


/* 	prstdout(); */

	count = 1;				/* default count */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     dilation [<opts>]\n");
				fprintf(stderr,"Function:   dilate a type one object\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -c=<count>  Number of times to dilate\n");
				exit(0);
			case 'c':
				if (argv[0][2] == '=')
					count = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"DILATION: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"DILATION: Illegal arguement %s\n",*argv);
	}
			
	while((obj = readobj(stdin)) != NULL)
	{
		if (obj->type == 1)
		{
			for ( i = 0; i < count ; i++ )
			{
				dobj = dilation(obj);
				freeobj(obj);
				obj = dobj;
			}
			writeobj(stdout,dobj);
			freeobj(dobj);
		}
		else
		{
			writeobj(stdout,obj);	/* 5/11/87 bdp. fixed order of params */
			freeobj(obj);
		}
	}
}
