/*
 *
 *	E R O S I O N . C --
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Written: J. Piper
 *           Medical Research Council
 *           Clinical and Population Cytogenetics Unit
 *           Edinburgh.
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	   16th August 1983.
 *
 *	Purpose:	   
 *
 *	Description:
 *
 *  Modifications
 *	23 Nov 1987		BDP		Added help
 *	20 Nov 1987		BDP		Changed arguement format to -c=n from -c n
 *	05 Nov 1987		BDP		Fixed parameter order for writeobj for non type 1 objs
 *	02 Nov 1987		BDP		Added an erosion count parameter, -c 
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *dobj, *readobj(), *erosion();
	int i,count;
	
	count = 1;				/* default erosion count */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     erosion [<opts>]\n");
				fprintf(stderr,"Function:   8-way erosion of type one object\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -c=<count> Number of times to erode\n");
				exit(0);
			case 'c':
				if (argv[0][2] == '=')
					count = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"EROSION: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"EROSION: Illegal arguement %s\n",*argv);
	}
	while((obj = readobj(stdin)) != NULL)
	{
		if (obj->type == 1)
		{
			for ( i= 0; i < count; i++ )
			{
				dobj = erosion(obj);
				freeobj(obj);			/* free every source object */
				obj = dobj;
			}
			writeobj(stdout,dobj);
			freeobj(dobj);
		}
		else
		{
			writeobj(stdout,obj);		/* 5/11/87 bdp fixed param order */
			freeobj(obj);
		}
	}
}
