/*
 *
 *	E R O S I O N 4 . C --
 *
 *  Written: B. Pennington
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	    November 1987.
 *
 *	Purpose:		Test program for function erosion4
 *		
 *	Description:	Exact copy of erosion.c but calls erosion4 instead	
 *																	
 *	Modifications:														
 *																		
 *	23 Nov 1987		BDP		Added help option							
 *	20 Nov 1987		BDP		Changed arg format to -c=n from -c n		
 *	05 Nov 1987		BDP		Fixed parameter order for writeobj call for 
 *							non type 1 objs								
 *																		
 */

#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *dobj, *readobj(), *erosion4();
	int i,count;
	
	count = 1;				/* default erosion4 count */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     erosion4 [<opts>]\n");
				fprintf(stderr,"Function:   4-way erode type 1 object\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -c=<count>	Number of times to erode. default=1\n");
				exit(0);
			case 'c':
				if (argv[0][2] == '=')
					count = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"EROSION4: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"EROSION4: Illegal arguement %s\n",*argv);
	}

	while((obj = readobj(stdin)) != NULL)
	{
		if (obj->type == 1)
		{
			for ( i= 0; i < count; i++ )
			{
				dobj = erosion4(obj);
				freeobj(obj);			/* free every source object */
				obj = dobj;
			}
			writeobj(stdout,dobj);
			freeobj(dobj);
		}
		else
		{
			writeobj(stdout,obj);		/* 5.11.87 bdp. fixed param order */
			freeobj(obj);
		}
	}
}
