/*
 * facts.c	Jim Piper	October 1983
 * print out some facts about an object
 *
 * Modifications
 *
 *  2  Oct 1988 	dcb 	Add skip bytes (as single integer parameter)
 *	12 Sep 1986		CAS		Includes
 */
#include <stdio.h>
#include <wstruct.h>

main(argc, argv)
int argc;
char **argv;
{
	struct object *obj, *readobj();
	struct intervaldomain *idom;
	struct valuetable *vdom;
	struct polygondomain *pdom;
	struct histogramdomain *hdom;
	struct pframe *rf;
	int i, c, skip_bytes;

		Alloc_limits(0,512 * 1024 * sizeof(GREY));
		setmemalloc(64 * 1024);
/*
 * Skip 1st 'n' bytes of non object structured data
 */
 		skip_bytes = 0;
		if (argc == 2) skip_bytes = atoi(*(argv+1));
		for(i=0; i<skip_bytes; i++)
			c = getc(stdin);

		while ((obj = readobj(stdin)) != NULL) {
		printf("main type %d\n",obj->type);
		switch (obj->type) {
		case 1:
			idom = obj->idom;
			if (idom == NULL)
				printf("No domain structure\n");
			else {
				printf("Domain type %d\n",idom->type);
				printf("line bounds %d %d, column bounds %d %d\n",
					idom->line1,idom->lastln,idom->kol1,idom->lastkl);
			}
			vdom = obj->vdom;
			if (vdom == NULL)
				printf("No value table structure\n");
			else {
				printf("Value table type %d\n",vdom->type);
			}
			printf("Area %d (line area %d)\n",area(obj),linearea(obj));
			break;
		case 10:
			pdom = (struct polygondomain *)obj->idom;
			if (pdom == NULL)
				printf("No polygon domain structure\n");
			else {
				printf("Type %d, %d vertices\n",pdom->type,pdom->nvertices);
			}
			break;
		case 13:
			hdom = (struct histogramdomain *)obj->idom;
			if (hdom == NULL)
				printf("No histogram domain structure\n");
			else {
				printf("Type %d, length %d\n",hdom->type,hdom->npoints);
			}
			break;
		case 60:
			rf = (struct pframe *)obj;
			if (rf == NULL)
				fprintf(stderr, "No frame\n");
			else {
	printf("Type=%d, scale=%d\nco-ords\t(%d,%d)\noffset\t(%d,%d)\nxinc=%d, yscale=%d\n",
		rf->type, rf->scale, rf->dx, rf->dy, rf->ox, rf->oy, rf->ix, rf->iy);
			}
			break;
		default:
			break;
		}
		printf("\n");
	}
}
