/*
 *		F C A S T E L . C	-	Fix castellation
 *
 *	ripped out of Jim's new castel stuff (CAS 20 Jul 1987)
 *
 * Modifications:
 *
 *   3 Dec 1987		BDP		Put read obj onto while loop and made timer messages an option
 */
#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *readobj(), *t0, *t1;
	char *str;
	int timer = 0;			/* default to no timer messages */
	
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			str = *argv + 1;
			while ( *str != '\0' )
			switch( *str++ )
			{
			case '?':
				fprintf(stderr,"Syntax:     fcastel [<opts>]\n");
				fprintf(stderr,"Function:   Fix castellation\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -t		Timer messages enabled \n");
				exit(0);
			case 't':
				timer = 1;
				break;
			default:
				fprintf(stderr,"FCASTEL: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"FCASTEL: Illegal arguement %s\n",*argv);
	}

	while( (obj = readobj(stdin)) != NULL ){
		if (timer)
			starttimer();
		compute_decastel_tables(obj,&t0,&t1,8,255,0.25);
		if (timer)
			elapsedtime();
		apply_decastel_table(obj,t0,t1);
		if (timer)
			elapsedtime();
#ifndef DEBUG
		writeobj(stdout,obj);
#else DEBUG
		/* check how much castellation is left */
		compute_decastel_tables(obj,&t0,&t1,8,255,0.25);
#endif DEBUG
		freeobj(obj);
		freeobj(t0);
		freeobj(t1);
	}
}

