/*
 * gwdtr.c		Jim Piper		29-04-86
 *
 * Rutovitz (1968) grey-weighted distance transform.
 */
#include <stdio.h>
#include <wstruct.h>
#include <seqpar.h>
#define LARGE 0x3fff


main()
{
	struct object *obj, *readobj();
	
	while ((obj = readobj(stdin)) != NULL) {
		gwdtr(obj);
		writeobj(stdout,obj);
		freeobj(obj);
	}
}


gwdtr(obj)
struct object *obj;
{
	struct object *obf, *obb, *newgrey();
	struct iwspace iwsp,iwspf,iwspb;
	struct gwspace gwsp,gwspf,gwspb;
	int k,fgwdtr(),bgwdtr();
	register GREY *g,*gf,*gb;

	obf = newgrey(obj);
	obb = newgrey(obj);
	seqpar(obf,0,1,0,1,0,0,fgwdtr);
	seqpar(obb,0,1,3,1,0,0,bgwdtr);
	initgreyscan(obj,&iwsp,&gwsp);
	initgreyscan(obf,&iwspf,&gwspf);
	initgreyscan(obb,&iwspb,&gwspb);
	while (nextgreyinterval(&iwsp) == 0) {
		nextgreyinterval(&iwspb);
		nextgreyinterval(&iwspf);
		g = gwsp.grintptr;
		gf = gwspf.grintptr;
		gb = gwspb.grintptr;
		for (k=iwsp.lftpos; k<=iwsp.rgtpos; k++,g++,gf++,gb++)
			*g = *gf<*gb? *gf: *gb;
	}
	obf->idom = NULL;
	obf->plist = NULL;
	freeobj(obf);
	obb->idom = NULL;
	obb->plist = NULL;
	freeobj(obb);
}

extern struct sppar sppar;

/*
 * Forward grey-weighted distance local sequential transform
 */

int fgwdtr(d)
{
	register GREY *a;
	register j,ng;
	ng = LARGE;
	a = sppar.adrptr[-1] - 1;
	for (j = -1; j <= 1; j++,a++)
		if (*a < ng)
			ng = *a;
	a = sppar.adrptr[0] - 1;
	if (*a < ng)
		ng = *a;
	a++;
	return (ng + *a);
}

/*
 * Backward grey-weighted distance local sequential transform
 */

int bgwdtr(d)
{
	register GREY *a;
	register j,ng;
	ng = LARGE;
	a = sppar.adrptr[-1] - 1;
	for (j = -1; j <= 1; j++,a++)
		if (*a < ng)
			ng = *a;
	a = sppar.adrptr[0] + 1;
	if (*a < ng)
		ng = *a;
	a--;
	return (ng + *a);
}
