/*
 * histo.c.	29/2/84.	Jim Piper
 *
 * compute and output histogram of type objects.
 * smooth if "-s" option.
 * log convert (default max log=2.0) if "-l" option.
 *
 * Modifications
 *
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
char **argv;
{
	struct object *obj, *readobj();
	struct object *h, *histo();
	struct histogramdomain *hdom;
	int smooth, logs;
	smooth=0;
	logs=0;
	while (argc > 0) {
		if (argv[1][0] == '-' && argv[1][1] == 's')
			smooth++;
		else if (argv[1][0] == '-' && argv[1][1] == 'l')
			logs++;
		argc--;
		argv++;
	}
	/*
	 * read object
	 */
	while (( obj = readobj(stdin)) != NULL ) {
		if (obj->type == 1) {
			/*
	 		 * compute histogram
	 		 */
			h = histo(obj);
/*
			if (logs)
				histlog(h,2.0);
*/
			if (smooth)
				histothreshsmooth(h);
			writeobj(stdout,h);
			freeobj(h);
		} else
			writeobj(stdout,obj);
		freeobj(obj);
	}
}
