/*
 * hthresh.c.	17/11/83.	Jim Piper
 *
 * Threshold type 1 objects input by analysis of histogram.
 *
 * Modifications
 *
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
char **argv;
int argc;
{
	struct object *obj, *readobj(), *nobj, *threshold();
	struct object *h, *histo();
	struct histogramdomain *hdom;
	int i, j, histmax;
	long k;
	int thresh, N, *hgms;
	if (argc > 1) {
		N = atoi(argv[1]);
		if (N<0)
			N=0;
		else if (N>99)
			N=99;
	} else
		N = 0;
	/*
	 * read object
	 */
	while (( obj = readobj(stdin)) != NULL ) {
		if (obj->type == 1) {
			/*
	 		 * compute histogram
	 		 */
			h = histo(obj);
			/*
	 		 * smooth histogram
	 		 */
			histothreshsmooth(h);
			/*
	 		 * compute theshold
	 		 */
			thresh = compthr3(h);
			if (N > 0) {
				/****************************
				 * threshold as computed is
				 * persistently too low.
				 * Remove an extra N% of area
				 ****************************/
				hdom = (struct histogramdomain *) h->idom;
				hgms = hdom->hv;
				histmax = hdom->npoints;
				k = 0;
				for (i=thresh; i<histmax; i++)
					k += hgms[i];
				k = k*N/100;
				for (i=thresh; i<histmax; i++) {
					k -= hgms[i];
					if (k < 0) {
						thresh = i;
						break;
					}
				}
fprintf(stderr,"modified thresh (N percent rule) = %d\n",thresh);
			}
			/*
	 		* threshold.
	 		*/
			nobj = threshold(obj,thresh);
			writeobj(stdout,nobj);
			freeobj(nobj);
		}
		freeobj(obj);
	}
}
