/*
 * htruncate.c.	19/6/84.		Jim Piper
 *
 * Normalise object and compress top and bottom specified % of grey range.
 * Default is to compress top and bottom 0.2% of range.
 *
 * Modifications
 *
 *	14 Jan 1987		CAS		Moved guts to trans
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>

extern int htnormalise ();

main(argc,argv)
char **argv;
{
	struct object *obj, *readobj();
	double toppc,botpc,atof();

	/*
	 * set top, bottom truncation
	 */
	toppc = 0.2;
	botpc = 0.2;
	if (argc > 1)
		toppc = botpc = atof(argv[1]);
	if (argc > 2)
		botpc = atof(argv[2]);

	fprintf(stderr,"Trunc values %f %f\n",toppc,botpc);
	/*
	 * read object
	 */
	while (( obj = readobj(stdin)) != NULL ) {
		if (obj->type == 1) {
			htnormalise(obj,toppc,botpc);
		}
		writeobj(stdout,obj);
		freeobj(obj);
	}
}


