/*
 * laplac.h	Jim Piper	7 January 1983
 *
 * Declarations of some 3 x 3, 5 x 5, and 7 x 7 Laplacian convolution masks
 */

/*
 * 3 by 3 with central weight 1
 */
int lpl3[9] = {
	-1, -1, -1,
	-1, 9, -1,
	-1, -1, -1
};

struct convolution laplac3 = {
	1,
	3,
	&lpl3[0]
};

/*
 * 5 by 5 (implementing 4 by 4) with central weight 1 (four times)
 */
int lpl4[25] = {
	 0,  0,  0,  0,  0,
	 0, -2, -4, -4, -2,
	 0, -4, 11, 11, -4,
	 0, -4, 11, 11, -4,
	 0, -2, -4, -4, -2
};

struct convolution laplac4 = {
	1,
	5,
	&lpl4[0]
};

/*
 * 5 by 5 with central weight 4
 */
int lpl5[25] = {
	-1, -1, -1, -1, -1,
	-1,  0,  0,  0, -1,
	-1,  0, 20,  0, -1,
	-1,  0,  0,  0, -1,
	-1, -1, -1, -1, -1
};

struct convolution laplac5 = {
	1,
	5,
	&lpl5[0]
};

/*
 * 7 by 7 with central weight 4
 */
int lpl7[49] = {
	 0,  0,  0, -1,  0,  0,  0,
	 0, -1,  0,  0,  0, -1,  0,
	 0,  0,  0,  1,  0,  0,  0,
	-1,  0,  1,  8,  1,  0, -1,
	 0,  0,  0,  1,  0,  0,  0,
	 0, -1,  0,  0,  0, -1,  0,
	 0,  0,  0, -1,  0,  0,  0
};

struct convolution laplac7 = {
	1,
	7,
	&lpl7[0]
};
