/************************************************************************/
/*																		*/
/*							minwrect.c									*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Written by:		B. Pinnington										*/
/*																		*/
/*	Purpose:		Test program for minwrect and mwrangle functions	*/
/*																		*/
/*	Description:	Reads type one objects from stdin, and writes type  */
/*					20 rectangle objects to stdout. Uses convhull to	*/
/*					transform type 1 to type 12 object needed by 		*/
/*					minwrect											*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Modifications:														*/
/*																		*/
/************************************************************************/

#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *cobj, *rectobj, *minwrect(), *convhull(), *readobj();
	
	setmemalloc(65536);
	Alloc_limits( 0, 1024 * 512 * sizeof(GREY) );

	while((obj = readobj(stdin)) != NULL) {
		if (obj->type != 1) {
			writeobj(stdout,obj);
		} else {
			cobj = convhull(obj);
			rectobj = minwrect(cobj);
			writeobj(stdout,rectobj);
#ifdef DEBUG
			wzsum(rectobj);
			wzsum(cobj);
#endif DEBUG
			freeobj(cobj);
			freeobj(rectobj);
		}
		freeobj(obj);
	}
}
