/*
 * nfosingle.c		Jim Piper		14/1/86
 *
 * Construct Woolz object type 1 from new-style FIP digitised
 * data passed down the PIA from MIPROC.  This data is produced
 * both by a hardware threshold card and by a software simulation.
 *
 * main program reads data into "fipbuf", passes to "nfipobj()"
 * write out as single object.
 *
 *	Modifications
 *
 *	 5 Jan 1987		CAS			Includes
 *	10 Mar 1987		BDP			process possible null return from nfipobj
 *
 */
#include <stdio.h>
#include <wstruct.h>

#define BSIZ 200000

main(argc,argv)
char **argv;
{
	char *fp, *fipbuf;
	int c,numobj;
	struct object *obj, *nfipobj(), *objlist[100];
	int norm = 1;

	if (argc > 1 && argv[1][0] == '-' && argv[1][1] == 'n')
		norm = 0;	
	fipbuf = (char *) Malloc(BSIZ);
	fp = fipbuf;
	while ((c=getchar()) != EOF && (int) (fp-fipbuf) < BSIZ)
		*fp++ = (unsigned char) c;

	starttimer();

	/* check that something is returned, if not just drop out */
	
	if (( obj = nfipobj(fipbuf,(int)(fp-fipbuf)) ) != NULL ){
		elapsedtime();
		if (norm) {
			normalise(obj);
			elapsedtime();
		}
		writeobj(stdout,obj);
		elapsedtime();
	}
}
