/*
 * nfotest.c		Jim Piper		14/1/86
 *
 * Construct Woolz object type 1 from new-style FIP digitised
 * data passed down the PIA from MIPROC.  This data is produced
 * both by a hardware threshold card and by a software simulation.
 *
 * main program reads data into "fipbuf", passes to "nfipobj()"
 * for consistency checks and ultimately for cnstructing an object.
 *
 * Modifications
 *
 *	10 mar 1987		BDP		cope with possible null object from nfipobj
 *	14 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>

#define BSIZ 200000

main()
{
	char *fp, *fipbuf;
	int c,numobj;
	struct object *obj, *nfipobj(), *objlist[100];
	
	fipbuf = (char *) Malloc(BSIZ);
	fp = fipbuf;
	while ((c=getchar()) != EOF && (int) (fp-fipbuf) < BSIZ)
		*fp++ = (unsigned char) c;

	starttimer();

	/* check that an object is returned before processing it */
	
	if (( obj = nfipobj(fipbuf,(int)(fp-fipbuf)) ) != NULL ){
		elapsedtime();
		normalise(obj);
		elapsedtime();
		label(obj,&numobj,objlist,100,5);
		elapsedtime();
		writeobj(stdout,objlist[30]);
		elapsedtime();
		writeobj(stdout,spin(objlist[30],1.0));
		elapsedtime();
	}
}
