/************************************************************************/
/*																		*/
/*							octagon.c									*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Written by:		B. Pinnington										*/
/*																		*/
/*	Purpose:		Test program for octagon function					*/
/*																		*/
/*	Description:	Reads type one objects from stdin, and writes type  */
/*					10 octagon objects to stdout. 						*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Modifications:														*/
/*																		*/
/*  23 Nov 1987		BDP		Added help									*/
/*																		*/
/************************************************************************/

#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *octobj, *octagon(), *readobj();
	int tip;
	
	tip = 1;	/* default setting */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     octagon [<opts>]\n");
				fprintf(stderr,"Function:   convert type one object to octagon type 10\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -t=<tip>  Tip parameter to function. default 1 \n");
				exit(0);
			case 't':
				if (argv[0][2] == '=')
					tip = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"OCTAGON: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"OCTAGON: Illegal arguement %s\n",*argv);
	}
	setmemalloc(65536);
	Alloc_limits( 0, 1024 * 512 * sizeof(GREY) );

	while((obj = readobj(stdin)) != NULL) {
		if (obj->type != 1) {
			writeobj(stdout,obj);
		} else {
			octobj = octagon(obj,tip);
			writeobj(stdout,octobj);
			freeobj(octobj);
		}
		freeobj(obj);
	}
}
