/*
 *      P R C O N S T R U C T . C  --  Make woolz object from Virtuoso digitisation
 *
 *
 *  Written: Bruce D Pinnington
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:
 *
 *	Purpose:		Test fsconstruct.c
 *
 *	Description:	Calls construct and writes returned object to stdout
 *
 *  Modifications
 *
 *	18 Dec 1987		CAS		Convert to new ddgs, added std header + command line parser
 *	13 Oct	1987	BDP		Use new memory routines
 *	28 Jul	1987	BDP		Added memory error function setting
 *
 */
#include <stdio.h>
#include <wstruct.h>
#include <ddgs.h>
typedef unsigned char FSCHAR;

int fsmemerror();

main(argc,argv)
char **argv;
int argc;
{
	char	*swptr, **targv;
	int		targc, doneone;
	int		store = FS_VIRTUOSO_INVERT, devno = 0;
	DDGS	*dg, *ddgsopen();
	int tot,linetot;
	int i,j,invert;
	unsigned int thresh;
	struct object *obj, *fsconstruct();
	unsigned char *chr;
		
	thresh = 10;		/* default threshold */
	invert = 0;			/* defaults white = 0, black = 255 */
	
#ifdef INTERRUPT
	intercept(interrupt);
#endif INTERRUPT
	targc = argc; targv = argv;

	argc--; argv++;			/* dump process name */
	while (argc > 0) {
		if (*argv[0] == '-') {
			swptr = *argv;
			*argv = NULL;
			while (*(++swptr)) {
				switch (*swptr) {
					case '?':
				  		printf("Syntax:   prconstruct <options> [threshold]\n");
					  	printf("Function: Make woolz object from Virtuose digitisation\n");
					  	printf("Options:  v - Show version number\n");
						printf("          i - invert\n");
						printf("          1 - Use seat 1 framestore\n");
						printf("          2 - Use seat 2 framestore (similarly 3 & 4)\n");
				  		printf("          ? - Help\n");
					  	exit(0);
					case 'v':
						printf("Prconstruct - Version 0.1\n");
						exit(0);
					case 'i':
						argc--;
						invert = 1;
						thresh = 245;		/* default for invert */
						break;
					case '1':
						devno = 0;
						break;
					case '2':
						devno = 1;
						break;
					case '3':
						devno = 2;
						break;
					case '4':
						devno = 3;
						break;
				  default:
				 	printf("prconstruct - unknown option\n");
				}
			}
		}
		argv++; argc--;
	}

	argc = targc; argv = targv;
	argc--; argv++;			/* dump process name */
	doneone = 0;
/*
 *	Use remaining params 
 */
	while (argc) {
		if (*argv != NULL) {
			switch (doneone) {
				case 0:
					thresh = atoi(*argv);
					break;
			}
			doneone++;
		}
		argc--; argv++;
	}
	fprintf(stderr,"prconstruct object called with threshold of %d\n",thresh);
	dg = ddgsopen(store,devno);
	fprintf(stderr,"opened ddgs, framestore at %x\n              number of lines = %d\n             number of cols  = %d\n",
 			dg->frame,dg->lineno,dg->lineln);
	chr = dg->frame;
	Alloc_exit(fsmemerror);
	Alloc_wait(0);		/* dont wait if out of memory */
	obj = fsconstruct(dg->frame,dg->lineno,dg->lineln,thresh,invert);
	if (obj == NULL)
		fprintf(stderr,"construct, null object returned\n");
	else {
		writeobj(stdout,obj);
		freeobj(obj);
	}
	fprintf(stderr,"construct, completed\n");
}

