/*
 *      P R F S L I N E . C  --  Display framestore line in decimal
 *
 *
 *  Written: Bruce D Pinnington
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:
 *
 *	Purpose:		print out all grey values on specified line(s)
 *
 *	Description:	uses the ddgs graphics structure to derive the
 *					store address, then calculates an offset of line
 *
 *	Modifications
 *
 *	18 Dec 1987		CAS			Added std cmd line stuf, convert to new ddgs 
 *								and add std header
 *
 */
#include <stdio.h>
#include <wstruct.h>
#include <ddgs.h>
typedef unsigned char FSCHAR;

main(argc,argv)
char **argv;
int argc;
{
	char	*swptr, **targv;
	int		targc, doneone;
	int		store = FS_VIRTUOSO_INVERT, devno = 0;
	DDGS	*dg, *ddgsopen();
	int lineno;
	int linetot;
	int i,j;
	unsigned char *chr;
		
#ifdef INTERRUPT
	intercept(interrupt);
#endif INTERRUPT
	targc = argc; targv = argv;

	argc--; argv++;			/* dump process name */
	while (argc > 0) {
		if (*argv[0] == '-') {
			swptr = *argv;
			*argv = NULL;
			while (*(++swptr)) {
				switch (*swptr) {
					case '?':
				  		printf("Syntax:   prfsline <options> [linenumber...]\n");
					  	printf("Function: Display framestore line (numerically)\n");
					  	printf("Options:  v - Show version number\n");
						printf("          1 - Use seat 1 framestore\n");
						printf("          2 - Use seat 2 framestore (similarly 3 & 4)\n");
				  		printf("          ? - Help\n");
					  	exit(0);
					case 'v':
						printf("Prfsline - Version 0.1\n");
						exit(0);
					case '1':
						devno = 0;
						break;
					case '2':
						devno = 1;
						break;
					case '3':
						devno = 2;
						break;
					case '4':
						devno = 3;
						break;
				  default:
				 	printf("Prfsline - unknown option\n");
				}
			}
		}
		argv++; argc--;
	}

	fprintf(stderr,"opened ddgs, framestore at %x\n               number of lines = %d\n             number of cols  = %d\n",
 			dg->frame,dg->lineno,dg->lineln);
	dg = ddgsopen(store,devno);
	argc = targc; argv = targv;
	argc--; argv++;			/* dump process name */
	doneone = 0;
/*
 *	Use remaining params 
 */
	while (argc) {
		if (*argv != NULL) {
			lineno = atoi(*argv);
			fprintf(stderr,"line %d\n",lineno);
			chr = dg->frame + (lineno * dg->lineln);
			for (j=0; j < dg->lineln; j++) {
				fprintf(stderr," %d",*chr++);
				if ( j%20 == 0 )
					fprintf(stderr,"\n");
			}
			fprintf(stderr," %d",linetot);
			doneone++;
		}
		argc--; argv++;
	}
}


