/************************************************************************/
/*																		*/
/*							prsum.c										*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Written by:		B. Pinnington										*/
/*																		*/
/*	Purpose:		Main routine for the object summariser program		*/
/*																		*/
/*	Description:	Takes objects from stdin and writes a brief summary */
/*					of each ot stderr.  In all cases the object as		*/
/*					read is written to stdout.							*/
/*																		*/
/************************************************************************/
/*																		*/
/*	Modifications:														*/
/*																		*/
/*  23 Nov 1987		BDP		Added -?, help option						*/
/*  20 Nov 1987		BDP		Added -n, no object write option			*/
/*																		*/
/************************************************************************/

#include <stdio.h>
#include <wstruct.h>
/*page*/
main(argc,argv)
int argc;
char **argv;
{
	int objwrite;
	struct object *obj, *readobj();
		
	objwrite = 1;				/* default is write obj to stdout */
	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     prsum [<opts>]\n");
				fprintf(stderr,"Function:   Summarise a woolz object\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -n      Disable writing of object to stdout\n");
				exit(0);
			case 'n':
				objwrite = 0;
				break;
			default:
				fprintf(stderr,"PRSUM: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"PRSUM: Illegal arguement %s\n",*argv);
	}
	setmemalloc(65536);
	Alloc_limits(0, 512 * 1024 * sizeof(GREY));
	while((obj = readobj(stdin)) != NULL) 
	{
		wzsum(obj);			/* summarise a good object */
		if (objwrite)
			writeobj(stdout,obj);
		freeobj(obj);
	}
}
