/*
 * select.c.	3/1/84.		Jim Piper
 *
 * select the n'th object in a file or stream.
 * optionally, the n'th of a specified type.
 * error message if too few.
 *
 * Modifications
 *
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
char **argv;
{
	int fromwhich,towhich,type;
	struct object *obj, *readobj();
	FILE *in;

	in = stdin;
	type = 0;
	if (argc > 1 && argv[1][0] == '-' && argv[1][1] == 't') {
		type = atoi(&argv[1][2]);
		argc--;
		argv++;
	}
	if (argc < 2) {
		fprintf(stderr,"select: object number not specified\n");
		exit(2);
	} else {
		towhich = fromwhich = atoi(argv[1]);
		if (argc > 3 && argv[2][0] == '-' && argv[2][1] == '\0') {
			towhich = atoi(argv[3]);
			argc -= 2;
			argv += 2;
		}
	}
	if (argc > 2) {
		in = fopen(argv[2],"r");
		if (in == NULL) {
			fprintf(stderr,"select: can't find file %s\n",argv[2]);
			exit(3);
		}
	}
	while((obj = readobj(in)) != NULL) {
		if (type == 0 || type == obj->type) {
			fromwhich--;
			towhich--;
			if (fromwhich <= 0 && towhich>= 0) {
				writeobj(stdout,obj);
			}
			else if (towhich < 0)
				exit(0);
		}
		freeobj(obj);
	}
	fprintf(stderr,"too few objects\n");
	exit(1);
}
