/*
 *
 *	S H I F T . C --
 *
 *  Written: B. Pennington.
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	    November 1987.
 *
 *	Purpose:		Test program for function shift				
 *																	
 *	Description:	loops inputting objects from stdin. all type 1	
 *					one objects are shifted in line and column by the
 *					specified amount, and the new object writtento 	
 *					stdout. If object is not type 1 it is written to
 *					stdout anyway.  Two arguements must be given , the
 *					line shift then column shift or an error will be
 *					given.											
 *																	
 *	Modifications:	
 *					
 *	24 Nov 1987		BDP		Added help	
 *										
 */

#include <stdio.h>
#include <wstruct.h>

main(argc,argv)
char **argv;
int argc;
{
	struct object *obj, *readobj(), *nobj, *shift();
	int lshift, kshift;
	
	if (argc > 1)
		if ( (argv[1][0] == '-') && (argv[1][1] == '?') )
		{
			fprintf(stderr,"Syntax:     shift <lshift> <kshift>\n");
			fprintf(stderr,"Function:   \n");
			exit(0);
		}
	if (argc < 3)
		fprintf(stderr,"shift error, too few arguements\n");
	else
	{
		lshift = atoi(argv[1]);
		kshift = atoi(argv[2]);
		
		while((obj = readobj(stdin)) != NULL)
		{
			if (obj->type == 1)
			{
				nobj = shift(obj,lshift,kshift);
				writeobj(stdout,nobj);
				freeobj(nobj);
			}
			else
				writeobj(stdout,obj);
			freeobj(obj);
		}
	}
}
