/****************************************************************/

/*
 * skeleton.c.	25/10/83.	Jim Piper
 *
 * Modifications
 *
 * 24 Nov 1987		BDP 	Added help and changed parameter input format
 * 13 Nov 1987		BDP 	Took out fprintfs
 * 12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
char **argv;
{
	struct object *obj, *nobj, *readobj(), *skeleton();
	struct valuetable *newvaluetb();
    int colour =255;
   	int tipdel = 0;

	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     skeleton [<opts>]\n");
				fprintf(stderr,"Function:   produce type one skeletal object from type one object\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -c=<colour> 0-255, colour for all skeleton pixels \n");
				fprintf(stderr,"    -t=<tipdel> value of tipdel parameter to skeleton\n");
				exit(0);
			case 'c':
				if (argv[0][2] == '=')
					colour = atoi( &argv[0][3] );
				break;
			case 't':
				if (argv[0][2] == '=')
					tipdel = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"SKELETON: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"SKELETON: Illegal arguement %s\n",*argv);
	}
	while((obj = readobj(stdin)) != NULL) {
		if (obj->type == 1) {
			nobj = skeleton(obj,tipdel);
			nobj->vdom = newvaluetb(nobj,1,0);
			setval(nobj,colour);
			writeobj(stdout,nobj);
			freeobj(nobj);
		} else
			writeobj(stdout,obj);
		freeobj(obj);
	}
}
