/*
 *
 *	S P I N . C --
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Written: J. Piper
 *           Medical Research Council
 *           Clinical and Population Cytogenetics Unit
 *           Edinburgh.
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	   16th August 1983.
 *
 *	Purpose:	   Test program for function spin.
 *
 *	Description:
 *
 *	Modifications:	
 *					
 *	24 Nov 1987		BDP		Added help				
 *	04 Nov 1987		BDP		Did a setmemalloc to prevent out of memory	
 *																		 
 */

#include <stdio.h>
#include <wstruct.h>

#define RADIANS (180.0/3.14159)

main(argc,argv)
char **argv;
int argc;
{
	struct object *obj, *readobj(), *nobj, *spin();
	int rot = 90;
	
	setmemalloc(32 * 1024);
	if (argc == 2) {
		if ((argv[1][0] == '-') && (argv[1][1] == '?')) {
			fprintf(stderr,"Syntax:     rotate [<angle>]\n");
			fprintf(stderr,"Function:   spin type one object by specifed no of degrees\n");
			exit(0);
		}
		else
			rot = atoi(argv[1]);
	}
	while((obj = readobj(stdin)) != NULL) {
		if (obj->type == 1) {
			nobj = spin(obj,rot/RADIANS);
			writeobj(stdout,nobj);
		} else
			writeobj(stdout,obj);
		freeobj(obj);
	}
}
