/*
 *
 *	U N I T E . C --
 *
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *	Written: J. Piper
 *           Medical Research Council
 *           Clinical and Population Cytogenetics Unit
 *           Edinburgh.
 *
 *	Copyright (c) and intellectual property rights Image Recognition Systems
 *
 *  Date:    	   25th August 1983.
 *
 *	Purpose:	   
 *
 *	Description:
 *
 * Modifications:
 *  23 Nov 1987		BDP		Added help option
 *  20 Nov 1987		BDP		Changed arguement format to -c=n from -c n
 *  05 Nov 1987		BDP		Changed object list to 200 not 100 long
 *  27 Oct 1987		BDP		Union count parameter added
 *	14 jan 1987		CAS		setmemalloc()
 *	12 Sep 1986		CAS		Includes
 */

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
int argc;
char **argv;
{
	struct object *obj, *readobj(), *objs[200], *unionn();
	int i,j;
	int unioncount;
	int greytabs ;
	
	unioncount = 0;
	i = 0;
	greytabs = 1;			/* default of produce greytable */

	while(--argc > 0)
	{
		if ((*++argv)[0] == '-') 
		{
			switch( argv[0][1] )
			{
			case '?':
				fprintf(stderr,"Syntax:     unite [<opts>]\n");
				fprintf(stderr,"Function:   perform union of two or more type one objects\n");
				fprintf(stderr,"Options:\n");
				fprintf(stderr,"    -c=<count>	Max number of objects to include in one union\n");
				exit(0);
			case 'c':
				if (argv[0][2] == '=')
					unioncount = atoi( &argv[0][3] );
				break;
			default:
				fprintf(stderr,"UNITE: Unrecognised parameter ignored\n");
				break;
			}
		}
		else
			fprintf(stderr,"UNITE: Illegal arguement %s\n",*argv);
	}
	setmemalloc(65536);
	Alloc_limits( 0, 1024 * 512 * sizeof(GREY) );
	while((obj = readobj(stdin)) != NULL) {
		if (obj->type != 1) {
			freeobj(obj);
		} else {
			objs[i++] = obj;
			if (obj->vdom == NULL)
				greytabs = 0;
		}
	}
#ifdef DEBUG
	fprintf(stderr,"UNITE: %d objects read\n",i);
#endif DEBUG
		
	if ( unioncount == 0)
	{
		obj = unionn(objs,i,greytabs);
		writeobj(stdout,obj);
		freeobj(obj);
	}
	else
	{
		for ( j = 0; j < i; j+=unioncount )
		{
			obj = unionn(&objs[j],( i - j < unioncount ? i - j: unioncount), greytabs);
			writeobj(stdout,obj);
			freeobj(obj);
		}
	}

/*	while ( --i >= 0)
		freeobj(&objs[i]);
*/
}
