/*
 *
 *	W T C O P Y D M N . C --
 *
 *  Written: B. Pennington.
 *           Image Recognition Systems
 *           720 Birchwood Boulevard
 *           Birchwood Science Park
 *           Warrington
 *           Cheshire
 *           WA3 7PX
 *
 *  Date:    November 1987.
 *
 *	Purpose: Test routine for wzcopydmn
 *
 *	Description:Reads objects from stdin, copies their idoms into
 *	 			new objects which reference the same vdom where		  
 *	 			appropriate, frees the original object, then writes   
 *				new object to stdout								  
 *
 *	Modifications:														  
 *																		  
 * 02 Nov 1987		BDP		Changed to test newidomain, routine already   
 *							existing with wzcopydmn functionality		  
 *																		  
 */

#include <stdio.h>
#include <wstruct.h>

main ()
{
	struct object *obj, *nobj, *makemain(), *readobj();
	struct intervaldomain *idom2, *wzcopydmn(), *newidomain();
	
	while((obj = readobj(stdin)) != NULL)
	{
		if (obj->type == 1)
		{
			idom2 = newidomain(obj->idom);
			nobj = makemain(1,idom2,obj->vdom,NULL,NULL);
			writeobj(stdout,nobj);
			freeobj(nobj);	
		}
		else
			writeobj(stdout,obj);
		freeobj(obj);
	}
}

