/*
 * testreadobj.c.	02-12-86.	Jim Piper
 *
 * Test readobj() speed.
 *
 * Modifications
 *
 *	17 Dec 1986		CAS		Mode fbopen + fbclose static to avoid name
 *							clashes
 */
#define DEBUG

#include <stdio.h>
#include <wstruct.h>


main(argc,argv)
char **argv;
{
	struct object *objl[100], *obj, *readobj();
	FILE *in, *out, *fbopen();
	int i,n,s;
#ifdef DEBUG
	setbuf(stderr,NULL);
#endif DEBUG
	in = fbopen(argv[1],"r",512);
	out = fbopen(argv[2],"w",512);
	n = 0;
	s = 0;
	starttimer();
	while((obj = readobj(in)) != NULL) {
		objl[n++] = obj;
		s += seqsize(obj);
#ifdef DEBUG
		fprintf(stderr,"O");
#endif DEBUG
	}
#ifdef DEBUG
	fprintf(stderr,"\n");
	fprintf(stderr,"Total sequential size %d bytes\n",s);
#endif DEBUG
	preexpand(out,s);
	for (i=0; i<n; i++) {
		obj = objl[i];
		writeobj(out,obj);
		freeobj(obj);
#ifdef DEBUG
		fprintf(stderr,"W");
#endif DEBUG
	}
#ifdef DEBUG
	fprintf(stderr,"\n");
#endif DEBUG
	elapsedtime();
#ifdef DEBUG
	tell(stdin);
#endif DEBUG
}

tell(f)
FILE *f;
{
	printf("ptr %x base %x end %x flag %x fd %x size %x\n",f->_ptr,
	f->_base,f->_end,f->_flag,f->_fd,f->_bufsiz);
}

static FILE *fbopen(name,flag,bufsiz)
char *name, *flag;
{
	FILE *f;
	char *malloc();
	f = fopen(name,flag);
	if (f == NULL) {
		fprintf(stderr,"fbopen: cannot open %s\n",name);
		exit(1);
	}
#ifdef DEBUG
	tell(f);
#endif DEBUG
	f->_base = malloc(bufsiz);
	f->_flag |= _BIGBUF;
	f->_ptr = f->_end = f->_base + bufsiz;
	f->_bufsiz = bufsiz;
#ifdef DEBUG
	tell(f);
#endif DEBUG
	return(f);
}

static fbclose(f)
FILE *f;
{
	char *buf = f->_base;
	fclose(f);
	f->_base = f->_ptr = f->_end = 0;
	f->_bufsiz = 0;
	free(buf);
}

preexpand(f,s)
FILE *f;
{
	fseek(f,(long)s,0);
	putc(0,f);
	fflush(f);
	fseek(f,(long)0,0);
}

